commit 48fb00980464c95f69579688c5390cf0560c4f04
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Mar 20 18:11:21 2017 +0100

    pygi-info: initialize GIArgument before passing it to
    g_constant_info_get_value

    Co-Authored-By: Mikhail Fludkov <misha@pexip.com>

    https://bugzilla.gnome.org/show_bug.cgi?id=772949

 gi/pygi-info.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e0c036d84ee66530498ec71e5388eaf23df2eb95
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Mar 20 16:10:12 2017 +0100

    configure.ac: post-release version bump to 3.24.1

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9d76190bc7a256764b1af5ec4bd05ce4a7b6e1d2
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Mar 20 14:28:51 2017 +0100

    release 3.24.0

 NEWS | 3 +++
 1 file changed, 3 insertions(+)

commit bffbb4b1f823de5035e51e013dc6da5a973045aa
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Mar 20 14:23:59 2017 +0100

    configure.ac: pre-release version bump to 3.24.0

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 78defd2ab5f1935a6226336eaa08727e7516fb02
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Mar 13 20:14:37 2017 +0100

    release 3.23.92

 NEWS | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 4ccabfec0cececba935339ea8449ec51b4aeef5e
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Mar 13 20:13:13 2017 +0100

    Version bump to 3.23.92

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ebc245c477c36fa1f65f80d2e75792b82d837611
Author: Fabian Orccon <cfoch.fabian@gmail.com>
Date:   Tue Jan 24 00:00:12 2017 -0500

    overrides: Update for Gdk-4.0 and Gtk+-4.0

    Override Gdk.Color and Gdk.RGBA according version.
    Use properly Gtk.init_check in Gtk+-4.0

    https://bugzilla.gnome.org/show_bug.cgi?id=777680

 gi/overrides/Gdk.py | 74
 ++++++++++++++++++++++++++++-------------------------
 gi/overrides/Gtk.py |  7 +++--
 2 files changed, 44 insertions(+), 37 deletions(-)

commit d005df9645fd5fb2f19bd09384355f45591f1e58
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Jan 23 21:26:05 2017 +0100

    Disable -Werror=missing-prototypes

    https://bugzilla.gnome.org/show_bug.cgi?id=760056
    added some code triggering "missing-prototype" which we by default
    treat as an error. This disables that specific error by default.

    https://bugzilla.gnome.org/show_bug.cgi?id=777534

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6695931a0dfb7d9db9ea14a128108342c3d0be89
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Jan 9 20:44:11 2017 +0100

    Fix new PEP8 errors

    Two new errors popped up:

    * E305 expected 2 blank lines after class or function definition
    * E741 ambiguous variable name

    https://bugzilla.gnome.org/show_bug.cgi?id=776009

 examples/cairo-demo.py             |  1 +
 examples/properties.py             |  1 +
 gi/_option.py                      |  1 +
 gi/overrides/GIMarshallingTests.py |  2 ++
 gi/overrides/GLib.py               | 19 +++++++++++++++++++
 gi/overrides/GObject.py            | 12 ++++++++++++
 gi/overrides/Gdk.py                |  3 +++
 gi/overrides/Gio.py                |  2 ++
 gi/overrides/Gtk.py                | 35
 +++++++++++++++++++++++++++++++++++
 gi/overrides/Pango.py              |  2 ++
 gi/types.py                        |  1 +
 pygtkcompat/pygtkcompat.py         |  1 +
 tests/test_generictreemodel.py     |  1 +
 tests/test_interface.py            |  4 ++++
 tests/test_iochannel.py            |  1 +
 tests/test_overrides_gtk.py        | 10 +++++-----
 tests/test_properties.py           | 12 ++++++------
 tests/test_signal.py               |  1 +
 18 files changed, 98 insertions(+), 11 deletions(-)

commit 3f68e0a352abc12e1990e82e3134c48f0be2b3c9
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Wed Mar 23 17:07:53 2016 +0100

    Move pep8/pyflakes tests from 'make check' to 'make check.quality'

    The current behaviour is problematic because new versions of
    pep8/pyflakes
    add new warnings or get more picky. This makes testing
    hard in case newly added code is developed on an older version
    or when testing old branches/releases.

    This moves the pep8/pyflakes tests to a new "make check.quality"
    command.

    This also removes the SKIP_PEP8 flag which was added in
    25d12afd06863ce
    to speed up make check.

    https://bugzilla.gnome.org/show_bug.cgi?id=764087

 HACKING     |  2 +-
 Makefile.am | 12 +++++-------
 2 files changed, 6 insertions(+), 8 deletions(-)

commit 222f5581c38551bdd5c6c9ca4e895d1f44397ad1
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Fri Oct 21 13:59:54 2016 +0200

    overrides: Update for Gtk-4.0

    Skip things which are gone since 4.0.
    This only fixes importing and doesn't add any tests for now.

    https://bugzilla.gnome.org/show_bug.cgi?id=773315

 gi/overrides/Gtk.py | 482
 ++++++++++++++++++++++++++--------------------------
 1 file changed, 242 insertions(+), 240 deletions(-)

commit 8694e4dd42565f07b6f9ba1221fb03146be333a0
Author: Dan Nicholson <nicholson@endlessm.com>
Date:   Wed Dec 21 12:02:14 2016 -0600

    Handle exception unreffing Variant at exit

    Calling unref will cause gi and gi.repository.GLib to be imported.
    However, if the program is exiting, then these modules have likely
    been
    removed from sys.modules and will raise an exception. Assume
    that's the
    case for ImportError and ignore the exception since everything will be
    cleaned up, anyways.

    This can be triggered with the following trivial program:

    $ python3 -c 'from gi.repository import GLib; v = GLib.Variant("s",
    "foo")'
    Exception ignored in:

    Adding some debug code to show the full exception revealed this:

    Traceback (most recent call last):
      File "/home/dan/src/pygobject/build3/gi/overrides/GLib.py", line
      265, in __del__
        self.unref()
    ImportError: import of 'gi.repository.GLib' halted; None in
    sys.modules

    https://bugzilla.gnome.org/show_bug.cgi?id=776092

 gi/overrides/GLib.py | 11 ++++++++++-
 1 file changed, 10 insertions(+), 1 deletion(-)

commit 54c623ba639654716ca475f75c92cc8ed673d9f5
Author: Dan Nicholson <nicholson@endlessm.com>
Date:   Wed Dec 21 11:50:08 2016 -0600

    Handle multiple deinit of callable cache

    In python3, it seems that the callable cache deinit can be called
    multiple times when the program is exiting. Make that safer by
    clearing
    the various pointers in the structure using g_clear_pointer and
    Py_CLEAR. A subsequent call will skip all the deinit by seeing NULL
    pointers for the members.

    This was causing a critical warning when destroying the arg name hash
    table multiple times with the following trivial program:

    $ python3 -c 'from gi.repository import GLib; v = GLib.Variant("s",
    "foo")'

    (process:32378): GLib-CRITICAL **: g_hash_table_destroy: assertion
    'hash_table != NULL' failed

    (process:32378): GLib-CRITICAL **: g_hash_table_destroy: assertion
    'hash_table != NULL' failed

    https://bugzilla.gnome.org/show_bug.cgi?id=776092

 gi/pygi-cache.c | 15 +++++++--------
 1 file changed, 7 insertions(+), 8 deletions(-)

commit 94226b8eb63dd985def8501168572ee16e02acad
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Sep 19 15:31:57 2016 +0200

    configure.ac: post-release version bump to 3.23.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fb1b8fa8a67f2c7ea7ad4b53076496a8f2b4afdb
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Sep 19 15:27:35 2016 +0200

    release 3.22.0

 NEWS | 3 +++
 1 file changed, 3 insertions(+)

commit b93523fcdb6bc04b42709ecd30b8cd11de80f0c5
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Sep 19 15:24:35 2016 +0200

    configure.ac: pre-release version bump to 3.22.0

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3ec19401dc57263508ee3aa16f5293419c222f5b
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Sep 11 11:45:59 2016 +0200

    release 3.21.92

 NEWS | 7 +++++++
 1 file changed, 7 insertions(+)

commit 7ccc164b6da6d87c0a200ea50314d213470a1f18
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sat Sep 3 20:02:13 2016 +0200

    Handle nullable filename parameters

    Make _pygi_marshal_from_py_filename handle None input
    values. This allows one to pass None to parameters
    annotated as nullable filenames.

    This fixes a test suite error in test_spawn_async_with_pipes
    triggered by an annotation change in glib.

    https://bugzilla.gnome.org/show_bug.cgi?id=770821

 gi/pygi-basictype.c             |  5 +++++
 tests/gimarshallingtestsextra.c | 22 ++++++++++++++++++++++
 tests/gimarshallingtestsextra.h |  3 +++
 tests/test_gi.py                |  4 ++++
 4 files changed, 34 insertions(+)

commit f4d858c069f06e7060a0bb067c29f5bffb7869ee
Author: Aurelien Jarno <aurelien@aurel32.net>
Date:   Wed Aug 31 22:16:06 2016 +0200

    Fix list/hashtable enum <-> hash conversion on 64-bit big endian

    glist and ghashtable objects both store pointers. Complex objects are
    stored as pointers to the objects, but simpler objects like an integer
    value are stored directly as a pointer, using for example the
    GINT_TO_POINTER and GPOINTER_TO_INT macros.

    This is done in pygobject with the _pygi_hash_pointer_to_arg and
    _pygi_arg_to_hash_pointer functions. These functions handle the
    various
    type of objects. However they consider that an enum, represented
    with the
    GI_TYPE_TAG_INTERFACE type (extended interface object), are always a
    pointer. This is wrong as it is often a 32-bit value. Therefore
    on 64-bit
    big endian machines, the value is handle with the 2 32-bit parts
    swapped.

    This patches fixes that by changing the second argument of both
    functions
    from GITypeTag to GITypeInfo. This way the interface can be
    determined,
    and the underlying storage type can also be determined. This currently
    only handles enum and flags, leaving other types as pointers. The
    patch
    also adds two tests in the testsuite, one for each direction.

    https://bugzilla.gnome.org/show_bug.cgi?id=770608

 gi/pygi-argument.c              | 33 +++++++++++++++++++++++++++++----
 gi/pygi-argument.h              |  4 ++--
 gi/pygi-hashtable.c             |  8 ++++----
 gi/pygi-list.c                  |  8 ++++----
 tests/gimarshallingtestsextra.c | 33 +++++++++++++++++++++++++++++++++
 tests/gimarshallingtestsextra.h | 10 ++++++++++
 tests/test_gi.py                | 11 +++++++++++
 7 files changed, 93 insertions(+), 14 deletions(-)

commit 1cb6c470e9d297afda21b73efaccb0b95e519b5d
Author: Lukas K <lu@0x83.eu>
Date:   Fri May 13 21:30:47 2016 +0200

    Allow passing sockets to io_add_watch on win32

    https://bugzilla.gnome.org/show_bug.cgi?id=766396

 gi/overrides/GLib.py | 4 ++++
 1 file changed, 4 insertions(+)

commit 4617c39ca212f0da82af1a9989c912bcdfe1158b
Author: Michael Biebl <biebl@debian.org>
Date:   Sat Sep 3 16:46:40 2016 +0200

    tests: use dbus-run-session instead of dbus-launch to run tests

    The use of dbus-launch is deprecated by dbus upstream.
    See https://lists.debian.org/debian-devel/2016/08/msg00554.html
    for more
    details.

    So use dbus-run-session instead, which was specifically designed to be
    used for such cases, like running test-suites.

    See also https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=836049.

    https://bugzilla.gnome.org/show_bug.cgi?id=770798

 tests/Makefile.am | 7 ++-----
 1 file changed, 2 insertions(+), 5 deletions(-)

commit 4b9185250d73c38231d90b53974d0d2912a02972
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Thu Aug 25 16:57:11 2016 +0200

    configure.ac: post-release version bump to 3.21.92

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2f98ecc4df9e0feaab78ba289956f469e36c7d76
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Thu Aug 25 16:51:39 2016 +0200

    release 3.21.91

 NEWS | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 91abec259ed0c387ab69762ff92142b08327d00a
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Thu Aug 25 16:50:56 2016 +0200

    configure.ac: version bump to 3.21.91

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f65bb1fc8f7f6172970545412fe56ab75f57904b
Author: Mathieu Bridon <bochecha@daitauha.fr>
Date:   Thu Jun 23 22:35:42 2016 +0200

    Allow installing with pip

    This commit adds a setup.py file which just calls the autotools to
    configure/make/make install.

    It is heavily inspired by the similar work from Simon McVittie on
    dbus-python.

    https://bugzilla.gnome.org/show_bug.cgi?id=767988

 .gitignore  |   3 ++
 Makefile.am |   3 +-
 setup.py    | 105
 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 110 insertions(+), 1 deletion(-)

commit 14626ee5dcf380ae94680626607742a8cc048351
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Jun 6 20:08:18 2016 +0200

    Skip a test with older glib

    https://bugzilla.gnome.org/show_bug.cgi?id=740301

 tests/test_docstring.py | 4 ++++
 1 file changed, 4 insertions(+)

commit a12f7027adeb57fe1c0142c86d34d5ec8f6b6d9e
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Jun 6 20:13:29 2016 +0200

    Fix a test with Python 3.1/3.2

    Fix Python version check in
    TestImporter.test_invalid_repository_module_name()
    to avoid failure with Python 3.1 and 3.2.

    Fix provided by Arfrever Frehtes Taifersar Arahesis at
       https://bugzilla.gnome.org/show_bug.cgi?id=740324#c1

    https://bugzilla.gnome.org/show_bug.cgi?id=740324

 tests/test_import_machinery.py | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f5cf74f3b8d285de3591d89c6f3b4b8d59bde35e
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Jun 6 20:45:22 2016 +0200

    tests: Use places kwarg for assertAlmostEqual

    Always pass 'places' argument of TestCase.assertAlmostEqual
    as keyword argument.

    Fix by Arfrever Frehtes Taifersar Arahesis
        https://bugzilla.gnome.org/show_bug.cgi?id=740337#c1

    https://bugzilla.gnome.org/show_bug.cgi?id=740337

 tests/test_properties.py | 6 +++---
 tests/test_signal.py     | 4 ++--
 2 files changed, 5 insertions(+), 5 deletions(-)

commit e0b40099283a31ea23433f9d36dc9beebd4370c9
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Jun 6 11:34:47 2016 +0200

    Print exception if marshalling a signal argument fails

    For example if cairo support is missing a Gtk.Widget::draw call
    will result in
    "TypeError: Couldn't find foreign struct converter for
    'cairo.Context'"

    https://bugzilla.gnome.org/show_bug.cgi?id=748198

 gi/pygi-signal-closure.c | 1 +
 1 file changed, 1 insertion(+)

commit 76e2e30bc586016eba8bcfdd753dc1f4672dced7
Author: Marinus Schraal <mschraal@src.gnome.org>
Date:   Fri May 20 01:26:27 2016 +0200

    overrides: allow treemodel sequence shorthands

    Add get_ and set_ overrides for sequences of GtkTreeModel
    indices. This
    allows an arbitray list of indices to be retrieved or written in
    one go
    from or to a GtkTreeModel row:

    model[0][0, 1] = [True, "Hello"]
    [foo, bar] = model[0][2, 7]

    https://bugzilla.gnome.org/show_bug.cgi?id=766580

 gi/overrides/Gtk.py         | 15 +++++++++++++--
 tests/test_overrides_gtk.py | 46
 +++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 59 insertions(+), 2 deletions(-)

commit ff1a6f0f00e042c5addfa42231ec8927ebf1a1a6
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Tue May 31 19:26:00 2016 +0200

    Remove pygobject-external.h

    It's not used any more

    https://bugzilla.gnome.org/show_bug.cgi?id=767084

 gi/Makefile.am          |  1 -
 gi/pygobject-external.h | 73
 -------------------------------------------------
 2 files changed, 74 deletions(-)

commit f5dd1551371308d33df9627bc8cc0e34fa68a2a8
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Tue May 31 18:47:54 2016 +0200

    Remove pygobject-private.h and rename pygobject.c to
    pygobject-object.c

    Move all the random declarations in pygobject-private.h to their
    respective header files. Rename pygobject.c to pygobject-object.c
    so it's clearer that it's not the implementation of pygobject.h.
    Add a new pygobject-internal.h which includes pygobject.h
    with _INSIDE_PYGOBJECT_ defined like pygobject-private.h did.

    In case you are looking at the git log and end up here due to the
    rename try:

      git log --follow pygobject-object.c

    or on the web interface go to the history of the old file name:

    https://git.gnome.org/browse/pygobject/log/gi/pygobject.c?id=6b702c052e9f26e809cff494f0c896d17a514c64

    https://bugzilla.gnome.org/show_bug.cgi?id=767084

 gi/Makefile.am                         |   7 +-
 gi/gimodule.c                          |  10 +-
 gi/gobjectmodule.c                     |  56 +---------
 gi/gobjectmodule.h                     |  11 ++
 gi/pygboxed.c                          |   4 +-
 gi/pygboxed.h                          |  11 ++
 gi/pygenum.c                           |   4 +-
 gi/pygenum.h                           |  22 ++++
 gi/pygflags.c                          |   4 +-
 gi/pygflags.h                          |  21 ++++
 gi/pygi-argument.c                     |   4 +-
 gi/pygi-basictype.c                    |   2 +-
 gi/pygi-boxed.c                        |   3 +-
 gi/pygi-boxed.h                        |   2 +-
 gi/pygi-cache.c                        |   1 +
 gi/pygi-ccallback.c                    |   1 -
 gi/pygi-enum-marshal.c                 |   3 +-
 gi/pygi-foreign.c                      |   2 +-
 gi/pygi-info.c                         |   2 +-
 gi/pygi-object.c                       |   2 +-
 gi/pygi-property.c                     |   1 +
 gi/pygi-property.h                     |   2 +-
 gi/pygi-signal-closure.h               |   2 +-
 gi/pygi-source.c                       |   3 +-
 gi/pygi-struct-marshal.c               |   3 +
 gi/pygi-struct.c                       |   3 +-
 gi/pygi-struct.h                       |   2 +-
 gi/pygi-type.c                         |   2 +-
 gi/pygi-util.c                         |  42 ++++++++
 gi/pygi-util.h                         |   6 ++
 gi/pygi-value.c                        |   6 +-
 gi/pyginterface.c                      |   3 +-
 gi/pygobject-internal.h                |   7 ++
 gi/{pygobject.c => pygobject-object.c} |  27 ++++-
 gi/pygobject-object.h                  |  56 ++++++++++
 gi/pygobject-private.h                 | 186
 ---------------------------------
 gi/pygparamspec.c                      |   5 +-
 gi/pygpointer.c                        |   3 +-
 gi/pygpointer.h                        |   8 ++
 gi/pygtype.c                           |  27 ++---
 gi/pygtype.h                           |  25 +++++
 41 files changed, 305 insertions(+), 286 deletions(-)

commit ef7a6dad8cea6a3b9547cfae00bf15ebb9eb756e
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Tue May 31 15:44:36 2016 +0200

    Merge pyglib-private.h into pyglib.h

    No need for another header

    https://bugzilla.gnome.org/show_bug.cgi?id=767084

 gi/Makefile.am        |  1 -
 gi/gimodule.c         |  2 +-
 gi/glibmodule.c       |  1 -
 gi/pygi-resulttuple.c |  2 +-
 gi/pygi-source.c      |  1 -
 gi/pyglib-private.h   | 40 ----------------------------------------
 gi/pyglib.c           |  1 -
 gi/pyglib.h           |  6 ++++++
 gi/pygoptioncontext.c |  1 -
 gi/pygoptiongroup.c   |  1 -
 gi/pygspawn.c         |  1 -
 11 files changed, 8 insertions(+), 49 deletions(-)

commit e1e05fb027c328ef41be0ba6d99883d2d7983f70
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Tue May 31 15:31:38 2016 +0200

    Remove pygi.h and pygi-private.h

    Instead include things where needed.

    https://bugzilla.gnome.org/show_bug.cgi?id=767084

 gi/Makefile.am                     |  3 +-
 gi/gimodule.c                      | 11 ++++-
 gi/pygboxed.c                      |  1 -
 gi/pygenum.c                       |  2 +-
 gi/pygflags.c                      |  4 +-
 gi/pygi-argument.c                 | 17 ++++++--
 gi/pygi-array.c                    |  3 +-
 gi/pygi-basictype.c                |  2 +-
 gi/pygi-boxed.c                    |  3 +-
 gi/pygi-boxed.h                    |  8 ++++
 gi/pygi-cache.c                    |  2 +
 gi/pygi-ccallback.c                |  2 +-
 gi/pygi-ccallback.h                | 11 +++++
 gi/pygi-closure.c                  |  5 ++-
 gi/pygi-enum-marshal.c             |  3 +-
 gi/pygi-error.c                    |  2 +-
 gi/pygi-hashtable.c                |  2 +-
 gi/pygi-info.c                     |  6 ++-
 gi/pygi-info.h                     | 22 ++++++++++
 gi/pygi-invoke.c                   |  5 +++
 gi/pygi-invoke.h                   |  2 +-
 gi/pygi-list.c                     |  2 +-
 gi/pygi-marshal-cleanup.c          |  8 ++--
 gi/pygi-marshal-cleanup.h          |  4 +-
 gi/pygi-object.c                   |  2 +-
 gi/pygi-property.c                 |  3 +-
 gi/pygi-property.h                 |  2 +-
 gi/pygi-repository.c               |  3 +-
 gi/pygi-repository.h               |  6 +++
 gi/pygi-signal-closure.c           |  4 +-
 gi/pygi-signal-closure.h           |  3 +-
 gi/pygi-source.c                   |  4 +-
 gi/pygi-struct-marshal.c           |  6 ++-
 gi/pygi-struct.c                   |  5 ++-
 gi/pygi-struct.h                   |  6 +++
 gi/pygi-type.c                     |  3 +-
 gi/{pygi-private.h => pygi-util.h} | 47 ++--------------------
 gi/pygi.h                          | 82
 --------------------------------------
 gi/pygobject.c                     |  3 +-
 gi/pygpointer.c                    |  1 -
 40 files changed, 146 insertions(+), 164 deletions(-)

commit c86424c73725610ac2ef832c1fa41a777f9a5efa
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Apr 24 21:27:59 2016 -0700

    configure.ac: post-release version bump to 3.21.1

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit febd211b6628a8f63d92ae011d68b845e9fe6ec8
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Apr 24 21:19:39 2016 -0700

    release 3.21.0

 NEWS | 7 +++++++
 1 file changed, 7 insertions(+)

commit 1bb267f1755b2ec314c751b27931cbe7032f3c36
Author: Dustin Falgout <dustin@falgout.us>
Date:   Sun Mar 20 03:21:02 2016 -0500

    gi: Add require_versions() function

    Adds a new function that accepts a dict of one or more namespace,
    version
    pairs through which it iterates and calls `gi.require_version()`
    for each pair. Also adds a test for the new function.

    https://bugzilla.gnome.org/show_bug.cgi?id=761141

 gi/__init__.py                 | 33 +++++++++++++++++++++++++++++++++
 tests/test_import_machinery.py |  6 ++++++
 2 files changed, 39 insertions(+)

commit b3f897b98c5a2c59ea34a8afcce0448b1ffb0731
Author: Iain Lane <iain@orangesquash.org.uk>
Date:   Thu Mar 24 18:04:40 2016 +0000

    test_gerror_novalue: Don't assign the error to a variable

    Otherwise the build fails with:

      CHECK  Pyflakes examples gi tests pygtkcompat
      tests/test_gobject.py:689: local variable 'error' is assigned to
      but never used

    https://bugzilla.gnome.org/show_bug.cgi?id=764165

 tests/test_gobject.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6ff29c91dfdbcc3203405da0aca8dbfa318d8b32
Author: Emmanuele Bassi <ebassi@gnome.org>
Date:   Wed Mar 23 13:59:53 2016 +0000

    build: Do not enable code coverage based on lcov

    Code coverage turns on various slow paths and disables
    optimizations. It
    should be, and it usually is, an opt in configuration flag.

    Enabling it should not be conditional on the existence of the lcov
    binary on the system, otherwise anybody building PyGObject from Git on
    any moderately complete development environment will automatically
    enable code coverage even when not wanted.

    https://bugzilla.gnome.org/show_bug.cgi?id=764075

 autogen.sh | 10 +---------
 1 file changed, 1 insertion(+), 9 deletions(-)

commit c2a66daf3ac62e3e97f8d7fe16afccf37f413305
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 21 21:00:37 2016 -0700

    configure.ac: post-release version bump to 3.21.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ce3034544f126f196cad57485f126f1246cd1acf
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 21 20:34:50 2016 -0700

    release 3.20.0

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit eee366401383f92a2b2b233b2cd0db2ad50b6cb2
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 21 20:33:13 2016 -0700

    configure.ac: pre-release version bump to 3.20.0

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f4401234cdc9be784eea9347fec349e7cba0a153
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Mar 15 22:56:10 2016 -0700

    release 3.19.92

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit 3d8860c2d0a95cff38f7eaa65c38521654a162ae
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Mar 1 22:10:21 2016 -0800

    post-release version bump to 3.19.92

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a4865ef2f8c70b93f84f93236786c65ad5f973af
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Mar 1 21:46:21 2016 -0800

    release 3.19.91

 NEWS | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit cc75f994a07639b9ffcc6afef757768780a076de
Author: Thibault Saunier <tsaunier@gnome.org>
Date:   Fri Feb 5 15:00:10 2016 +0100

    tests: check passing Boxed type in GValue as function parameters

    https://bugzilla.gnome.org/show_bug.cgi?id=761592

 tests/Makefile.am               | 13 +++++++++++--
 tests/gimarshallingtestsextra.c | 37
 +++++++++++++++++++++++++++++++++++++
 tests/gimarshallingtestsextra.h | 26 ++++++++++++++++++++++++++
 tests/test_error.py             |  6 ++++++
 4 files changed, 80 insertions(+), 2 deletions(-)

commit 5f4b08f4e8a98046eab71537c7827edde2ca8742
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Feb 29 22:50:32 2016 -0800

    gerror: Add special case marshaling for boxing GErrors

    Transfer gtype from introspection GError class to Python GError
    implementation.
    Expose the PyGError pointer as an extern so other C files can pick
    this up.
    Add custom to/from GValue marshalers for GError.
    Add tests for both complete and incomplete (no boxed pointer held).

    https://bugzilla.gnome.org/show_bug.cgi?id=761592

 gi/overrides/GLib.py  |  1 +
 gi/pygi-error.c       | 32 +++++++++++++++++++++++++++++++-
 gi/pygi-error.h       |  2 ++
 gi/pygi-value.c       |  1 +
 tests/test_gobject.py | 17 +++++++++++++++++
 5 files changed, 52 insertions(+), 1 deletion(-)

commit cfca1457c39e3c4c7ef97e7b46a73c19e5adf305
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Feb 28 01:39:31 2016 -0800

    gerror: Add support for marshaling GError from Python to C

    Refactor pygi_gerror_exception_check() to use a new broken out
    function
    pygi_error_marshal_from_py(). This allows re-use for argument
    marshaling
    of a Python GError to a C GError.
    Remove PYGI_META_ARG_TYPE_CHILD setting for GError out argument
    marshaling.
    This was incorrect since GError exception arguments are not specified
    explicitly and instead uses the "throws" option.

    https://bugzilla.gnome.org/show_bug.cgi?id=685197

 gi/pygi-error.c              | 132
 +++++++++++++++++++++++++++++--------------
 gi/pygi-error.h              |   3 +
 tests/test_overrides_glib.py |  30 ++++++++++
 3 files changed, 123 insertions(+), 42 deletions(-)

commit 2fc1a689a81614649d042965997f4546b0a58ada
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Feb 27 17:21:53 2016 -0800

    gerror: Add "_to_py" suffix to pygi_error_marshal

    This will allow for the a pygi_error_marshal_from_py function.

    https://bugzilla.gnome.org/show_bug.cgi?id=685197

 gi/pygi-error.c | 8 ++++----
 gi/pygi-error.h | 2 +-
 2 files changed, 5 insertions(+), 5 deletions(-)

commit 7e29227b6f58cfcc96118a4af83658ca1a6fa1f4
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sat Jul 4 22:09:46 2015 +0200

    Some error handling/reporting fixes.

    * Check in pyg_boxed_new() if the passed type is an actual subclass
    * Don't replace existing exceptions in pyg_value_as_pyobject()
    * Print an error in pyg_closure_marshal() in case marshalling
      an argument failed.

    https://bugzilla.gnome.org/show_bug.cgi?id=751956

 gi/pygboxed.c   |  8 +++++++-
 gi/pygi-value.c | 15 ++++++++++-----
 gi/pygtype.c    | 11 ++++++++++-
 3 files changed, 27 insertions(+), 7 deletions(-)

commit 49880800b35029de3731523eede1b3174f10c1db
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sat Jul 4 21:40:04 2015 +0200

    GVariant: Don't use pyg_boxed_new as GVariant isn't a PyGBoxed but
    a PyGIStruct.

    This only worked because they share the same struct layout.
    This adds a new constructor for creating a new PyGIStruct instance
    from GType.

    https://bugzilla.gnome.org/show_bug.cgi?id=751956

 gi/pygi-struct.c | 32 ++++++++++++++++++++++++++++++++
 gi/pygi-struct.h |  5 +++++
 gi/pygi-value.c  |  3 ++-
 3 files changed, 39 insertions(+), 1 deletion(-)

commit f27b1976ea325fcd55359888401dd08ac8fb074a
Author: Mikhail Fludkov <misha@pexip.com>
Date:   Tue Sep 1 17:54:17 2015 +0200

    pygi-value: special case for NULL GValueArray

    Don't segfault when dealing with GValue of GValueArray type containing
    NULL. Return empty list in this case.

    https://bugzilla.gnome.org/show_bug.cgi?id=754359

 gi/pygi-value.c       | 5 +++--
 tests/test_gobject.py | 6 ++++++
 2 files changed, 9 insertions(+), 2 deletions(-)

commit c8176dfabea694ce738ff4633e7522b0d1fc1c51
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Feb 20 20:42:40 2016 -0800

    post-release version bump to 3.19.91

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d16ae38f0a12653557bdeba17eb155144d91bff4
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Feb 20 19:56:24 2016 -0800

    release 3.19.90

 NEWS | 9 +++++++++
 1 file changed, 9 insertions(+)

commit 0190fb84fc1f88ba4c0623bf1b29fe3ca4f80932
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Feb 20 19:49:31 2016 -0800

    pre-release version bump to 3.19.90

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0467808b97f89c5a36c01f5b7cba013acaef6851
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Feb 20 19:40:45 2016 -0800

    tests: Set the active style context state before retrieving values

    compat_test_pygtk.TestGTKCompat.test_style() was giving a warning due
    to set/get state mismatch. Set the current state before getting values
    from the context.

 tests/compat_test_pygtk.py | 1 +
 1 file changed, 1 insertion(+)

commit 8145fa69c8ace9772687f26f782acb5e461776be
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Feb 20 17:32:01 2016 -0800

    tests: Fix crash with empty drag source icon names

    Add "_About" argument when testing call to
    drag_source_set_icon_name().
    Add Gtk.STOCK_ABOUT argument when testing call to
    drag_source_set_icon_stock().
    This avoids crashes due to GTK+ drag source attempting to unref a
    NULL pointer.

    https://bugzilla.gnome.org/show_bug.cgi?id=762392

 tests/test_overrides_gtk.py | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 6a26d3f2b25b3fbbd87def14f1df17b96ed23a0d
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Oct 4 11:18:04 2015 +0200

    Try to import GdkX11 in Gdk overrides

    pygobject will not provide GdkX11 instances until the namespace
    is loaded so try to load it in the overrides.

    This makes Gdk.Display.get_default() return a GdkX11.X11Display
    instead of a dummy Gdk.Display subclass instance.

    https://bugzilla.gnome.org/show_bug.cgi?id=673396

 gi/overrides/Gdk.py | 11 ++++++++++-
 1 file changed, 10 insertions(+), 1 deletion(-)

commit 12022437d663f49ba3a2a2f884da30dd5ca08ff6
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Fri Oct 30 13:07:57 2015 +0100

    Fix import warnings pointing to the wrong code with CPython 3.3/3.5

    For making warnings point to the code doing the import, the stack
    frames
    of the import system need to be skipped. The frame count number
    varries
    between CPython versions and in 3.5 all frames of the import
    system are
    skipped for warnings (https://bugs.python.org/issue24305).

    This hardcodes the frame counts for all supported CPython versions
    which fixes the import warning output for CPython 3.3 and 3.5.

    This also fixes/works around a bug in CPython 3 where if a too
    large stacklevel value was passed to warn(), CPython would try to
    interpret a file called "sys" in the same directory of the
    executed script (https://bugs.python.org/issue25493
    and https://bugzilla.gnome.org/show_bug.cgi?id=757184).

    https://bugzilla.gnome.org/show_bug.cgi?id=757184

 gi/importer.py                 | 28 +++++++++++++++++++++++-----
 tests/test_import_machinery.py |  4 ++++
 2 files changed, 27 insertions(+), 5 deletions(-)

commit 72ab17963e81fb63f7238123c359be8d83a529f4
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Oct 25 11:39:22 2015 +0100

    Bump automake version to 1.12.6

    Required to a get a new enough py-compile which supports
    the __pycache__ directories for newer Python 3 versions.
    See https://debbugs.gnu.org/cgi/bugreport.cgi?bug=8847

    Also remove m4/py-compile which doesn't seem to get used in
    either 1.11 or 1.15 here.

    https://bugzilla.gnome.org/show_bug.cgi?id=757086

 configure.ac  |   4 +-
 m4/py-compile | 161
 ----------------------------------------------------------
 2 files changed, 3 insertions(+), 162 deletions(-)

commit b71f76af163c1d43b9f11e6a6362e7510d84c231
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 31 14:55:46 2015 -0700

    post-release version bump to 3.19.3

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bedc7b883febceb3470f1b8e909cfab696d1fc5f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 31 14:47:07 2015 -0700

    release 3.19.2

 NEWS | 7 +++++++
 1 file changed, 7 insertions(+)

commit 4164e7088be446fcab65cef642c6853aad3b6a69
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 31 14:06:40 2015 -0700

    tests: Fix failure due to new GTK+ warning regarding size_allocate()

    Call get_preferred_size() to avoid size_allocated() warning in
    size-allocated signal handler test.

 tests/test_overrides_gtk.py | 1 +
 1 file changed, 1 insertion(+)

commit a8293f411234180d70e9ff979954b28381842e1f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 31 14:03:21 2015 -0700

    Fix build warnings regarding _POSIX_C_SOURCE redefinition

    Move Python.h includes above glib includes to avoid build
    warnings with Python 2 as noted here:
    https://docs.python.org/2/c-api/intro.html#include-files

 gi/gobjectmodule.c       | 1 +
 gi/pygi-array.c          | 2 +-
 gi/pygi-cache.c          | 2 +-
 gi/pygi-enum-marshal.c   | 2 +-
 gi/pygi-hashtable.c      | 1 +
 gi/pygi-hashtable.h      | 2 +-
 gi/pygi-list.c           | 1 +
 gi/pygi-object.c         | 2 +-
 gi/pygi-struct-marshal.c | 2 +-
 gi/pygi-value.c          | 1 +
 10 files changed, 10 insertions(+), 6 deletions(-)

commit 3b1d130174951f7648beceac270daa8ac65939c7
Author: Matthias Clasen <mclasen@redhat.com>
Date:   Fri Oct 30 12:15:26 2015 -0400

    Drop -std=c90 for now

    glib headers have a problem with it, and sorting it out on the
    glib side will take a while, so drop this for now.

 configure.ac | 9 ---------
 1 file changed, 9 deletions(-)

commit ef219cc74a7c6803795692664fc3b2c8ebbb4fe4
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Fri Oct 30 16:23:11 2015 +0100

    configure.ac: post release version bump to 3.19.2

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 98a4bfe4606bd2c7534533633a20a998f732e248
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Fri Oct 30 16:13:46 2015 +0100

    release 3.19.1

 NEWS | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

commit 175d10665472e6f4090d707e3b89255814c932b1
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Jun 8 18:14:08 2015 +0200

    Use a named tuple for returning multiple values

    >>> v = Gtk.Button().get_alignment()
    >>> v
    (xalign=0.5, yalign=0.5)
    >>> v.xalign
    0.5

    For each GICallable a new gi._gi.ResultTuple subclass
    is created which knows the return value names of that
    callable and displays them in __repr__, __dir__ and
    allows to access tuple items by name.

    The subclass is cached in PyGICallableCache.

    To reduce the number of small tuple allocations use a free list
    similar to the one used for pure tuples in CPython.

    https://bugzilla.gnome.org/show_bug.cgi?id=727374

 gi/Makefile.am            |   2 +
 gi/gimodule.c             |   1 +
 gi/pygi-cache.c           |  34 +++++
 gi/pygi-cache.h           |   6 +
 gi/pygi-invoke.c          |  35 ++---
 gi/pygi-private.h         |   1 +
 gi/pygi-resulttuple.c     | 354
 ++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-resulttuple.h     |  34 +++++
 gi/pyglib-python-compat.h |   5 +
 tests/Makefile.am         |   1 +
 tests/test_resulttuple.py |  87 ++++++++++++
 11 files changed, 543 insertions(+), 17 deletions(-)

commit b1788c9a445c8a820121c42260bcbdbc3ae8dfba
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Oct 26 11:17:34 2015 +0100

    enum/flags: use gir info for type names and __repr__ instead of the
    gtype name

    For example __name__ is now SpawnFlags instead of PyGLibSpawnFlags
    and __repr__ shows GLib.SpawnFlags in stead of PyGLibSpawnFlags.

    https://bugzilla.gnome.org/show_bug.cgi?id=657915

 gi/gimodule.c               | 35 ++++++++++++++++++++++++----
 gi/pygenum.c                | 57
 +++++++++++++++++++++++++++++++--------------
 gi/pygflags.c               | 31 +++++++++++++++++++-----
 tests/test_gi.py            | 41 ++++++++++++++++++++++++++++++++
 tests/test_overrides_gdk.py |  6 ++---
 5 files changed, 139 insertions(+), 31 deletions(-)

commit 6b702c052e9f26e809cff494f0c896d17a514c64
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Wed Jun 10 18:24:44 2015 +0200

    Improve and unify __repr__ format for PyGObject, PyGBoxed and
    PyGIStruct

    Includes the module, Python type name, pointer and wrapper pointer
    and GType name. e.g.
    "<Gtk.Border object at 0x7f26bee9e4c8 (GtkBorder at 0x1c72e30)>"

    In case of PyGObjects created from GType set the module to __gi__
    instead of guessing the old static binding name. Also
    remove the code that tries to add them to the guessed static bindings
    module while at it. The __repr__ will now return
    "<__gi__.X11Keymap ..." instead of "<gtk.gdk.X11Keymap ..."

    https://bugzilla.gnome.org/show_bug.cgi?id=657915

 gi/pygboxed.c    | 31 +++++++++++++++++++++----
 gi/pygi-struct.c | 23 ++++++++++++++++++
 gi/pygobject.c   | 71
 +++++++++++++++++++++++++-------------------------------
 tests/test_gi.py | 33 ++++++++++++++++++++++++++
 4 files changed, 113 insertions(+), 45 deletions(-)

commit 9b821aa0d60857e612cde9dabe9c8f9f9c60214c
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Oct 4 11:13:37 2015 +0200

    Don't leak internal RepositoryError on import.

    In case a dependency of the imported namespace has a version
    conflict with an already loaded version, import would raise
    RepositoryError.

    This fixes it to raise an ImportError instead.

    https://bugzilla.gnome.org/show_bug.cgi?id=756033

 gi/importer.py | 7 +++++--
 gi/module.py   | 4 ++++
 2 files changed, 9 insertions(+), 2 deletions(-)

commit dba1da9b0770c7dec1abd82303b9b4266fe2ce3f
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Oct 4 10:13:35 2015 +0200

    Import dependencies when importing typelibs from gi.repository

    Recursively import a modules dependencies when importing from
    gi.repository.

    This fixes the case where a library depends on initialization
    code of dependency overrides. For example libwnck expects
    gdk_init to be called before using its API and gdk_init
    gets called in the Gdk overrrides.

    https://bugzilla.gnome.org/show_bug.cgi?id=656314

 gi/importer.py                 | 12 +++++++++++-
 gi/pygi-repository.c           | 35 +++++++++++++++++++++++++++++++++++
 tests/test_import_machinery.py | 13 +++++++++++++
 tests/test_repository.py       | 10 ++++++++++
 4 files changed, 69 insertions(+), 1 deletion(-)

commit dfa3a85290dd97ecd7cbe8f12fbc1ff2db5a1155
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Oct 11 01:28:48 2015 +0200

    Fix Gdk.rectangle_intersect/rectangle_union missing with GTK+ 3.18

    3.18 added a Gdk.Rectangle type which changed these functions
    to methods in the gir.

    Fix by providing aliases in the Gdk overrides.

    https://bugzilla.gnome.org/show_bug.cgi?id=756364

 gi/overrides/Gdk.py         | 8 ++++++++
 tests/test_overrides_gdk.py | 9 +++++++++
 2 files changed, 17 insertions(+)

commit 98726caff183491cde1e145861adfcff0c243d9b
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Oct 4 09:53:27 2015 +0200

    Don't import inspect at module level

    Move it to the only user instead as importing inspect
    takes 10msec here.

 gi/_signalhelper.py | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit e1921b7224ca1e909d9fe5483a09414742d0baf4
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sat Sep 26 21:29:54 2015 +0200

    invoke state: add a free memory cache for PyGIInvokeArgState

    Keep one free allocation per argument count around
    to reduce g_slice_alloc/free usage.

    Reduces CPU time for simple functions by 10% and 5% for closures.

    https://bugzilla.gnome.org/show_bug.cgi?id=750658

 gi/pygi-closure.c |  6 ++----
 gi/pygi-invoke.c  | 61
 +++++++++++++++++++++++++++++++++++++++++++++++++------
 gi/pygi-invoke.h  |  4 ++++
 3 files changed, 61 insertions(+), 10 deletions(-)

commit f72b6434de82ffa1950ff45a4daf80c84f58eca6
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sat Sep 26 21:25:38 2015 +0200

    invoke/closure: reduce g_slice_alloc usage

    Instead of allocating multiple arrays, combine argument
    data in a new PyGIInvokeArgState and allocate it in one go.

    This reduces CPU time by 20% for simple functions and by 15%
    for closures.

    https://bugzilla.gnome.org/show_bug.cgi?id=750658

 gi/pygi-array.c               |  6 +--
 gi/pygi-closure.c             | 99
 +++++++++++++++++++------------------------
 gi/pygi-invoke-state-struct.h | 34 +++++++++------
 gi/pygi-invoke.c              | 50 +++++++---------------
 gi/pygi-marshal-cleanup.c     | 10 ++---
 5 files changed, 86 insertions(+), 113 deletions(-)

commit 640221c099031a55cbc32f5cdac3e6e018256fff
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Sep 27 11:19:14 2015 +0200

    pep8: ignore new errors reported by pep8 1.6

    Makes sure we get the same result for older and newer pep8.
    Once 1.6 is more common, the ignored errors could be added back
    and fixed (E402 might be impossible, see bug 755620)

 Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5fcc0b49e5988bfb6893bd56dd25a6257cd9720d
Author: Garrett Regier <garrett.regier@riftio.com>
Date:   Tue Sep 22 14:57:13 2015 -0700

    Bump g-i dependency to latest stable

    This is required for throwing exceptions in closures.

 README       | 2 +-
 configure.ac | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 0acbf6ad543a928ce75fc6d6839d3e6aa2e9a3d3
Author: Garrett Regier <garrett.regier@riftio.com>
Date:   Tue Jun 9 07:11:51 2015 -0700

    Avoid calling g_slist_length() during invoke

    We already know the number of Python args.

 gi/pygi-invoke.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 216e94cff0bbe5436efe423b197c9cfc4a00a02d
Author: Garrett Regier <garrett.regier@riftio.com>
Date:   Wed Jun 3 08:14:08 2015 -0700

    Simplify closure_convert_arguments()

    This chunk of work should really be done
    in convert_ffi_arguments().

 gi/pygi-closure.c | 65
 +++++++++++++++++++++++++------------------------------
 1 file changed, 29 insertions(+), 36 deletions(-)

commit 7f7d0c52c9b364ba0ec92c9415298c26b103a077
Author: Garrett Regier <garrett.regier@riftio.com>
Date:   Wed Jun 3 08:09:31 2015 -0700

    Remove a level of indentation in convert_ffi_arguments()

 gi/pygi-closure.c | 138
 ++++++++++++++++++++++++++----------------------------
 1 file changed, 67 insertions(+), 71 deletions(-)

commit 3066f3a88103f02c7e22db22efbeb501f4e30d32
Author: Garrett Regier <garrett.regier@riftio.com>
Date:   Wed Jun 3 07:50:37 2015 -0700

    Prevent passing the user data multiple times to callbacks

    This can happen when a callback has multiple gpointers.
    Also, store the closure index as it is hopefully more reliable
    than guessing.

    https://bugzilla.gnome.org/show_bug.cgi?id=750347

 gi/pygi-cache.c   | 24 ++++++++++++++++++++++++
 gi/pygi-cache.h   |  3 +++
 gi/pygi-closure.c |  8 ++------
 3 files changed, 29 insertions(+), 6 deletions(-)

commit 40bba555c835cf53d6aa2645329631e6abe57e6c
Author: Garrett Regier <garrett.regier@riftio.com>
Date:   Wed Jun 3 07:06:40 2015 -0700

    Support throwing exceptions in closures

    This allows exceptions raised in vfunc implemntations
    and callbacks to be turned into GErrors.

    NOTE: this requires matchs in
    https://bugzilla.gnome.org/show_bug.cgi?id=729543
    thus we must bump the GI req once they are commited.

    https://bugzilla.gnome.org/show_bug.cgi?id=710671

 gi/pygi-closure.c   | 113
 ++++++++++++++++++++++++++++++----------------------
 tests/test_error.py |  22 ++++++++++
 2 files changed, 88 insertions(+), 47 deletions(-)

commit ea75a89a7d2bdabc7a29f7f20f792211765f2ac7
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Sep 6 05:35:03 2015 +0200

    Don't emit require_version warning if namespace was loaded previously
    using g_irepository_require

    Instead of tracking loaded dependencies ourself to hide warnings
    if they
    were loaded by a previous import just look if the namespace was loaded
    before the import. This (a) makes the implementation much simpler and
    (b) also takes into account namespaces loaded outside of
    Python/PyGObject
    using the libgirepository C API (as is common in applications using
    libpeas with Python plugins)

    This also introduces a new Python wrapper for
    g_irepository_is_registered()
    to allow checking the loading state of namespaces before imports.

    This fixes unnecessary require_version warnings in gedit,
    gnome-builder,
    totem, rhythmbox etc.

    https://bugzilla.gnome.org/show_bug.cgi?id=754491

 gi/importer.py                 | 93
 +++++++++++-------------------------------
 gi/pygi-repository.c           | 19 +++++++++
 tests/test_import_machinery.py |  9 ----
 tests/test_repository.py       | 11 +++++
 4 files changed, 54 insertions(+), 78 deletions(-)

commit 65726314de2833ce0364a3f3e23f344d122b342f
Author: Garrett Regier <garrett.regier@riftio.com>
Date:   Tue Sep 22 00:17:00 2015 -0700

    configure.ac: post release version bump to 3.19.1

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit ea5ecca4916569b1eca6296ff1a8905e42c3c38a
Author: Garrett Regier <garrettregier@gmail.com>
Date:   Tue Sep 22 00:10:35 2015 -0700

    Release 3.18.0

 NEWS         | 2 ++
 configure.ac | 4 ++--
 2 files changed, 4 insertions(+), 2 deletions(-)

commit e2b8ba0584d1a3273dfa2fcb23616d1dc68fdb8e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Aug 19 21:04:37 2015 -0700

    configure.ac: post-release version bump to 3.17.91

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6392b2727e7ed391683bebbf69fbc8b474e99a5f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Aug 19 21:02:44 2015 -0700

    release 3.17.90

 NEWS | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

commit 1da98892cf505b35ce0280db22e1e8ba31c095e0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Aug 19 20:57:37 2015 -0700

    configure.ac: pre-release version bump to 3.17.90

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 79d23e9accd331d954007dcae6b6b7fa2837cfa7
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Wed Feb 18 19:30:30 2015 +0100

    Allow passing unicode lists to GStrv properties on Python 2

    https://bugzilla.gnome.org/show_bug.cgi?id=744745

 gi/pygi-value.c          | 41 ++++++++++++++++++++++++++++++++---------
 tests/test_properties.py |  8 +++++++-
 2 files changed, 39 insertions(+), 10 deletions(-)

commit 8aa3d5935b4541be6e76e8792e58bb301fa4f7d1
Author: Rui Matos <tiagomatos@gmail.com>
Date:   Thu May 21 17:53:17 2015 +0200

    Avoid a silent long to int truncation

    If the python object contains a value bigger than MAXUINT we'd
    silently truncate it when assigning to 'val' and the if condition
    would always be true.

    This was caught by a coverity scan.

    https://bugzilla.gnome.org/show_bug.cgi?id=749698

 gi/pygi-value.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 5af6c722e5b7db90a3ca0832c46efe0c9142a0d1
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Jul 5 11:58:50 2015 +0200

    tests: add a test for test_glist_gtype_container_in()

    https://bugzilla.gnome.org/show_bug.cgi?id=749696

 tests/test_everything.py | 6 ++++++
 1 file changed, 6 insertions(+)

commit f69ce9f5f6cd81b057ed0006d1fe7f71fa294943
Author: Mathieu Bridon <bochecha@daitauha.fr>
Date:   Sun Jul 5 11:07:00 2015 +0200

    Handle gtype marshalling

    https://bugzilla.gnome.org/show_bug.cgi?id=749696

 gi/pygi-argument.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 0ee1f562c975df51ce93578d35678ef1e915e202
Author: Daniel Hahler <git@thequod.de>
Date:   Wed Mar 25 14:37:29 2015 +0100

    pygi-foreign-cairo.c: fix include for py3cairo.h

    The pkg-config info includes the "pycairo" folder already.

    https://bugzilla.gnome.org/show_bug.cgi?id=746742

 gi/pygi-foreign-cairo.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fea15145c2a3e6aac73350241a982a095e16c7d8
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Thu Jun 18 13:36:52 2015 +0200

    tests: Silence various error messages and warnings.

    This silences glib warnings which are due to testing
    of error handling, deprecation warnings which we ignore
    since we want to continue testing deprecated code and
    other error output of code which is supposed to fail.

    To reduce code duplication and make things easier
    this introduces a shared helper module containing
    various context managers and decorators which allow
    testing and silencing of warnings and errors.

    https://bugzilla.gnome.org/show_bug.cgi?id=751156

 tests/Makefile.am           |   1 +
 tests/compat_test_pygtk.py  |  27 +++------
 tests/compathelper.py       |   8 +++
 tests/helper.py             | 132
 ++++++++++++++++++++++++++++++++++++++++++++
 tests/test_everything.py    |  28 ++++++----
 tests/test_gi.py            |   6 +-
 tests/test_gio.py           |   3 +
 tests/test_iochannel.py     |  20 +++----
 tests/test_overrides_gdk.py |  18 +++---
 tests/test_overrides_gtk.py |  20 +++----
 tests/test_properties.py    |  21 +++----
 tests/test_repository.py    |  13 ++---
 tests/test_signal.py        |  24 +++-----
 tests/test_source.py        |   8 +--
 14 files changed, 231 insertions(+), 98 deletions(-)

commit 619777730891b42b98da556c3aa9ca5a1b3f617b
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Thu Jun 18 13:30:03 2015 +0200

    Fix gcc warning regarding uninitialized use of variable

    https://bugzilla.gnome.org/show_bug.cgi?id=751156

 gi/pygobject.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 1ed8200abefc3e51e4d2083b1372695aaf4163fb
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sun Jun 21 23:55:02 2015 +0200

    Fix test regression when xdg-user-dirs is not installed.

    GLib.get_user_special_dir is only guaranteed to always return
    a path in case GLib.UserDirectory.DIRECTORY_DESKTOP is passed.
    This was unintentionally changed to DIRECTORY_MUSIC
    in 9948a67e677c8a351f2de1708.

    https://bugzilla.gnome.org/show_bug.cgi?id=751299

 tests/test_glib.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 79cf1f70d247b5a4d33d1e60107e47903ca76055
Author: Garrett Regier <garrett.regier@riftio.com>
Date:   Mon May 18 02:32:18 2015 -0700

    Explicitly check if an override exists instead of ImportError

    If an override depended on another module and it did not
    exist then the raised ImportError was consumed and assumed
    to mean that the override did not exist. This makes it
    difficult to diagnose issues with overrides.

    This uses pkgutil.get_loader() as it is the easier way to
    determine if a module exists in both Python 2 and 3
    and avoid deprecated functions.

    https://bugzilla.gnome.org/show_bug.cgi?id=749532

 gi/overrides/__init__.py | 17 +++++++++++++++--
 1 file changed, 15 insertions(+), 2 deletions(-)

commit d2faa619f5e204b75315a42fec99dd48fe7fb31c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jun 15 01:24:16 2015 -0700

    configure.ac: post-release version bump to 3.17.2

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6fa54fe868d0e2a9a9d4dc300a61cbfa079681a8
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jun 15 01:20:47 2015 -0700

    release 3.17.1

 NEWS | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 2048dc8d1d708abce7037f96483c6d776567d6b5
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Mon Mar 2 20:58:04 2015 +0100

    Add gi.PyGIWarning and use it instead of PyGIDeprecationWarning in
    case the version to import wasn't specified.

    This makes the warning visible by default.
    See commit ef3bff4e570363e4f383d4cdae9cecd4073b03d8 for more info
    on the warning.

    https://bugzilla.gnome.org/show_bug.cgi?id=727379

 gi/__init__.py   |  2 ++
 gi/gimodule.c    |  6 ++++++
 gi/importer.py   |  3 ++-
 tests/test_gi.py | 15 +++++++++++++++
 4 files changed, 25 insertions(+), 1 deletion(-)

commit 7a3bb6971f22accd25e987496d377e1879f6e1ba
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Sat May 30 17:46:54 2015 +0200

    Remove Gdk.Rectangle alias with newer gobject-introspection and GTK+

    The new GdkRectangle in the typelib confuses the marshalling code
    as PyGObject uses the Python class from the overrides for marshalling
    to Python but uses the gtype from the typelib to do
    type checking when marshalling from Python.

    https://bugzilla.gnome.org/show_bug.cgi?id=749625

 gi/overrides/Gdk.py | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit 64be2069d39b4d2767eb1efd47bb3f268ad7fb0d
Author: Christoph Reiter <creiter@src.gnome.org>
Date:   Thu Apr 23 22:03:54 2015 +0200

    overrides: Provide _overrides_module attribute to make gst-python
    overrides work again.

    gi_gst_fraction_from_value () in gst-python's gstmodule.c tries
    to access
    the Gst.Fraction class through
    gi.repository.Gst._overrides_module.Fraction
    and failed since _overrides_module was removed in revision
    149c31beced944c.

    This adds it back pointing to the proxy itself which also contains
    Gst.Fraction.

    https://bugzilla.gnome.org/show_bug.cgi?id=736678#c6

 gi/overrides/__init__.py | 7 +++++++
 1 file changed, 7 insertions(+)

commit 6772e990ad889af817b9224e88ea9d79a04caef7
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Apr 13 19:33:40 2015 -0700

    overrides: Conditionalize touch override support in Gdk

    Conditionalize Gdk.EventTouch union discrimination. This fixes the
    Gdk overrides to continue working with versions of Gdk less than 3.4.

    https://bugzilla.gnome.org/show_bug.cgi?id=747717

 gi/overrides/Gdk.py | 18 +++++++++++++-----
 1 file changed, 13 insertions(+), 5 deletions(-)

commit 26c015b177ddcc0f35c97bcd7a4f2114fb2e8e2a
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Sun Mar 29 23:23:09 2015 +0200

    Field setters: Remove unneeded type/range checks and resulting
    unused code.

    These checks are performed in the actual marshalling code
    paths as well, no need to do them twice.

    Also move _pygi_g_registered_type_info_check_object() to pygi-info.c
    as it's the only place where it is still used.

    https://bugzilla.gnome.org/show_bug.cgi?id=746985

 gi/pygi-argument.c   | 626
 ---------------------------------------------------
 gi/pygi-argument.h   |  12 -
 gi/pygi-info.c       |  90 ++++++--
 tests/test_fields.py |  14 +-
 4 files changed, 83 insertions(+), 659 deletions(-)

commit dbb0b199268ece884e19eb99093fc26bd7bf92af
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Sun Mar 29 21:51:42 2015 +0200

    pygi-argument: Remove unused imports/includes

    https://bugzilla.gnome.org/show_bug.cgi?id=746985

 gi/gimodule.c      | 1 -
 gi/pygi-argument.c | 7 -------
 gi/pygi-argument.h | 2 --
 3 files changed, 10 deletions(-)

commit 7dee04efff418677eead36ee9ed497cc3eadf8f7
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Sun Mar 29 21:47:47 2015 +0200

    Improve test coverage for field setters/getters.

    Field setters are the sole users of the GIArgument value validation
    code and the error handling is hardly tested. This tries to improve
    the coverage for the field types available in
    GLib/Regress/GIMarshallingTests.

    https://bugzilla.gnome.org/show_bug.cgi?id=746985

 tests/Makefile.am    |   1 +
 tests/test_fields.py | 186
 +++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 187 insertions(+)

commit b0170220fabbf878a36e0c14b0a3024973b7355f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Mar 29 16:35:47 2015 -0700

    configure.ac: post release version bump to 3.17.1

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 46f463a3a3ff45eb8eba67fbb59ecc861b1e1d73
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Mar 24 01:25:25 2015 -0700

    release 3.16.0

 NEWS         | 2 ++
 configure.ac | 4 ++--
 2 files changed, 4 insertions(+), 2 deletions(-)

commit bf802599f5d0d13cc4b69f1716400561a16a2443
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Mar 5 01:09:12 2015 -0800

    configure.ac: post release version bump to 3.15.92

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a86f309066f007f9787a6d1ac679dc041740d8dc
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Mar 5 01:08:03 2015 -0800

    release 3.15.91

 NEWS         | 14 ++++++++++++++
 configure.ac |  2 +-
 2 files changed, 15 insertions(+), 1 deletion(-)

commit 9948a67e677c8a351f2de17080d7a671882570f3
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Tue Jan 27 17:47:49 2015 +0100

    tests: Don't use deprecated override attributes

    In case the test explicitly tests the deprecated attribute
    silence the resulting warnings.

    Instead of replacing GObject.PARAM_READWRITE with
    GObject.ParamFlags.READWRITE use (READABLE | WRITABLE)
    to not depend on a newer glib version.

    https://bugzilla.gnome.org/show_bug.cgi?id=743514

 tests/test_everything.py    | 168
 ++++++++++++++++++++++----------------------
 tests/test_gi.py            |  66 ++++++++---------
 tests/test_glib.py          |  33 +++++----
 tests/test_gobject.py       |  21 +++---
 tests/test_internal_api.py  |   4 +-
 tests/test_iochannel.py     |  11 +--
 tests/test_overrides_gtk.py |  20 +++---
 tests/test_properties.py    | 100 ++++++++++++++------------
 tests/test_signal.py        | 111 ++++++++++++++---------------
 tests/test_source.py        |   8 +--
 tests/test_subprocess.py    |   7 +-
 tests/testmodule.py         |   3 +-
 12 files changed, 292 insertions(+), 260 deletions(-)

commit 9285b23cd1b253baaf06ddd49e2f000716bbf7f3
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Tue Jan 27 16:36:02 2015 +0100

    Add GLib.MINFLOAT etc. and mark GObject.G_MINFLOAT etc. deprecated.

    They are defined in glib, not gobject and not included in the gir;
    Similar constants like G_MAXINT64 are defined in GLib gir and marked
    deprecated in the GObject overrides already.

    https://bugzilla.gnome.org/show_bug.cgi?id=743514

 gi/overrides/GLib.py         | 12 ++++++++++++
 gi/overrides/GObject.py      |  4 +++-
 tests/test_overrides_glib.py |  7 +++++++
 3 files changed, 22 insertions(+), 1 deletion(-)

commit f74acb38f1410982f3419acb134adf173600e497
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Tue Jan 27 16:06:03 2015 +0100

    Emit PyGIDeprecationWarning when accessing deprecated override
    attributes.

    Adds a new helper function for overrides to mark a module level
    attribute
    as deprecated. A warning will be emitted every time the attribute gets
    accessed.

    e.g. when marking GObject.STATUS_FOO as deprecated using

       STATUS_FOO = GLib.Status.FOO
       deprecated_attr("GObject", "STATUS_FOO", "GLib.Status.FOO")
       __all__.append("STATUS_FOO")

    accessing it will emit

      "GObject.STATUS_FOO is deprecated; use GLib.Status.FOO instead"

    https://bugzilla.gnome.org/show_bug.cgi?id=743514

 gi/overrides/GLib.py     | 44 ++++++++++++++++-------
 gi/overrides/GObject.py  | 90
 +++++++++++++++++++++++++-----------------------
 gi/overrides/__init__.py | 74 ++++++++++++++++++++++++++++++++++++++-
 tests/test_gi.py         | 70 +++++++++++++++++++++++++++++++++++++
 4 files changed, 221 insertions(+), 57 deletions(-)

commit a10df7d28c01d70ee33d8e4e9ddaa23f1990ca60
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Tue Jan 27 19:13:54 2015 +0100

    Add namespace and container name to callable cache and include them
    in all warnings/error messages.

    https://bugzilla.gnome.org/show_bug.cgi?id=743468

 gi/pygi-cache.c          | 39 ++++++++++++++++++++++++++++++++++-----
 gi/pygi-cache.h          |  5 +++++
 gi/pygi-closure.c        |  4 +++-
 gi/pygi-invoke.c         | 41 +++++++++++++++++++++++++++++------------
 tests/test_everything.py |  2 +-
 tests/test_gi.py         | 28 ++++++++++++++++++----------
 6 files changed, 90 insertions(+), 29 deletions(-)

commit 747fc3754c296ad5481d354bbf35521f886c5c61
Author: Garrett Regier <garrettregier@gmail.com>
Date:   Sun Mar 1 03:30:46 2015 -0800

    tests: Add test for GIRepository.UnionInfo.get_size()

    https://bugzilla.gnome.org/show_bug.cgi?id=745362

 tests/test_repository.py | 1 +
 1 file changed, 1 insertion(+)

commit 2dcce92b4fab95403b9bbedffa8a91453c947927
Author: Garrett Regier <garrettregier@gmail.com>
Date:   Fri Jan 23 01:37:35 2015 -0800

    Avoid duping filenames when marshalling from Python to C

    https://bugzilla.gnome.org/show_bug.cgi?id=744719

 gi/pygi-basictype.c | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 26fe8dafb933fa76afd41e45b10a3163a7380c1e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Feb 20 22:06:24 2015 -0800

    configure.ac: post release version bump to 3.15.1

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e8aef305d273ce551da41e74a54c5d03de5a0c2a
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Feb 20 22:04:43 2015 -0800

    release 3.15.0

 NEWS | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 5dc113283c0a721c4027026bb8de7243585f1289
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Feb 20 21:59:10 2015 -0800

    Ignore deprecation warning for g_option_group_free()

 gi/pygoptiongroup.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit d8961622ea748c42171bdb4703e70022035ec3cc
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Feb 20 21:52:58 2015 -0800

    tests: Make get_all_dependendencies() test more robust

    Replace array comparison with checking if individual items are in
    the array.
    This solves a problem where the returned array might be in a
    different order
    as well as future proofs the test in case more dependencies are added.

 tests/test_import_machinery.py | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit b10ab49afb97655507e2d3b92f621387287a2928
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Feb 20 20:16:35 2015 -0800

    tests: Fix PEP8 error with commented code in test

 tests/test_gi.py | 1 -
 1 file changed, 1 deletion(-)

commit 60de632153a693fb2b0f2ce26208c6ff668bdf4d
Author: Garrett Regier <garrett.regier@riftio.com>
Date:   Tue Jan 27 10:39:53 2015 -0800

    Avoid copying bytearrays from Python to C when transfer nothing

    https://bugzilla.gnome.org/show_bug.cgi?id=743278

 gi/pygi-array.c  | 23 +++++++++++++++++++----
 tests/test_gi.py | 14 +++++++++++++-
 2 files changed, 32 insertions(+), 5 deletions(-)

commit a4160892dd28ab1d656cef4d4059f3b3f95caf4a
Author: Garrett Regier <garrett.regier@riftio.com>
Date:   Mon Jan 19 14:53:53 2015 -0800

    Allows passing arguments to opaque Boxed types

    https://bugzilla.gnome.org/show_bug.cgi?id=743214

 gi/pygi-info.c           |  7 +++++++
 gi/types.py              | 10 +++++++++-
 tests/test_everything.py |  9 +++++++++
 tests/test_glib.py       |  6 +++---
 4 files changed, 28 insertions(+), 4 deletions(-)

commit ef3bff4e570363e4f383d4cdae9cecd4073b03d8
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Sat Jan 24 20:01:00 2015 +0100

    Emit ImportWarning when gi.require_version() is not used

    gi tries to import the latest version of typelibs which can cause
    existing code to break when a newer typelib is released.
    Emit an ImportWarning when gi.require_version() is not used to give
    developers this awareness so they can future proof their code.

    https://bugzilla.gnome.org/show_bug.cgi?id=727379

 gi/importer.py                 | 99
 +++++++++++++++++++++++++++++++++++++++++-
 gi/pygi-repository.c           | 35 +++++++++++++++
 tests/compat_test_pygtk.py     |  7 ++-
 tests/test_atoms.py            |  6 ++-
 tests/test_import_machinery.py | 22 ++++++++++
 tests/test_overrides_gtk.py    |  7 ++-
 tests/test_overrides_pango.py  |  5 ++-
 tests/test_properties.py       |  5 ++-
 tests/test_repository.py       | 10 +++++
 9 files changed, 187 insertions(+), 9 deletions(-)

commit 149c31beced944c72fba6ca6e096c81c1100ea2b
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Tue Dec 2 15:38:57 2014 +0100

    Refactor overrides import/modules

    Removes Registry and DynamicModule in favor of a simple module
    wrapper that
    contains only overrides and falls back to the introspection module.
    Moves all the overrides logic into gi.overrides; Speeds up module
    attribute access

    https://bugzilla.gnome.org/show_bug.cgi?id=736678

 gi/importer.py                 |  11 ++--
 gi/module.py                   |  68 ---------------------
 gi/overrides/__init__.py       | 131
 ++++++++++++++++++++++++++++++-----------
 tests/test_gi.py               |   4 --
 tests/test_import_machinery.py |  32 +++++++---
 5 files changed, 126 insertions(+), 120 deletions(-)

commit 4d0ab13a8461f781986accc637fada3909cfb91a
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 21 15:11:39 2014 -0700

    Replace statically bound GLib.Variant.new_tuple() with GI

    Remove the static implementation of _wrap_pyg_variant_new_tuple with
    usage of the dynamic version coming from GI. Array marshalling has
    drastically improved in recent years making the dynamic version usable
    with a small compatibility shim for the arguments.

    https://bugzilla.gnome.org/show_bug.cgi?id=735199

 gi/gimodule.c        | 39 ---------------------------------------
 gi/overrides/GLib.py | 12 +++++-------
 2 files changed, 5 insertions(+), 46 deletions(-)

commit 17ec0d39069b7a4cc19691ea1284f821caf84d24
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Sep 10 13:30:48 2014 -0700

    overrides: Add Gdk.EventTouch union discrimination

    Add EventTouch to get/setattr pass-through to support BEGIN,
    UPDATE, END,
    and CANCEL touch event types. Ensure Gdk.Event methods get_state(),
    get_axis(), get_coords(), and get_root_coords() are patched onto
    Gdk.EventTouch.

    https://bugzilla.gnome.org/show_bug.cgi?id=736380

 gi/overrides/Gdk.py         |  5 +++++
 tests/test_overrides_gdk.py | 12 ++++++++++++
 2 files changed, 17 insertions(+)

commit 16408a81713157cdf1e3b6bd74bd53e816e9dfda
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Jan 3 17:20:14 2015 -0800

    tests: Update pixbuf loader test to not raise exception when closing

    GdkPixbuf commit:
    https://git.gnome.org/browse/gdk-pixbuf/commit/?id=447bd32650af
    changed the close() method to raise if the a loader is prematurely
    closed.
    Update the test to write a 1x1 PNG stream to ensure close() will
    succeed.

 tests/compat_test_pygtk.py | 9 +++++++++
 1 file changed, 9 insertions(+)

commit fd3935541ab4baddb504e000ec659b80923afa13
Author: Murray Cumming <murrayc@murrayc.com>
Date:   Tue Dec 2 19:55:51 2014 +0100

    PyGObjectFlags: Remove a trailing comma on the enum.

    Because this produces a g++ pedantic warning.

 gi/pygobject.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3b70f5bc8e59e49795fcaa7b285aeff0c4565a04
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Oct 27 20:19:23 2014 -0700

    Remove redefinitions of function and vfunc cache typedefs

    https://bugzilla.gnome.org/show_bug.cgi?id=737874

 gi/pygi-cache.h | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit cec9c2b253bdbc1e6493630c533acf6bb4509114
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 22 13:26:24 2014 -0700

    configure.ac: post release version bump to 3.15.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f20df385f480b65a8128986ce3df4022b324ade0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 22 12:38:35 2014 -0700

    release 3.14.0

 NEWS | 3 +++
 1 file changed, 3 insertions(+)

commit 309d4100a08867d18420586c3b1f8709c360250f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 22 12:24:32 2014 -0700

    configure.ac: pre release version bump to 3.14.0

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 4b7c985aa57f8026da96d174454b308858ebd1cc
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 15 15:46:04 2014 -0700

    release 3.13.92

 NEWS | 7 +++++++
 1 file changed, 7 insertions(+)

commit 79bad703a089a4b0c31fcdb143b889667f5fa197
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Sep 12 17:10:04 2014 -0700

    tests: Add test for Gio.Application.add_main_option()

 tests/test_gio.py | 29 +++++++++++++++++++++++++++++
 1 file changed, 29 insertions(+)

commit a2f98a9ba0b0dda0d3cf59651327e5c93d5479d6
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Sep 11 19:32:53 2014 -0700

    Split test_everything.TestEverything.test_string() into multiple tests

    https://bugzilla.gnome.org/show_bug.cgi?id=735193

 tests/test_everything.py | 25 +++++++++++++++++++------
 1 file changed, 19 insertions(+), 6 deletions(-)

commit 6674701b6de02353738b9dc04ab88de23996704e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Sep 11 19:08:53 2014 -0700

    tests: Split array tests up

    Split test_everything.TestEverything.test_array(),
    test_array_fixed_size(),
    and test_ptrarray() into functions of a finer granularity. This
    allows for
    easier diagnosis of problems and leaks when they occur.

    https://bugzilla.gnome.org/show_bug.cgi?id=735193

 tests/test_everything.py | 37 ++++++++++++++++++++++++++++++++-----
 1 file changed, 32 insertions(+), 5 deletions(-)

commit d1bae18ba0514864a37bf5d182605e2100c28d7e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Sep 11 16:17:13 2014 -0700

    tests: Split test_strv() into multiple tests

    https://bugzilla.gnome.org/show_bug.cgi?id=735193

 tests/test_everything.py | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

commit 6181f724bc2c6ea30194c961cb15b2c543a48f95
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Sep 10 19:06:35 2014 -0700

    Fix invalid read error in argument cleanup code

    Always set initial length argument index for arrays to -1. Ensure
    we don't
    attempt retrieving Python cleanup arguments until we know it is valid.
    This was causing an invalid read in test_gi.TestArray.test_array_out()

 gi/pygi-array.c           |  1 +
 gi/pygi-marshal-cleanup.c | 13 ++++++++-----
 2 files changed, 9 insertions(+), 5 deletions(-)

commit 972e944ad4b2aac03c61633b8c277e35395c114c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Sep 10 18:55:45 2014 -0700

    tests: Increase num-callers for valgrind runs

    Additionally split valgrind check variations over multiple lines
    for readability.

 tests/Makefile.am | 23 ++++++++++++++++++++---
 1 file changed, 20 insertions(+), 3 deletions(-)

commit d70b300c7415dd7b20ff88b09fe835690da19831
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Sep 6 23:58:25 2014 -0700

    Fix memory management problems with struct arguments to signals

    Replicate struct marshaling logic for determining if struct arguments
    to signals should be passed by reference to callbacks.
    Maintain a list of these structs and apply an in-place copy of
    the struct
    pointer if the struct wrapper is held longer than the duration of the
    Python callback. This allows for both mutation of struct arguments
    from
    callbacks as well as memory safety incase a callbacks holds onto
    the struct.

    https://bugzilla.gnome.org/show_bug.cgi?id=736175

 gi/pygi-boxed.c             | 20 ++++++++++++++++++++
 gi/pygi-boxed.h             |  2 ++
 gi/pygi-signal-closure.c    | 43
 +++++++++++++++++++++++++++++++++++++------
 tests/test_overrides_gtk.py |  1 -
 tests/test_signal.py        | 27 +++++++++++++++++++++++++++
 5 files changed, 86 insertions(+), 7 deletions(-)

commit 09161ff690ad37c94668d5d65191f4d84829d41f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Sep 7 15:53:35 2014 -0700

    Limit foreign struct checks to GI_INFO_TYPE_STRUCT

    Add struct type check before calling g_struct_info_is_foreign().

    https://bugzilla.gnome.org/show_bug.cgi?id=736175

 gi/pygi-argument.c       | 11 ++++++++---
 gi/pygi-struct-marshal.c |  7 +++++--
 2 files changed, 13 insertions(+), 5 deletions(-)

commit 4ebb1f5a4750712bd919a31103ed8c8d6af483b3
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Sep 6 15:16:06 2014 -0700

    tests: Add failing regression test for Gtk.TextBuffer.insert-text
    signal

    https://bugzilla.gnome.org/show_bug.cgi?id=736175

 tests/test_overrides_gtk.py | 19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

commit 2f355dc4e9724f25c200d30db1c8fbc4695f9ab7
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 1 17:36:46 2014 -0700

    configure.ac: post release version bump to 3.13.92

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 68d34721a21bfac1a43252bd92612c2460ea60dd
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 1 17:31:39 2014 -0700

    release 3.13.91

 NEWS | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 8c6cf22d74075b7169512b9e7773a511abb9b759
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 1 16:48:15 2014 -0700

    docs: Skip "Constructors" header for anonymous structs

    Structs which don't have a size or constructor should not procuce
    any doc
    string. The trailing "::" was causing a problem with sphinx.

 gi/docstring.py         | 8 ++++++--
 tests/test_docstring.py | 3 ++-
 2 files changed, 8 insertions(+), 3 deletions(-)

commit c1ea60be30ebf11c2e5415180305e4ac3c573f57
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 1 15:21:04 2014 -0700

    docs: Fix error when using may_return_null()

    Fix error with an untested code path opened up by commit 1f78dc0ace.

 gi/docstring.py         | 3 ++-
 tests/test_docstring.py | 4 ++++
 2 files changed, 6 insertions(+), 1 deletion(-)

commit 1f78dc0ace5282def9f1f700bfe4523de07e7549
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 29 16:49:14 2014 -0700

    docs: Fix function doc string generator return types

    Change skip_return() access into a function call. This was causing
    return type doc strings to always be skipped.

 gi/docstring.py         | 2 +-
 tests/test_docstring.py | 8 ++++++--
 2 files changed, 7 insertions(+), 3 deletions(-)

commit 28d0337f0e3d4b0e9c4350ce5d6cf0cb68da843f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 29 14:18:28 2014 -0700

    Special case signal output arguments which are structs as
    pass-by-reference

    Add a special case which avoids copying of struct arguments marked
    as output
    to signals. Since we don't currently support output arguments,
    users have
    come to rely on a pass-by-reference bug which was fixed and caused
    this to
    regress (bug 722899). Add unittest which is currently failing due
    to a number
    of issues with emit() not supporting type annotations or output
    arguments
    (bug 735693).

    https://bugzilla.gnome.org/show_bug.cgi?id=735486

 gi/pygi-signal-closure.c    | 41
 +++++++++++++++++++++++++++++++++++------
 tests/test_overrides_gtk.py | 24 ++++++++++++++++++++++++
 2 files changed, 59 insertions(+), 6 deletions(-)

commit 16f8f687eae0caa1e4059fd62bd1f9d4c7f655f7
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Aug 27 23:55:06 2014 -0700

    Ignore closure callbacks when Python is not initialized

    Add an immediate return in ffi closures if Python is not initialized.
    This fixes rare events when which lead to a segfault when a process
    is exiting.

    https://bugzilla.gnome.org/show_bug.cgi?id=722562

 gi/pygi-closure.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit 27a14679dce33f64bbb5d77677eba83849f168ff
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Fri Aug 22 21:51:31 2014 -0700

    Change boxed init with args to warn instead of raise

    Replace raising a TypeError in gi.types.Boxed() with a warning.
    Even though passing arguments or keywords to the parent class is
    incorrect here, raising an exception was causing a bit of fallout
    in some apps (Gramps).

    https://bugzilla.gnome.org/show_bug.cgi?id=727810

 gi/pygi-boxed.c  |  5 ++++-
 tests/test_gi.py | 13 +++++++++++--
 2 files changed, 15 insertions(+), 3 deletions(-)

commit 6008748bd7ecc6e5c933e6902c77d8485b905a6f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 22 02:16:10 2014 -0700

    tests: Add test for GLib.spawn_async_with_pipes()

    https://bugzilla.gnome.org/show_bug.cgi?id=735213

 tests/test_signal.py     |  2 +-
 tests/test_subprocess.py | 17 +++++++++++++++++
 2 files changed, 18 insertions(+), 1 deletion(-)

commit 983276fb1cbc261d062ef93ba2266d08a5a6f423
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 21 17:16:31 2014 -0700

    Revert "Replace statically bound GLib.Variant.new_tuple() with GI"

    This was accidentally pushed.
    Revert commit 35c6540c42a01e1155f44533cc09e6c9f94b6613.

 gi/gimodule.c        | 39 +++++++++++++++++++++++++++++++++++++++
 gi/overrides/GLib.py | 12 +++++++-----
 2 files changed, 46 insertions(+), 5 deletions(-)

commit b7a4e68a224ab66f67e45667023f74dd743e6177
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Fri Aug 22 01:04:40 2014 +0200

    Fix crash in GList/GSList marshaling error handling path.

    In case PySequence_GetItem() failed, the retured NULL was passed
    to PyDECREF.

    https://bugzilla.gnome.org/show_bug.cgi?id=735201

 gi/pygi-list.c   |  4 ++--
 tests/test_gi.py | 16 ++++++++++++++++
 2 files changed, 18 insertions(+), 2 deletions(-)

commit 35c6540c42a01e1155f44533cc09e6c9f94b6613
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 21 15:11:39 2014 -0700

    Replace statically bound GLib.Variant.new_tuple() with GI

    Remove the static implementation of _wrap_pyg_variant_new_tuple with
    usage of the dynamic version coming from GI. Array marshalling has
    drastically improved in recent years making the dynamic version usable
    with a small compatibility shim for the arguments.

    https://bugzilla.gnome.org/show_bug.cgi?id=735199

 gi/gimodule.c        | 39 ---------------------------------------
 gi/overrides/GLib.py | 12 +++++-------
 2 files changed, 5 insertions(+), 46 deletions(-)

commit c1d387540a0b2db66e860c574b070051a5431914
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 21 14:37:14 2014 -0700

    Fix reference counting problems with GLib.Variant.new_tuple()

    Always sink the results of g_variant_new_tuple() in the statically
    bound wrapper. This matches the generic GI marshalling behavior
    of passing GVariants to Python with transfer-none.

    https://bugzilla.gnome.org/show_bug.cgi?id=735166

 gi/gimodule.c                | 1 +
 tests/test_overrides_glib.py | 7 +++++++
 2 files changed, 8 insertions(+)

commit 9ce261f27742ba200f70003f162291a375d244d3
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Aug 19 14:57:31 2014 -0700

    configure.ac: Fix darwin builds

    Merge platform_win32 and os_win32 variables/case statements and
    define "link_python_libs" for win32 as well as darwin.

    https://bugzilla.gnome.org/show_bug.cgi?id=735068

 configure.ac | 30 +++++++++++-------------------
 1 file changed, 11 insertions(+), 19 deletions(-)

commit 92f0d6ebf9b67729d8253e15fce77b0ad0375573
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Aug 20 13:39:31 2014 -0700

    Skip marshalling NULL output arguments in Python closures

    Skip marshalling optional output arguments which are passed NULL
    as the memory location. This fixes fallout from bug 727004.

    https://bugzilla.gnome.org/show_bug.cgi?id=735090

 gi/pygi-closure.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit d7e30c3cacf3cdd550e4dbfe2fa47aea1ae28147
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Aug 18 19:10:36 2014 -0700

    configure.ac: post release version bump to 3.13.91

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 17ba19c2e9b91a1bb8b03fabd4100d436c96975d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Aug 18 19:07:10 2014 -0700

    release 3.13.90

 NEWS | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 6bcfaf6e1e2331b704dd6067d45d6840e87632a2
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Aug 18 18:57:28 2014 -0700

    configure.ac: pre release version bump to 3.13.90

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3b5b590599ca98cc51871878618cd59fc05212d1
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Aug 18 02:33:54 2014 -0700

    gtk-demo: Don't use deprecated constructor for Gtk.Label

 demos/gtk-demo/demos/pickers.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5b82051d23f8d759b6fa57a4e9327e300568c89f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Aug 9 02:30:43 2014 -0700

    Fast path Python Property getter when accessed through GObject
    interfaces

    Break do_get_property() call into a re-usable function.
    Call do_get_property() Python implementations instead of going
    through GObject
    machinery for Python GObjects. This gives a performance boost
    for Python
    GObject properties when accessed via. obj.get_property() and
    obj.props.

    https://bugzilla.gnome.org/show_bug.cgi?id=723872

 gi/gobjectmodule.c | 11 ++++-------
 gi/pygi-property.c | 35 +++++++++++++++++++++++++++--------
 gi/pygi-property.h |  3 +++
 3 files changed, 34 insertions(+), 15 deletions(-)

commit 0a99f878e40c8d683157dea69c3c9ac40d13d734
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Aug 9 02:10:11 2014 -0700

    Fast path Python Property getter when accessing descriptor directly

    Call the Python implemented fget() when a property is accessed
    directly
    on a Python implemented GObject. This skips going through the GObject
    machinery which ends up calling fget() and marshalling the results
    through GValues.

    https://bugzilla.gnome.org/show_bug.cgi?id=723872

 gi/_propertyhelper.py | 19 +++++++++++++++----
 1 file changed, 15 insertions(+), 4 deletions(-)

commit 74722386192ad27aac8855d4603d8120af82c98e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Aug 18 02:05:58 2014 -0700

    Don't use GI type for determining pointer extraction from GValues

    Replace usage of g_type_is_a() with G_VALUE_HOLDS() when extracting
    pointers from GValues being marshalled from properties and signals.
    This fixes fallout from commit abdfb0f.

 gi/pygi-value.c | 10 ++++------
 1 file changed, 4 insertions(+), 6 deletions(-)

commit 2601011e9eb3b5f391161313ed568e5c4b67c99a
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 8 23:58:17 2014 -0700

    Fast path property access for basic types

    Attempt marshalling with pygi_value_to_py_basic_type() prior to
    looking at
    GI info. This gives a quick conversion for basic types like bools,
    ints, and
    strings without having to go through GIArgument and GI
    conversions. This
    gives approximately a 3x performance boost for accessing these
    types with
    the unified GValue marshaller.

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 gi/pygi-property.c |  9 +++++++++
 gi/pygi-value.c    | 26 ++++++++++++++++++--------
 2 files changed, 27 insertions(+), 8 deletions(-)

commit 8f4b06f700ed79df32774fad8e2a2a922bfbfbe5
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 8 16:31:01 2014 -0700

    Break pyg_value_as_pyobject into two functions

    Add pygi_value_to_py_basic_type() which is limited to handling basic
    types that don't need introspection information when marshalling
    to Python.
    Add pygi_value_to_py_structured_type() for marshalling of structured
    data
    which can eventually accept GI type hints.

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 gi/pygi-value.c | 74
 +++++++++++++++++++++++++++++++++++++++++++++++----------
 gi/pygi-value.h |  6 +++++
 2 files changed, 68 insertions(+), 12 deletions(-)

commit b0236d6fde137e0b2ecf7f5556ad5d53c22874bc
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 8 20:55:28 2014 -0700

    Unify property getters

    Consolidate duplicate logic into pygi_get_property_value().
    Use the function for GObject.get_property(), GObject.get_properties(),
    and GObject.props.
    Remove overridden expected failures in TestCGetPropertyMethod which
    now work due to the unification.

    https://bugzilla.gnome.org/show_bug.cgi?id=733893
    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 gi/pygi-property.c       | 85 +++++++++++++++++++++++++++++-------------
 gi/pygi-property.h       |  4 ++
 gi/pygobject.c           | 97
 +++++++-----------------------------------------
 tests/test_properties.py | 38 -------------------
 4 files changed, 77 insertions(+), 147 deletions(-)

commit abdfb0fa3f72f9bf822c472d16c90d6b1871610b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jul 28 19:09:30 2014 -0700

    Merge pygi_get_property_value and _pygi_argument_from_g_value

    Merge duplicated GValue marshaling code which has diverged over time
    (commits 3606eb20, ee62df4d, e14ebab6, 8cfd596c, 9f50fd21, 0d099bdb,
    and 216caf59).
    Use _pygi_argument_to_array within pygi_get_property_value. This
    is needed
    in the new code for supporting GI_TYPE_TAG_ARRAY and also fixes
    bug 669496.
    Side effects of this change also include support for properties
    holding
    G_TYPE_FLAGS and G_TYPE_PARAM.

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 gi/pygi-property.c | 140
 +++++------------------------------------------------
 gi/pygi-value.c    |  24 ++++++---
 2 files changed, 28 insertions(+), 136 deletions(-)

commit 142ff1903d34876db3d1bee5e9782ac49de12313
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jul 28 04:40:36 2014 -0700

    Never dup data structures when marshaling signal in arguments

    Always assume transfer-none of GValue arguments to signal handlers.
    A signal handler with arguments marked as transfer-full does not
    make any sense, so assume they are always transfer-none.

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 gi/pygi-signal-closure.c | 4 +---
 gi/pygi-value.c          | 4 +++-
 2 files changed, 4 insertions(+), 4 deletions(-)

commit 04816f74194bd2c95b8b958dcf9ed5da5a83e001
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jul 28 04:23:39 2014 -0700

    Never dup data structures when marshaling from g_object_get_property()

    Always use transfer-none with the results of g_object_get_property()
    and assume g_value_unset() will cleanup the results. This gives us
    control over memory of properties and limits property anotations to
    value typing.

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 gi/pygi-property.c | 24 +++++++-----------------
 1 file changed, 7 insertions(+), 17 deletions(-)

commit 85175047e66dfc0c0263eac91d8056a95d0a60a0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jul 29 19:29:28 2014 -0700

    Refactor boxed wrapper memory management strategy

    Change pygi_boxed_new() to accept "copy_boxed" instead of
    "free_on_dealloc".
    This changes memory management so the PyGIBoxed wrapper owns the boxed
    pointer given to it. Use __del__ instead of dealloc for freeing
    the boxed
    memory. This is needed for edge cases where objects like GSource can
    trigger the finalized callback during de-alloc, resulting in the
    PyObjects
    references counts being manipulated and triggering a re-entrant
    de-alloc.
    Add hack to keep Gtk.TreeIter.do_iter_next/previous implementations
    working
    which rely on pass-by-reference.
    See also: https://bugzilla.gnome.org/show_bug.cgi?id=734465

    https://bugzilla.gnome.org/show_bug.cgi?id=722899

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 gi/gimodule.c            |  6 +++-
 gi/overrides/GLib.py     |  4 ---
 gi/overrides/GObject.py  |  3 ++
 gi/pygi-boxed.c          | 54 +++++++++++++++++++++++++-------
 gi/pygi-boxed.h          |  4 +--
 gi/pygi-source.c         |  6 ++--
 gi/pygi-struct-marshal.c | 81
 +++++++++++++++++++++++++++++++++++++++++++++---
 tests/test_gi.py         |  1 -
 tests/test_source.py     |  8 +++--
 9 files changed, 140 insertions(+), 27 deletions(-)

commit 62aed0977090f7099a5e538209f7c680ea22fe12
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Aug 17 19:04:51 2014 -0700

    Replace GObject.signal_query with introspected version

    Remove the static bindings for GObject.signal_query and replace with a
    Python compatibility shim which utilizes the introspection exposed
    version
    of the function.

    https://bugzilla.gnome.org/show_bug.cgi?id=688792

 gi/gobjectmodule.c      | 89
 -------------------------------------------------
 gi/overrides/GObject.py | 39 ++++++++++++----------
 2 files changed, 21 insertions(+), 107 deletions(-)

commit 4e130d72a5492fc00c61a816eddccdbc4f558b91
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Aug 17 19:03:32 2014 -0700

    Use array lengths specified on struct fields

    Add array length marshalling policy for struct fields. This fixes
    accessing
    C array fields on structs which also specify a length field.

    https://bugzilla.gnome.org/show_bug.cgi?id=688792

 gi/pygi-argument.c | 14 ++++++-------
 gi/pygi-argument.h |  4 ++++
 gi/pygi-info.c     | 59
 ++++++++++++++++++++++++++++++++++++++++++++++++++++--
 3 files changed, 68 insertions(+), 9 deletions(-)

commit c55d029d2d67b5920e9467212e22b0ad58d3ded8
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Aug 17 18:15:23 2014 -0700

    Refactor signal array length marshalling to support a length policy

    Replace passing arrays of data to non-caching array marshallers with
    a policy
    closure that can be customized depending on context. In the case
    of signals,
    this is mostly scaffolding which will be replaced with caching
    marshallers.
    However, it opens the legacy marshaller for usage with struct
    and object
    array fields.

    https://bugzilla.gnome.org/show_bug.cgi?id=688792

 gi/pygi-argument.c       | 70
 ++++++++++++++++++++++++++++++++----------------
 gi/pygi-argument.h       | 14 +++++++---
 gi/pygi-signal-closure.c |  8 ++++--
 3 files changed, 64 insertions(+), 28 deletions(-)

commit 3270dad356c44f5fef7571a9f29b22e7c293fa2c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Aug 17 13:58:10 2014 -0700

    Remove dead code for marshalling array lengths in the context
    of vfuncs

    Remove usage of the args parameter from _pygi_argument_to_array. This
    is no
    longer used because array marshalling for vfuncs is now handled by
    the cached
    marshaller.

    https://bugzilla.gnome.org/show_bug.cgi?id=688792

 gi/pygi-argument.c | 24 +++++++++---------------
 1 file changed, 9 insertions(+), 15 deletions(-)

commit 6046ca87697fe80c6c0eb70f1efcad24de4f4fd8
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Aug 17 21:53:55 2014 -0700

    Fix memory leak with unboxed caller allocated structs

    Take caller-allocates into account when wrapping unboxed structures.
    This will free the allocated memory when the Python object is
    de-alloced.

 gi/pygi-struct-marshal.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c607f07f5ae3ca62ee3a2649f84330eaaa8801c6
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Aug 16 22:34:29 2014 -0700

    tests: Add reference count test for signal connection arguments

    Add tests for ensuring reference counts are what we expect for
    connect() callback, user_data, and swap object (currently broken
    due to bug 688064).

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 tests/test_signal.py | 133
 +++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 133 insertions(+)

commit 7076669aadfc5227144df87277d69ae66865770a
Author: Tobias Mueller <gnome-bugs@muelli.cryptobitch.de>
Date:   Sat Aug 16 17:46:50 2014 -0700

    Don't mask GObject sub-class doc strings in meta-class

    If a class has a __doc__ attribute explicitly set, always return it.
    Only generate doc strings for classes coming from  gi.repository
    or gi.overrides.

    Co-Authored-By: Simon Feltman <sfeltman@src.gnome.org>

    https://bugzilla.gnome.org/show_bug.cgi?id=731452

    https://bugzilla.gnome.org/show_bug.cgi?id=734926

 gi/types.py             | 12 +++++++++++-
 tests/test_docstring.py |  2 --
 2 files changed, 11 insertions(+), 3 deletions(-)

commit 4cdca4328da7442be247e775294fc676cf677bb7
Author: Piotr Iwaniuk <piwaniuk@poczta.onet.pl>
Date:   Sat Aug 16 15:06:40 2014 -0700

    tests: Add failing tests for GObject sub-class doc-strings

    Add tests for sub-class docstrings set with either doc-string
    syntax and by setting the __doc__ attribute directly.

    Co-Authored-By: Simon Feltman <sfeltman@src.gnome.org>

    https://bugzilla.gnome.org/show_bug.cgi?id=731452

 tests/test_docstring.py | 39 +++++++++++++++++++++++++++++++++++++++
 1 file changed, 39 insertions(+)

commit 9328a6721909322f0e1444e5285ae1b7b5bf1e3c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 14 22:47:14 2014 -0700

    configure.ac: post release version bump to 3.13.5

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 49fd1662623f6dbb6af16b9fbfc0fb57707a7eee
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 14 22:42:27 2014 -0700

    release 3.13.4

 NEWS | 22 ++++++++++++++++++++++
 1 file changed, 22 insertions(+)

commit 0d2e797812ab4e1a745ef97559104691dbb6b824
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 14 18:33:06 2014 -0700

    Fix invalid unref after getting callable container

    Don't unref the results of g_base_info_get_container() because it is
    transfer-none. This was causing an attempted unref on an invalid
    object
    when setting up callback caches for signals.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-cache.c | 2 --
 1 file changed, 2 deletions(-)

commit 654c28faffc8d956bd31987adca092fa014cc897
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 14 21:31:33 2014 -0700

    tests: Silence valgrindlog and valgrindxml output from forked procs

    This is needed to properly diff valgrind runs between commits.

 tests/Makefile.am | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 57070585a5d5dbc5f42d6fa6d2c309b36f38dfdc
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Aug 13 10:27:01 2014 -0700

    Remove ffi wrapped destroy notify used for closure cleanup

    Remove global ffi wrapper for _pygi_invoke_closure_free() and
    instead use
    a pointer to _pygi_invoke_closure_free() directly. There is no need
    to wrap
    a known single use function with an ffi closure. Originally
    introduced in
    commit 610dd1eec87f.

 gi/pygi-closure.c | 49 +------------------------------------------------
 1 file changed, 1 insertion(+), 48 deletions(-)

commit 3f9b5f890ad1292f12eba1e545084de80b76dab7
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Aug 12 22:19:24 2014 -0700

    tests: Update tests for static binding protection to check
    AttributeErrors

 tests/test_import_machinery.py | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit e674340db90c29c556b45e0a8f8b2da72661b738
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Aug 11 23:12:38 2014 -0700

    Use AttributeError for static binding protection

    Replace usage of RuntimeError with AttributeError in the dummy module
    protecting importing of static bindings. This is needed so we
    don't break
    modules like inspect which is used by ipython.

 gi/__init__.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 86fb12b3e9b7558000d100f8f212e970ae8c4fd2
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Aug 11 22:47:14 2014 -0700

    Add deprecation warning for connect_object() with non-GObject argument

    GObject.connect_object() accepts any Python object and holds a strong
    reference to it in the closure defeating the purpose of
    connect_object().
    Add a warning so we can eventually limit connect_object() to GObject
    arguments
    use the underlying g_signal_connect_object() which holds a weak
    reference.

    https://bugzilla.gnome.org/show_bug.cgi?id=688064

 gi/pygobject.c | 9 +++++++++
 1 file changed, 9 insertions(+)

commit 9c54bb9defb681316841158cc63df0b0b85c12f0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Aug 11 22:39:13 2014 -0700

    tests: Add tests for connect_object()

    Add tests for both introspected and non-introspected signals
    making use
    of connect_object() and connect_object_after() in combination
    with GObject
    and Python object swap data.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 tests/test_signal.py | 139
 +++++++++++++++++++++++++++++++++++++++++++--------
 1 file changed, 117 insertions(+), 22 deletions(-)

commit 581acc4c56be127b3a724df504bb46a40959fdd9
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Aug 11 21:21:42 2014 -0700

    Add Python implementation of Object.connect_data()

    Add GObject.Object.connect_data() which takes an optional
    "connect_flags"
    keyword argument accepting GObject.ConnectFlags enum values. This is
    for supporting user data swapping (ConnectFlags.SWAPPED).

    https://bugzilla.gnome.org/show_bug.cgi?id=701843

 gi/overrides/GObject.py |  37 ++++++++++++++++
 tests/test_signal.py    | 109
 ++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 146 insertions(+)

commit b1caef95c4b68b65f3f159563162afde5a0b0939
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Aug 9 02:14:23 2014 -0700

    tests: Add failing tests which verify exceptions raised in property
    getters

    https://bugzilla.gnome.org/show_bug.cgi?id=575652

 tests/test_properties.py | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

commit 19cdbee5a89009da0eb366b9c698a860a7aa92b8
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Fri Aug 8 10:08:23 2014 -0400

    Cleanup input args when marshaling in closures

    The cleanup must happen before setting the out args otherwise
    the args that cleanup would free are the just set args, not the
    original ones.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-closure.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7742fab42de5b1f4f8161237fc3cef91fd98791c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 8 02:47:11 2014 -0700

    tests: Fix Python 2 build for newly added test_array_parm()

    Use @unittest.skip() with a string argument as required by Python 2.

 tests/test_signal.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3165c17a455652de9a61439428fa40f30120dc6a
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 8 02:46:26 2014 -0700

    Remove incorrect and unused casts from tp_free calls

    Arguments to Py_TYPE() do not need to be cast since the macro
    always casts
    to a PyObject* internall.

 gi/pygi-boxed.c     | 2 +-
 gi/pygi-ccallback.c | 2 +-
 gi/pygi-info.c      | 2 +-
 gi/pygi-struct.c    | 2 +-
 4 files changed, 4 insertions(+), 4 deletions(-)

commit 74dfec27c6008968cc66a13792dfb02b29c231b6
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 8 02:33:51 2014 -0700

    Fix GCallback Python wrapper leak

    The PyObject wrapper for GCallbacks was not calling tp_free in
    the custom
    tp_dealloc class method.

    https://bugzilla.gnome.org/show_bug.cgi?id=695130

 gi/pygi-ccallback.c | 2 ++
 1 file changed, 2 insertions(+)

commit dcf9111a86e01d66943909a0c9f21a181ccc38a6
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Fri Aug 8 01:55:21 2014 -0700

    tests: Add failing test for marshalling an array of GValues through
    signals

    https://bugzilla.gnome.org/show_bug.cgi?id=669496

 tests/test_signal.py | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit d689d24f271c30612c6a86b5c51d50a1179aedad
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 7 17:52:35 2014 -0700

    tests: Add tests for GApplication local command line handling

    Add various tests which override Gio.Appliction.do_command_line and
    do_local_command_line.

    https://bugzilla.gnome.org/show_bug.cgi?id=690851

 tests/test_gio.py | 65
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 65 insertions(+)

commit 59c257ebc47fa725750344dd50dd8eb522536d3c
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Thu Aug 7 12:25:59 2014 -0400

    Add test for a callback with an inout array

    This was broken until the closures used the caches for marshaling.

    https://bugzilla.gnome.org/show_bug.cgi?id=702508

 tests/test_everything.py | 19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

commit 9d0c43b2b9f92fff4249e4eb296f00ea73b15af3
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Thu Aug 7 12:06:30 2014 -0400

    Fix raising an error in a constructor

    It should raise a Python exception instead of warnings about
    a constructor returning NULL.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-cache.c  | 6 +++---
 tests/test_gi.py | 6 ++++++
 2 files changed, 9 insertions(+), 3 deletions(-)

commit d7b9ef0f5411ebcbb2597c16b221fd3482c535e4
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Wed Aug 6 15:30:58 2014 -0400

    Use the caches for marshaling the arguments in closures

    Changes to object marshaling when the calling context is from
    C was required to correctly keep the correct floating status.

    The array cache has been modified to set to/from_py_marshaller
    for the length arg cache. This is required for closures which include
    the length arg for backwards compatibility. The closure cache takes
    care to change the length arg cache's meta type so it gets marshalled
    for closures.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-array.c     |   5 +-
 gi/pygi-basictype.c |   4 +-
 gi/pygi-basictype.h |  36 +++--
 gi/pygi-cache.c     |  30 +++-
 gi/pygi-closure.c   | 403
 ++++++++++++++++++++++++++++------------------------
 gi/pygi-invoke.c    |   3 +-
 6 files changed, 271 insertions(+), 210 deletions(-)

commit 9337acf98d783777c94d4bcb912a185ba6791efb
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Wed Aug 6 12:14:27 2014 -0400

    Specialize GObject marshaling when called from C

    These are needed otherwise the floating status of
    the GObject will not be kept.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-object.c | 86
 +++++++++++++++++++++++++++++++++++++++++++++++---------
 1 file changed, 72 insertions(+), 14 deletions(-)

commit cf295f636b6324a46abbaf329cd6d92c04155d9d
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Wed Aug 6 11:59:09 2014 -0400

    Move special handling of GObject from Python when calling from C

    This will soon be used in the GObject arg cache marshaling when
    the calling context is C.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-argument.c | 21 +--------------------
 gi/pygi-object.c   | 30 ++++++++++++++++++++++++++++++
 gi/pygi-object.h   |  5 +++++
 3 files changed, 36 insertions(+), 20 deletions(-)

commit 0d09234ea0399d756ee3fb0d358fab5b0a145657
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Wed Aug 6 11:53:39 2014 -0400

    Always pass along the callable cache to the arg cache constructors

    This will be needed in a future patch which requires that the callable
    cache is always available.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-array.c     | 20 ++++++++++++--------
 gi/pygi-array.h     |  9 +++++----
 gi/pygi-cache.c     | 34 ++++++++++++++++++++--------------
 gi/pygi-cache.h     |  7 ++++---
 gi/pygi-hashtable.c | 31 +++++++++++++++++--------------
 gi/pygi-hashtable.h |  9 +++++----
 gi/pygi-list.c      | 30 +++++++++++++++++++-----------
 gi/pygi-list.h      |  9 +++++----
 gi/pygi-object.c    | 25 ++++++++++++++-----------
 gi/pygi-object.h    |  3 ++-
 10 files changed, 103 insertions(+), 74 deletions(-)

commit 203fef99205ce0c46b1530b0d480021ee8b8e325
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Tue Aug 5 10:42:46 2014 -0400

    Set the correct meta type for GErrors when marshaling to Python

    Otherwise we do not pass the GError into python callbacks and
    we also want to convert these into Python Exceptions.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-error.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2e92809258d04e91c9d22f2fc0de09db2e60c962
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Tue Aug 5 10:37:58 2014 -0400

    Pass the GIArgument to the closure assign functions

    This will be required once we use the caches for marshaling.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-closure.c | 102
 ++++++++++++++++++++++++++----------------------------
 1 file changed, 50 insertions(+), 52 deletions(-)

commit ca3579db14df278923674c294d07481a7255510f
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Tue Aug 5 10:25:40 2014 -0400

    Use the caches for closures, but not yet for marshaling the arguments

    Instead of using the various GI functions we use the data from
    the caches.
    This also fixes generating an arg cache for a closure as it was
    missing some
    data or simply setting incorrect data. Also, always included the
    GITypeInfo
    until the closures no longer need it for marshaling the arguments.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-cache.c   |  33 +++++++-
 gi/pygi-cache.h   |   4 +
 gi/pygi-closure.c | 245
 +++++++++++++++++++++++++-----------------------------
 gi/pygi-closure.h |   2 +
 4 files changed, 150 insertions(+), 134 deletions(-)

commit 6a21dab89b59db0afc6d6a22272028ee949b52ad
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Tue Aug 5 10:16:45 2014 -0400

    Correctly set the destroy notify for callbacks in closures

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-closure.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e6d48b4eadbeb1014c4eb140317b579e69eb8d88
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Fri Aug 1 11:40:08 2014 -0400

    Split the callable cache into the different types

    Instead of doing different things based on the various function types
    this adds vfuncs for generate_args_cache() and invoke() which are then
    specialized for the various function types. Also add a calling context
    to the callable cache which is then used to determine the direction
    when generating the arg caches.

    This is in preparation for adding closure caches.

    https://bugzilla.gnome.org/show_bug.cgi?id=727004

 gi/pygi-cache.c               | 514
 +++++++++++++++++++++++++++++++-----------
 gi/pygi-cache.h               |  96 +++++---
 gi/pygi-ccallback.c           |  16 +-
 gi/pygi-info.c                |   3 +-
 gi/pygi-invoke-state-struct.h |   2 -
 gi/pygi-invoke.c              | 244 ++++++++------------
 gi/pygi-invoke.h              |   4 +
 gi/pygi.h                     |   2 +-
 8 files changed, 564 insertions(+), 317 deletions(-)

commit 18341f27a5a9770d8caf3192a75737ab2bc06b1e
Author: Ignacio Casal Quinteiro <icq@gnome.org>
Date:   Wed Aug 6 08:27:43 2014 +0200

    Generate .dll libraries on windows

    https://bugzilla.gnome.org/show_bug.cgi?id=734288

 configure.ac      | 8 ++++++++
 tests/Makefile.am | 8 ++++----
 2 files changed, 12 insertions(+), 4 deletions(-)

commit d70403357d6b510356dd375304fb97e458fd12b2
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Aug 5 22:45:46 2014 -0700

    Add protection against attempts at importing static bindings

    Clobber gobject, gio, glib, gtk, and gtk.gdk in sys.modules upon
    importing
    gi with dummy modules which produce an error upon access.

    https://bugzilla.gnome.org/show_bug.cgi?id=709183

 gi/__init__.py                 | 25 ++++++++++++++++++++++---
 tests/test_import_machinery.py | 24 ++++++++++++++++++++++++
 2 files changed, 46 insertions(+), 3 deletions(-)

commit 5ca4d25eac0efcc12b02fe53f379ee41e69bf1d2
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Dec 31 16:15:04 2013 -0800

    Update and deprecate gi.overrides.keysyms

    Replace manually assigned keysyms with a dynamically generated version
    pulling names and values from Gdk via GI. Add a runtime warning when
    this module is imported.

    https://bugzilla.gnome.org/show_bug.cgi?id=721295

 gi/overrides/keysyms.py    | 1490
 +-------------------------------------------
 pygtkcompat/pygtkcompat.py |   14 +-
 2 files changed, 27 insertions(+), 1477 deletions(-)

commit 9eaeba9079c23d7e2837f62e8ed2b26c018351b6
Author: Alexey Pavlov <alexpux@gmail.com>
Date:   Tue Aug 5 19:03:38 2014 -0700

    Use -no-undefined for building on Windows

    See LT_INIT([win32-dll]):
    http://www.gnu.org/software/libtool/manual/html_node/LT_005fINIT.html

    Additionally add PYTHON_LIBS to testhelper.la linking.

    https://bugzilla.gnome.org/show_bug.cgi?id=734284

 tests/Makefile.am | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 5737a9ec4bf4d9d07a7e3994d91abf9077b342cc
Author: Alexey Pavlov <alexpux@gmail.com>
Date:   Tue Aug 5 18:40:53 2014 -0700

    Use python-config for libs when available

    https://bugzilla.gnome.org/show_bug.cgi?id=734289

 m4/python.m4 | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 093abb4ed052c768f51c90324c2e40063aa6b9b9
Author: Alexey Pavlov <alexpux@gmail.com>
Date:   Tue Aug 5 18:20:25 2014 -0700

    Link gi.so with FFI_LIBS

    https://bugzilla.gnome.org/show_bug.cgi?id=734286

 gi/Makefile.am | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 9df54d23a15b871fd71c994b97ffe847ff3b9eb5
Author: Alexey Pavlov <alexpux@gmail.com>
Date:   Tue Aug 5 15:45:04 2014 +0200

    Include math headers also on mingw

    https://bugzilla.gnome.org/show_bug.cgi?id=734287

 gi/pygi-basictype.c | 2 --
 1 file changed, 2 deletions(-)

commit 964ced98e03c704074d10cc362abfa14c00457ba
Author: Garrett Regier <Garrett.Regier@riftio.com>
Date:   Thu Jul 31 10:16:47 2014 -0400

    Added args_offset to the cache instead of checking the function type

 gi/pygi-array.c   | 6 ++----
 gi/pygi-cache.c   | 6 +++---
 gi/pygi-cache.h   | 3 +++
 gi/pygi-closure.c | 4 +---
 4 files changed, 9 insertions(+), 10 deletions(-)

commit 9943d876059201cbee87f072a84234ed774ed932
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Jul 31 21:51:00 2014 -0700

    doap: Update homepage URL and email address

 pygobject.doap | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit afef1020a43d91014c34ffcd5a5f66281f2e7cc9
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Jul 31 21:46:37 2014 -0700

    Change maintainer in PKG-INFO to self

 PKG-INFO.in | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 10c4d66574e35cc84bed3c3057b68ad98613d839
Author: Andre Klapper <a9016009@gmx.de>
Date:   Thu Jul 31 21:28:12 2014 +0200

    doap: add <programming-language>

 pygobject.doap | 2 ++
 1 file changed, 2 insertions(+)

commit f30001f2b01896577a2b4d956bc4658350e56b8d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jul 30 00:29:01 2014 -0700

    Add GClosure marshalling cleanup

    Add marshalling cleanup for Python callables and boxed GClosures
    passed as arguments. Make sure the marshaller owns a reference
    until clean. Fix transfer everything case by adding a new reference.
    Remove unused header declaration: pygi_arg_gclosure_from_py_marshal

    https://bugzilla.gnome.org/show_bug.cgi?id=695128

 gi/pygi-struct-marshal.c | 46
 ++++++++++++++++++++++++++++++++++++++--------
 gi/pygi-struct-marshal.h |  4 ----
 2 files changed, 38 insertions(+), 12 deletions(-)

commit cf4e830f1b613736ef9586562eb6c0b354165925
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jul 30 12:42:15 2014 -0700

    Remove decrementing argument index for failed marshalling cleanup

    Remove index decrement when cleanup function is called for failed
    argument
    marshalling. The decrement is incorrect and causes the failed argument
    cleanup to be skipped. The decrement also causes cleanup for arguments
    prior to the failed argument to receive "was_successful" as FALSE,
    which
    is also incorrect.

    https://bugzilla.gnome.org/show_bug.cgi?id=695128

 gi/pygi-invoke.c | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 662a4421125d126a11ca163c362d205f0c2147c4
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jul 30 12:46:18 2014 -0700

    Use cleanup data for argument marshalling failures

    Use state->args_cleanup_data when cleaning up failed argument
    marshalling.
    This was overlooked when cleanup data tracking was implemented
    (commit 7407367f).

    https://bugzilla.gnome.org/show_bug.cgi?id=695128

 gi/pygi-marshal-cleanup.c | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 39746a3b4f307974d8b3f98f7ba2aefe06d897a3
Author: Olav Vitters <olav@vitters.nl>
Date:   Wed Jul 30 20:41:37 2014 +0200

    doap category core

 pygobject.doap | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 36caa74a276972eee2b18162ac09edc83c30a3cb
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jul 28 23:51:19 2014 -0700

    tests: Move object property reference count tests to test_properties

    Move and consolidate tests for object property reference counts from
    tests_object_marshaling to test_properties.

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 tests/test_object_marshaling.py | 68
 -----------------------------------------
 tests/test_properties.py        | 36 ++++++++++++++++++++++
 2 files changed, 36 insertions(+), 68 deletions(-)

commit 15b795354ca5a8f436779ee5d81936af8961acb5
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jul 28 22:20:44 2014 -0700

    tests: Move test_everything.TestProperties into test_properties

    Consolidate property tests found in test_everything into test_property
    removing redundant tests already found in test_property.

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 tests/test_everything.py | 69
 +-----------------------------------------------
 tests/test_properties.py | 59 +++++++++++++++++++++++++++++++++++++++++
 2 files changed, 60 insertions(+), 68 deletions(-)

commit c691d86c6f5f073f7c1e1e6ddd4311ed27431747
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jul 28 21:32:44 2014 -0700

    tests: Add tests for get/set_property()

    Re-use the new CPropertiesTestBase class for testing
    get/set_property()
    methods.

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 tests/test_properties.py | 32 ++++++++++++++++++++++++++++++++
 1 file changed, 32 insertions(+)

commit 115bc88ad5eb85e0a1821fa4fa2cad5c6df87dcc
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jul 28 21:32:00 2014 -0700

    tests: Break TestPropertiesObject up for re-use

    Refactor TestPropertiesObject into a base class which abstracts
    get/set
    property methods. This will allow re-use for testing both
    get/set_property()
    and the props accessor.

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 tests/test_properties.py | 221
 +++++++++++++++++++++++++----------------------
 1 file changed, 118 insertions(+), 103 deletions(-)

commit bf0a5c3345e65b6a7475fada4ea240dbe0049a26
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jul 28 19:32:00 2014 -0700

    tests: Move test_gi.TestPropertiesObject into test_properties

    Move all property testing code into the test_properties module.

    https://bugzilla.gnome.org/show_bug.cgi?id=726999

 tests/test_gi.py         | 233
 ----------------------------------------------
 tests/test_properties.py | 235
 +++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 235 insertions(+), 233 deletions(-)

commit 4941691264970b19b81d435cd58ab18ef6bac9a5
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Jul 25 18:33:15 2014 -0700

    pyflakes: Fix legacy print and exception usage under Python 3

    Fix print statements and legacy exception usage in examples.

    https://bugzilla.gnome.org/show_bug.cgi?id=731042

 examples/properties.py    | 12 ++++++------
 tests/runtests-windows.py |  4 ++--
 2 files changed, 8 insertions(+), 8 deletions(-)

commit c3d3cd2f798cbae7f66d8e57e191b5f9569a713b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Jul 25 17:49:57 2014 -0700

    tests: Ignore warnings for GtkAlignment

    This was causing unittests to bail. Even though this is deprecated,
    we still need to test its usage in the context of pygtkcompat.

 tests/compat_test_pygtk.py | 15 ++++++++++++++-
 1 file changed, 14 insertions(+), 1 deletion(-)

commit 804b89447ae2748c88ad5efe5e6e37d949681b9e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Jul 25 17:40:36 2014 -0700

    tests: Remove usage of deprecated "schema" property in GSettings
    creation

    Use new and new_with_path instead as the schema property was causing a
    hard warning which fails the test suite.

 tests/test_gio.py | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 6b806137825891cc6bdad82a68cf3deb087feb70
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Jul 25 17:35:06 2014 -0700

    tests: Ignore stock-id usage warnings

    Add ignore_glib_warnings context manager for easily ignoring warnings
    caused by stock-id usage. Even though stock-id is deprecated, we still
    need to test the related Python binding overrides.

 tests/test_overrides_gtk.py | 40 ++++++++++++++++++++++++----------------
 1 file changed, 24 insertions(+), 16 deletions(-)

commit 6b944c4e215a34bc4181c7c708b6d6f2d4898c15
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jun 23 15:55:57 2014 -0700

    configure.ac: post release version bump to 3.13.4

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 58198b6ae426448cde82cad7304018c7c770c0ea
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jun 23 15:53:03 2014 -0700

    release 3.13.3

 NEWS | 8 ++++++++
 1 file changed, 8 insertions(+)

commit cdf8c40768b00d08a1facca696a042efc6e8988f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu May 29 13:02:44 2014 -0700

    demos: Cleanup CSS accordion demo to use a loop for adding buttons

    Also use Gtk.main_quit directly since it has been overridden to accept
    extra args.

 demos/gtk-demo/demos/Css/css_accordion.py | 21 +++------------------
 1 file changed, 3 insertions(+), 18 deletions(-)

commit ba8380d093d6f84eabcf18c02b248aae8ffc3cf5
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue May 27 19:24:20 2014 -0700

    refactor: Move builder connection utilities outside of Builder class

    Move _extract_handler_and_args and _builder_connect_callback into
    module
    scope for re-use by GTK+ Composite Templates.

    https://bugzilla.gnome.org/show_bug.cgi?id=701843

 gi/overrides/Gtk.py         | 83
 ++++++++++++++++++++++++---------------------
 tests/test_overrides_gtk.py |  8 ++---
 2 files changed, 48 insertions(+), 43 deletions(-)

commit f127fabe9664b243774b76a68e6fce5986aa23a0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue May 27 15:52:10 2014 -0700

    tests: Move TestSignals from test_everything into test_signal

    Move these tests into a more meaningful location.

    https://bugzilla.gnome.org/show_bug.cgi?id=701843

 tests/test_everything.py | 123
 --------------------------------------------
 tests/test_signal.py     | 131
 +++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 131 insertions(+), 123 deletions(-)

commit da46963a0ce9f796ff4ee4ae2023adfd40ed54ca
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon May 26 04:21:07 2014 -0700

    configure.ac: post release version bump to 3.13.2

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6258adf6c7c604954f0dbc1a9ed8c284114358bc
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon May 26 04:18:55 2014 -0700

    release 3.13.2

 NEWS | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

commit 32542a4ba24d413fb6e0d509bff05f4ac3f642a1
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon May 26 03:01:13 2014 -0700

    Python 3.4 make check fixes

    Bump GI required version to 1.39.0. This is needed to get rid of
    expectedFailures which pass when built with 1.39.0 (unexpected
    successes
    fail unittesting in Python 3.4).
    Silence deprecation warning when using imp.reload.

    https://bugzilla.gnome.org/show_bug.cgi?id=730411

 configure.ac               | 2 +-
 pygtkcompat/pygtkcompat.py | 4 +++-
 tests/test_gi.py           | 1 -
 tests/test_repository.py   | 2 --
 4 files changed, 4 insertions(+), 5 deletions(-)

commit dbdc662b5743bb54fcc3621db775a6e948ec360c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon May 26 01:53:14 2014 -0700

    tests: Don't use deprecated positional argument for Gio.Settings
    schema

 tests/test_gio.py | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit d0b23f08eebd4377f066a4483900fe6d09e3795e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 25 23:03:35 2014 -0700

    overrides: Add Gtk.Container.child_get/set overrides

    Add overrides for child_get and child_set to Gtk.Container since these
    are not introspectable methods.

    https://bugzilla.gnome.org/show_bug.cgi?id=685076

 gi/overrides/Gtk.py         | 10 ++++++++++
 tests/test_overrides_gtk.py | 16 ++++++++++++++++
 2 files changed, 26 insertions(+)

commit 45a5fb2b0d6c7f46d355c83c73d829532e5a72ce
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 25 22:07:07 2014 -0700

    overrides: Make value argument to Widget.style_get_property optional

    Override Gtk.Widget.style_get_property to optionally accept the
    "value"
    argument. If "value" is not supplied, the override will locate
    the child
    property value type and create the GValue. Additionally return
    the resulting
    GValue converted to a native Python value.

    https://bugzilla.gnome.org/show_bug.cgi?id=685076

 gi/overrides/Gtk.py         | 11 +++++++++++
 tests/test_overrides_gtk.py | 29 +++++++++++++++++++++++++++++
 2 files changed, 40 insertions(+)

commit 6f5a9a37bcdec5074332b1066396321d40b15d99
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 25 21:08:47 2014 -0700

    overrides: Make value argument to Container.child_get_property
    optional

    Override Gtk.Container.child_get_property to optionally accept the
    "value"
    argument. If "value" is not supplied, the override will locate
    the child
    property value type and create the GValue. Additionally return
    the resulting
    GValue converted to a native Python value.

    https://bugzilla.gnome.org/show_bug.cgi?id=685076

 gi/overrides/Gtk.py         | 11 +++++++++++
 tests/test_overrides_gtk.py | 47
 +++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 58 insertions(+)

commit bf84915f89fd5fd502b4fb162eef7bc0a48c8783
Author: Johan Dahlin <johan@gnome.org>
Date:   Mon Oct 1 06:42:24 2012 -0700

    Add GTypeClass methods as Python GObject class methods

    Take all the methods from an objects type classs and add them
    as class methods. For instance, GObject.ObjectClass.list_properties
    is available as GObject.Object.list_properties().

    Co-Authored-By: Simon Feltman <sfeltman@src.gnome.org>

    https://bugzilla.gnome.org/show_bug.cgi?id=685218

 gi/types.py             | 13 +++++++++++++
 tests/test_typeclass.py | 13 +++++++++++++
 2 files changed, 26 insertions(+)

commit 778d05c93e079ba207a250b754bda9377cb47457
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 25 19:05:56 2014 -0700

    Add marshalling coercion for Python classes and instances to
    GTypeClass

    Automatically marshal Python GObject classes and instances to
    GTypeClass
    structs (GObjectClass). This allows usage of the GTypeClass methods by
    passing a Python GObject class or instance to the GTypeClass method.
    This is needed to support usage of GTypeClass methods since we don't
    manually bind GTypeClasses and they are not very well supported with
    introspection.

    https://bugzilla.gnome.org/show_bug.cgi?id=685218

 gi/pygi-struct-marshal.c | 54 ++++++++++++++++++++++++++++++++++----
 tests/Makefile.am        |  1 +
 tests/test_typeclass.py  | 67
 ++++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 117 insertions(+), 5 deletions(-)

commit 1e606287e1244cba45e3bb174d27f1c01e4f9577
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 25 02:00:00 2014 -0700

    Cleanup struct marshalling function names

    Use a consistent naming scheme for struct marshalling cache related
    functions. This removes prefixed underscores from function names
    as well as redundant wording.

    To ignore this commit with git blame use:
      git blame <this-commit-sha>^ -- gi/pygi-struct-marshal.c

    https://bugzilla.gnome.org/show_bug.cgi?id=685218

 gi/pygi-argument.c       |  34 ++++----
 gi/pygi-array.c          |   2 +-
 gi/pygi-struct-marshal.c | 221
 ++++++++++++++++++++---------------------------
 gi/pygi-struct-marshal.h |  56 ++++++------
 4 files changed, 142 insertions(+), 171 deletions(-)

commit bbbfa967d06eb8fdef6d6ebe705cc8df2869ddf3
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri May 16 15:08:35 2014 -0700

    Use accessors for getting and setting PyGParamSpec pointers

    Add pyg_param_spec_get and pyg_param_spec_set macros for getting and
    setting the GParamSpec pointer field held by the Python wrapper. This
    is preliminary cleanup work for supporting fundamental types.

    https://bugzilla.gnome.org/show_bug.cgi?id=631901

 gi/pygi-value.c   |  2 +-
 gi/pygobject.h    |  9 +++++++--
 gi/pygparamspec.c | 22 +++++++++++-----------
 3 files changed, 19 insertions(+), 14 deletions(-)

commit b49179ba3b39576c0c8fe8586b7091dbbaef8046
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri May 16 14:50:57 2014 -0700

    Use accessors for getting and setting PyGPointer fields

    Add pyg_pointer_get_ptr and pyg_pointer_set_ptr macros for getting and
    setting the pointer field. This is preliminary cleanup work for
    supporting
    fundamental types.

    https://bugzilla.gnome.org/show_bug.cgi?id=631901

 gi/gimodule.c    |  2 +-
 gi/pygi-struct.c |  6 +++---
 gi/pygobject.h   |  2 ++
 gi/pygpointer.c  | 14 +++++++-------
 4 files changed, 13 insertions(+), 11 deletions(-)

commit 92fe52243d819ffe91597744a6a1c2362a295bce
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri May 16 14:19:47 2014 -0700

    Use accessors for getting and setting PyGBoxed pointers

    Add pyg_boxed_get_ptr and pyg_boxed_set_ptr macros for getting
    and setting
    the boxed pointer field. This is preliminary cleanup work for
    supporting
    fundamental types.

    https://bugzilla.gnome.org/show_bug.cgi?id=631901

 gi/pygboxed.c   | 20 ++++++++++----------
 gi/pygi-boxed.c |  6 +++---
 gi/pygobject.h  |  2 ++
 gi/pygtype.c    |  3 ++-
 4 files changed, 17 insertions(+), 14 deletions(-)

commit 0a4f13a571cb9bd110f435f8b23ed942e3b007b0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 11 16:04:55 2014 -0700

    tests: Use assertRaises as a context manager for GError test

    Simplify tests/test_error.py:TestMarshalling.test_exception so that
    it no longer needs to pull exception information out of sys.exc_info.

 tests/test_error.py | 14 ++++++--------
 1 file changed, 6 insertions(+), 8 deletions(-)

commit bc7b0b69f651a118a053106fcae2d7c0f2173430
Author: Andrew Grigorev <andrew@ei-grad.ru>
Date:   Sun May 11 23:54:46 2014 +0400

    Replace direct parent class call by super()

    Super works, it just needs the correct class.

    https://bugzilla.gnome.org/show_bug.cgi?id=729970

 demos/gtk-demo/gtk-demo.py | 6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit de827d00762f2a741f90bc38f8b55518593f4509
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Mar 23 01:59:00 2014 -0700

    Add cairo marshaling support for non-introspected signals

    Add link dependency of cairo-gobject to _gi_cairo_la needed for
    retrieving
    the GTypes of cairo classes.
    Add GValue marshalers for cairo Context, Surface, FontFace,
    ScaledFont,
    and Pattern classes.

    https://bugzilla.gnome.org/show_bug.cgi?id=694604

 gi/Makefile.am          |   2 +
 gi/pygi-foreign-cairo.c | 186
 ++++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-type.h          |   1 +
 gi/pygtype.c            |   2 +
 tests/test_cairo.py     |  65 +++++++++++++++++
 5 files changed, 256 insertions(+)

commit 22a952ec532cc83c8227861a7d5bfa2957608c3f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon May 5 19:37:18 2014 -0700

    [New API] Add gi.require_foreign

    Add gi.require_foreign(namespace, symbol=None) API for determining
    if a foreign marshaling module is available. This can be used in an
    applications import statement block to verify the existence of a
    specific foreign marshaling module (cairo).
    Additionally it forces loading of the foreign marshaling module as
    well as the GI repository module. This allows non-introspected signal
    closures to correctly marshal their arguments (bug 694604).

    https://bugzilla.gnome.org/show_bug.cgi?id=707735

 gi/__init__.py      | 28 +++++++++++++++++++++++++
 gi/gimodule.c       |  2 ++
 gi/pygi-foreign.c   | 60
 ++++++++++++++++++++++++++++++++++++++++++++++-------
 gi/pygi-foreign.h   |  4 ++++
 tests/test_cairo.py |  9 ++++++++
 5 files changed, 95 insertions(+), 8 deletions(-)

commit 4ee91a4cd0018d069c7aaf66d83e2f8235f2262a
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon May 5 19:48:06 2014 -0700

    tests: Move cairo tests into test_cairo.py

    Move cairo related tests from test_everything.py into test_cairo.py

    https://bugzilla.gnome.org/show_bug.cgi?id=694604

 tests/Makefile.am        |  1 +
 tests/test_cairo.py      | 67
 ++++++++++++++++++++++++++++++++++++++++++++++++
 tests/test_everything.py | 43 +------------------------------
 3 files changed, 69 insertions(+), 42 deletions(-)

commit 31ecd935564984068e6646676392122bdc03e42e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon May 5 19:42:59 2014 -0700

    Initialize the foreign API at PyGI load time

    Initialize the foreign struct list at gi._gi module load time. This
    ensures
    we always have a valid (non-null) list of foreign marshalers outside
    of the
    context of marshaling.

    https://bugzilla.gnome.org/show_bug.cgi?id=694604

 gi/gimodule.c     |  3 ++-
 gi/pygi-foreign.c | 12 ++++++++----
 gi/pygi-foreign.h |  2 ++
 3 files changed, 12 insertions(+), 5 deletions(-)

commit def47144b63a1492ebf47a4eadb535f45253ff3a
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Mar 22 14:13:01 2014 -0700

    Move pygi foreign API into pygi-foreign-api.h

    Move limited set of APIs necessary for registering foreign marshalers
    into
    pygi-foreign-api.h. Remove "_real" from internally used APIs and
    add necessary
    includes to the rest of pygobject for calling directly (instead of
    going through
    the PyCapsule API within PyGI itself).
    This is needed to avoid compilation errors when including pygobject.h
    in
    foreign marshaling plugins which conflicts with pygobject-private.h.

    https://bugzilla.gnome.org/show_bug.cgi?id=694604

 gi/Makefile.am           |   1 +
 gi/gimodule.c            |   6 +--
 gi/pygboxed.c            |   1 +
 gi/pygenum.c             |   1 +
 gi/pygflags.c            |   1 +
 gi/pygi-foreign-api.h    |  85 +++++++++++++++++++++++++++++++++++++
 gi/pygi-foreign-cairo.c  |   8 ++--
 gi/pygi-foreign.c        |  10 ++---
 gi/pygi-foreign.h        |  14 +++----
 gi/pygi-property.c       |   8 ++--
 gi/pygi-property.h       |  14 ++++---
 gi/pygi-signal-closure.c |  12 +++---
 gi/pygi-signal-closure.h |  15 +++----
 gi/pygi-type.c           |   4 +-
 gi/pygi-type.h           |   2 +-
 gi/pygi.h                | 107
 -----------------------------------------------
 gi/pygobject.c           |   3 ++
 gi/pygpointer.c          |   1 +
 18 files changed, 139 insertions(+), 154 deletions(-)

commit 4c2e6914bf0277ebc3a6a4426f33a1b378a04b00
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 4 23:19:30 2014 -0700

    Clobber GLib.Error with custom implementation

    Clobber the introspection GLib.Error class with the custom Python
    implementation found in gi._error.GError. Update references to
    GLib.GError
    to use GLib.Error.

    https://bugzilla.gnome.org/show_bug.cgi?id=712519

 gi/_error.py         |  3 ++-
 gi/overrides/GLib.py |  9 ++++++---
 gi/pygi-error.c      | 10 +++++-----
 tests/test_error.py  | 24 ++++++++++++------------
 4 files changed, 25 insertions(+), 21 deletions(-)

commit f80f5ec434ed868ab1f35d6a81537384e753b09d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 4 23:43:50 2014 -0700

    Simplify pygi_error_marshal to use GError initializer arguments

    https://bugzilla.gnome.org/show_bug.cgi?id=712519

 gi/pygi-error.c | 25 ++++++-------------------
 1 file changed, 6 insertions(+), 19 deletions(-)

commit 3083daf420ac1900bb20604c22fd61e5187b4ae8
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 4 04:13:46 2014 -0700

    Add Python implementation of GError

    Add internally used gi/_error.py module as a basis for implementing
    a unified GError between introspection and static bindings. Patch
    Python
    implementations of GError.matches and GError.new_literal in the GLib
    overrides

    https://bugzilla.gnome.org/show_bug.cgi?id=712519

 Makefile.am          |  3 ++-
 gi/_error.py         | 53
 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 gi/_option.py        |  3 ++-
 gi/overrides/GLib.py | 25 ++++++++++++++++++++++++-
 gi/pygi-error.c      | 18 +++++++-----------
 tests/test_error.py  | 37 ++++++++++++++++++++++++++++++++++++
 6 files changed, 125 insertions(+), 14 deletions(-)

commit 664bfa6fdf2196a0d1449baaca62a9a496121f67
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 4 23:14:27 2014 -0700

    tests: Move GError tests into test_error.py

    https://bugzilla.gnome.org/show_bug.cgi?id=712519

 tests/Makefile.am   |  1 +
 tests/test_error.py | 81
 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/test_gi.py    | 49 --------------------------------
 3 files changed, 82 insertions(+), 49 deletions(-)

commit 649895d83a90cd3a370da215a6f98a606b987419
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun May 4 00:18:41 2014 -0700

    Consolidate GError related code into pygi-error

    Rename all pyglib_error_* functions to pygi_error_* and move them into
    pygi-error.[h|c].
    Register GError as part of the gi._gi module instead of gi._gi._glib.
    Update all code to use new naming.

    https://bugzilla.gnome.org/show_bug.cgi?id=712519

 gi/_option.py          |   6 +-
 gi/gimodule.c          |   4 +-
 gi/glibmodule.c        |  19 -----
 gi/gobjectmodule.c     |  54 +-----------
 gi/overrides/GLib.py   |   3 +-
 gi/pygi-argument.c     |   6 +-
 gi/pygi-cache.c        |   4 +-
 gi/pygi-error.c        | 222
 ++++++++++++++++++++++++++++++++++++++++++++++++-
 gi/pygi-error.h        |  21 ++++-
 gi/pygi-invoke.c       |   5 +-
 gi/pyglib-private.h    |   1 -
 gi/pyglib.c            | 199 --------------------------------------------
 gi/pyglib.h            |   5 --
 gi/pygobject-private.h |   3 -
 gi/pygoptioncontext.c  |   3 +-
 gi/pygoptiongroup.c    |   3 +-
 gi/pygspawn.c          |   3 +-
 17 files changed, 262 insertions(+), 299 deletions(-)

commit 9080215e862a73ddcce16476f4dc4492a88dd3f2
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat May 3 22:56:49 2014 -0700

    Add gi.CallableInfo.can_throw_gerror()

    Add static binding for g_callable_info_can_throw_gerror.

 gi/pygi-info.c           | 10 ++++++++++
 tests/test_repository.py | 16 ++++++++++++++++
 2 files changed, 26 insertions(+)

commit f129e78d579b7897cb86111c524d87b5b12019ad
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat May 3 22:56:03 2014 -0700

    Derive PyCallbackInfo from PyCallableInfo

    Update the static GI bindings for PyGICallbackInfo to derive
    from PyGICallableInfo. This makes all the gi.CallableInfo methods
    available to gi.CallbackInfo for use from Python.

 gi/pygi-info.c           | 4 ++--
 tests/test_repository.py | 7 +++++++
 2 files changed, 9 insertions(+), 2 deletions(-)

commit 833f96807037e85445ac103d6fb6ad9c4fab65e4
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri May 2 21:36:25 2014 -0700

    PEP8 fixes

    Use infix 'not' instead of prefixed.
    Don't use double comments (##).
    Use space between comment and text.
    Un-comment tests that now work.
    Move broken (and won't fix) implicit int64 signal tests into
    a new skipped test function.

 gi/overrides/GIMarshallingTests.py |  4 ++--
 gi/overrides/Gio.py                |  4 ++--
 gi/overrides/Gtk.py                |  6 +++---
 gi/types.py                        |  2 +-
 pygtkcompat/pygtkcompat.py         |  4 ++--
 tests/test_everything.py           |  1 -
 tests/test_gi.py                   |  9 +++------
 tests/test_iochannel.py            |  2 +-
 tests/test_option.py               |  2 +-
 tests/test_signal.py               | 28 +++++++++++++---------------
 10 files changed, 28 insertions(+), 34 deletions(-)

commit 07af141dd8dcac551cb2e962f6bf338b3485006b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Apr 28 14:06:30 2014 -0700

    configure.ac: post release version bump to 3.13.2

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ba652c1fd9dbef6d3ff57e39b400ea827374a95e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Apr 28 14:00:59 2014 -0700

    release 3.13.1

 NEWS | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

commit 3a2bfc8bf01fcae386355bc3652780e198e54d49
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Mon Apr 14 23:33:52 2014 +0200

    Raise TypeError if arguments are passed to Boxed.__init__

    This is a partial revert of
    https://git.gnome.org/browse/pygobject/commit/?id=2f2069c9efcd8
    which removed a type check in __new__. This adds it back
    into __init__. Overrides which define __new__ now have to
    filter out any arguments in __init__ and not the other way
    around, which is a bit less surprising in the common case.

    https://bugzilla.gnome.org/show_bug.cgi?id=727810

 gi/overrides/GLib.py  | 6 ++++++
 gi/overrides/Gtk.py   | 6 ++++++
 gi/overrides/Pango.py | 3 +++
 gi/pygi-boxed.c       | 6 ++++++
 tests/test_gi.py      | 4 ++++
 5 files changed, 25 insertions(+)

commit 906977047df2fb2f394410e4ebf360b69af8dcfe
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Mon Apr 14 15:40:50 2014 +0200

    Gdk.Event: Override __setattr__ to set fields based on the event type

    Pass the setting of attributes through to the underlying union based
    on event type. This mirrors the logic in __getattr__.

    https://bugzilla.gnome.org/show_bug.cgi?id=727810

 gi/overrides/Gdk.py         |  7 +++++++
 tests/test_overrides_gdk.py | 13 ++++++++++---
 2 files changed, 17 insertions(+), 3 deletions(-)

commit 78a0508a4d40e3723b36297ba2d42889dabc1cdd
Author: Christoph Reiter <reiter.christoph@gmail.com>
Date:   Mon Apr 14 13:06:02 2014 +0200

    Gdk.Event: Include GdkEventType in __repr__

    https://bugzilla.gnome.org/show_bug.cgi?id=727810

 gi/overrides/Gdk.py         | 4 ++++
 tests/test_overrides_gdk.py | 4 ++++
 2 files changed, 8 insertions(+)

commit 23965455f060793ffcbc0d8288527d41a667579c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Apr 14 15:10:01 2014 -0700

    Fix crash with type checking for GObject arguments

    Ensure we have a valid GObject before attempting to call g_type_is_a.
    Swap conditional blocks to make if condition more readable.

    https://bugzilla.gnome.org/show_bug.cgi?id=727604

 gi/pygi-object.c                | 19 ++++++++++---------
 tests/test_object_marshaling.py | 35 +++++++++++++++++++++++++++++++++++
 2 files changed, 45 insertions(+), 9 deletions(-)

commit 2e853f6a31636d6a26ce91eb30be5bb0326474b1
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Mar 30 18:27:59 2014 +0200

    Do not leak info of destroy notify

 gi/pygi-closure.c | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit f9e504c79c5ef6e1938e4db5b49115689b9f5c3c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Mar 28 19:51:58 2014 -0700

    configure.ac: Update PyGObject wiki link in AC_INIT

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ee84b5a2c83d88436aec6b62e7a271a3525569e0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 24 18:57:56 2014 -0700

    Ignore GValueArray deprecations

    Wrap calls to GValueArray related calls with
    G_GNUC_BEGIN/END_IGNORE_DEPRECATIONS.
    Although GValueArray is deprecated, we still need to support the
    marshaling of
    them in PyGObject. The deprecations add noise to the build processes
    in which
    new warnings could be lost. Essentially losing the element of surprise
    a new
    warning should have on maintainers.

 gi/pygi-value.c          | 23 ++++++++++++++++++++---
 tests/testhelpermodule.c |  3 +++
 2 files changed, 23 insertions(+), 3 deletions(-)

commit ac8b59ee335967efef974ab0aa89128ade9f3d0c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 24 18:09:10 2014 -0700

    Raise ImportError when importing modules not found in repository

    Raise an ImportError with extra information noting the typelib was not
    found. This removes the need to log a similar message which adds
    output
    noise when attempting controlled imports within try/except statements.
    In Python 2, the additional information is lost but in Python 3 it
    shows up.

    https://bugzilla.gnome.org/show_bug.cgi?id=726877

 gi/importer.py                 |  9 ++++-----
 tests/test_import_machinery.py | 18 ++++++++++++++++++
 2 files changed, 22 insertions(+), 5 deletions(-)

commit e604ada06a8ef8f9a06f0638cf183cfeacdc63a9
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 24 18:04:27 2014 -0700

    tests: Rename test_overrides to test_import_machinery

    Rename this test to better suit the contents of the file. This
    also gives
    us a more concise location to grow other tests related to import
    machinery
    internals.

    https://bugzilla.gnome.org/show_bug.cgi?id=726877

 tests/Makefile.am                                     | 2 +-
 tests/{test_overrides.py => test_import_machinery.py} | 0
 2 files changed, 1 insertion(+), 1 deletion(-)

commit a863e5ec0ac27de49a0ae261fd3a78745cfe84a0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 24 04:39:47 2014 -0700

    HACKING: Update branch creation instructions to include -b

 HACKING | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1012cfd58c1d41dd6b040a2d14f395e5578f5e79
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 24 04:35:52 2014 -0700

    configure.ac: post release version bump to 3.13.1

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 45eda91eac2f6c8ab1a5c38808f96de760196e90
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 24 03:35:21 2014 -0700

    release 3.12.0

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit 70020e9934abb39cbccfa49e582fb838465c0490
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 24 03:05:16 2014 -0700

    pre-release version bump to 3.12.0

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a9a08a0c11e8802cce539f869ea93e1b729e829e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 17 15:17:12 2014 -0700

    configure.ac: post release version bump to 3.11.93

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7283d50de8413e9450820543d0d8fd43e6c24b27
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 17 15:12:33 2014 -0700

    release 3.11.92

 NEWS | 6 ++++++
 1 file changed, 6 insertions(+)

commit b3b1f38af1ac1bda9d6a3ba50e9b6fa37ae48d96
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 17 14:55:52 2014 -0700

    configure.ac: Remove option to build without libffi

    We've always had a hard dependency on libffi headers.
    Commit 5798f94b6a727b93 added a direct module dependency on libffi
    instead of indirect via GI. Remove the option to build without libffi.

 configure.ac | 21 +++------------------
 1 file changed, 3 insertions(+), 18 deletions(-)

commit 1a2438497ffc445fe3f9da06b15085f29317c4ee
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Mar 15 00:50:14 2014 -0700

    docs: Standardize Python doc strings

    Use consistent doc string quotations (three double quotes).
    Update usage of GObject.GObject in docs to GObject.Object.
    Use reStructuredText markup for parameter annotations, instance
    variables,
    admonitions, and code examples.
    This allows for better Sphinx documentation generation for the
    project.
    Preliminary style guide:
    https://wiki.gnome.org/Projects/PyGObject/StyleGuide

 gi/_option.py            |  67 +++++++++++++++------------
 gi/_propertyhelper.py    |  86 +++++++++++++++++-----------------
 gi/_signalhelper.py      | 117
 ++++++++++++++++++++++++-----------------------
 gi/docstring.py          |  17 ++++---
 gi/glibmodule.c          |   3 +-
 gi/overrides/GLib.py     |  20 ++++----
 gi/overrides/GObject.py  |  39 ++++++++++------
 gi/overrides/Gtk.py      |  28 ++++++++----
 gi/overrides/__init__.py |  66 +++++++++++++-------------
 gi/types.py              |   2 +-
 10 files changed, 242 insertions(+), 203 deletions(-)

commit 2d268ef661badabcb63e696dab01857d57cb3371
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Mar 15 00:49:00 2014 -0700

    Quote argument names in initializer deprecation warning

    Add quotation marks around names of deprecated positional arguments.
    This makes the message clearer in stating what has been deprecated
    in cases when only a single argument is displayed.

 gi/overrides/__init__.py | 2 +-
 tests/test_gi.py         | 6 +++---
 2 files changed, 4 insertions(+), 4 deletions(-)

commit a070e712526e433c236753813acc3ef300f0d203
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Mar 15 00:35:03 2014 -0700

    docs: Ignore meta-class bases in dynamic docstring generation

    Skip attempts at generating a doc string for GObject meta-class bases
    since they do not contain an __info__ attribute.
    This circumvents errors with documentation generators (Sphinx).

 gi/types.py | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit ec44dea6bbc3f1adfb6c1a2781364a2df0d0e0e6
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Mar 13 10:13:34 2014 -0700

    Update Free Software Foundation addresses

    Update all references to the FSF physical address
    to use the web address: http://www.gnu.org/licenses

 gi/_constants.py                | 4 +---
 gi/_gobject/__init__.py         | 4 +---
 gi/_option.py                   | 4 +---
 gi/_propertyhelper.py           | 4 +---
 gi/_signalhelper.py             | 4 +---
 gi/glibmodule.c                 | 4 +---
 gi/gobjectmodule.c              | 4 +---
 gi/overrides/keysyms.py         | 4 +---
 gi/pygboxed.c                   | 4 +---
 gi/pygboxed.h                   | 4 +---
 gi/pygenum.c                    | 4 +---
 gi/pygenum.h                    | 4 +---
 gi/pygflags.c                   | 4 +---
 gi/pygflags.h                   | 4 +---
 gi/pygi-argument.c              | 4 +---
 gi/pygi-argument.h              | 4 +---
 gi/pygi-boxed.c                 | 4 +---
 gi/pygi-boxed.h                 | 4 +---
 gi/pygi-cache.c                 | 4 +---
 gi/pygi-cache.h                 | 4 +---
 gi/pygi-ccallback.c             | 4 +---
 gi/pygi-ccallback.h             | 4 +---
 gi/pygi-info.c                  | 4 +---
 gi/pygi-info.h                  | 4 +---
 gi/pygi-invoke.c                | 4 +---
 gi/pygi-invoke.h                | 4 +---
 gi/pygi-marshal-cleanup.c       | 4 +---
 gi/pygi-marshal-cleanup.h       | 4 +---
 gi/pygi-repository.c            | 4 +---
 gi/pygi-repository.h            | 4 +---
 gi/pygi-signal-closure.c        | 4 +---
 gi/pygi-struct.c                | 4 +---
 gi/pygi-struct.h                | 4 +---
 gi/pygi-type.c                  | 4 +---
 gi/pygi-type.h                  | 4 +---
 gi/pygi.h                       | 4 +---
 gi/pyginterface.c               | 4 +---
 gi/pyginterface.h               | 4 +---
 gi/pyglib-private.h             | 4 +---
 gi/pyglib-python-compat.h       | 4 +---
 gi/pyglib.c                     | 4 +---
 gi/pyglib.h                     | 4 +---
 gi/pygobject-external.h         | 4 +---
 gi/pygobject.c                  | 4 +---
 gi/pygoptioncontext.c           | 4 +---
 gi/pygoptioncontext.h           | 4 +---
 gi/pygoptiongroup.c             | 4 +---
 gi/pygoptiongroup.h             | 4 +---
 gi/pygparamspec.c               | 4 +---
 gi/pygparamspec.h               | 4 +---
 gi/pygpointer.c                 | 4 +---
 gi/pygpointer.h                 | 4 +---
 gi/pygspawn.c                   | 4 +---
 gi/pygspawn.h                   | 4 +---
 gi/pygtype.c                    | 4 +---
 gi/pygtype.h                    | 4 +---
 pygtkcompat/generictreemodel.py | 4 +---
 tests/test_generictreemodel.py  | 4 +---
 58 files changed, 58 insertions(+), 174 deletions(-)

commit bbfcebdfdc5e574999221b60520422ea6da82435
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Wed Mar 12 18:32:47 2014 -0400

    Handle GI_TRANSFER_EVERYTHING for returns of foreign structures

    Any (transfer full) return of a cairo type other than a path
    was leaked.

    Pass the transfer type PyGIArgOverrideFromGIArgumentFunc and handle
    it for the cairo foreign type. For paths we can only handle
    (transfer full) so throw an error for (transfer none).

    https://bugzilla.gnome.org/show_bug.cgi?id=726206

 gi/pygi-foreign-cairo.c  | 32 +++++++++++++++++++++++++-------
 gi/pygi-foreign.c        |  3 ++-
 gi/pygi-foreign.h        |  1 +
 gi/pygi-invoke.c         |  1 +
 gi/pygi-struct-marshal.c |  1 +
 gi/pygi.h                |  1 +
 6 files changed, 31 insertions(+), 8 deletions(-)

commit c5b641cb4eea9ae64a173dcaa4ee5a4accb036f6
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 3 15:20:02 2014 -0800

    configure.ac: post release version bump to 3.11.92

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7816531691a3db3ae1fe74abc85ac37988b67d2b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 3 15:16:43 2014 -0800

    release 3.11.91

 NEWS | 7 +++++++
 1 file changed, 7 insertions(+)

commit 1a63a04eaf2a77c1752b90e80ab571677f27ac3d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 3 06:49:09 2014 -0800

    build: Update release-news to use srcdir

    Use $(top_srcdir)/NEWS for pulling in news items to ensure
    "make release-news" works in a vpath build environment.

 Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5798f94b6a727b930b07fe840b0aef264f98a80e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Feb 7 20:16:21 2014 -0800

    Use ffi_call directly instead of g_callable_info_invoke

    Cleanup internal callable cache and state tracking by removing
    multiple
    counting schemes for differently sized "in" and "out" argument arrays.
    Use a single count based on the total number of arguments passed to C
    (inclusive of instance argument and GError exception where
    applicable).
    Size all state tracking arrays to the same size and ensure argument
    cache
    indices always line up with these arrays. This cleans up logic
    which was
    required by g_callable_info_invoke for splitting "in" and "out"
    arguments
    up.

    Cleanup array marshaling which can now rely on the new scheme
    which ensures
    the "arg_values" array always points to the correct location for
    length
    argument values.

    Cache the ffi_cif struct in PyGICallableCache via GIFunctionInvoker
    and
    related GI methods. Overall, these changes can give a performance
    boost of
    almost 2x for simple function calls (see ticket for micro benchmarks).

    https://bugzilla.gnome.org/show_bug.cgi?id=723642

 gi/pygi-array.c               |  26 ++---
 gi/pygi-cache.c               |  61 +++++++++--
 gi/pygi-cache.h               |  10 +-
 gi/pygi-ccallback.c           |   3 +-
 gi/pygi-closure.c             |   6 +-
 gi/pygi-invoke-state-struct.h |  42 +++++---
 gi/pygi-invoke.c              | 241
 +++++++++++++++++++++++-------------------
 gi/pygi-invoke.h              |   2 +-
 gi/pygi-marshal-cleanup.c     |   4 +-
 9 files changed, 230 insertions(+), 165 deletions(-)

commit ad680ae9c37a0091628a7d66010fbf70aa1a2e43
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 3 04:51:09 2014 -0800

    tests: Move class definition depending on GTK+ within function
    evaluation

    Move the definition of WindowWithSizeAllocOverride inside of the test
    function call to so it is lazily defined. This avoids problems
    running tests
    on systems without GTK+ installed.

 tests/test_overrides_gtk.py | 32 ++++++++++++++++----------------
 1 file changed, 16 insertions(+), 16 deletions(-)

commit 45d45e7c2704d68a3008f739e501fa332d326b8b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 3 04:45:59 2014 -0800

    tests: Conditionalize usage of GTK+ in tests_generictreemodel

    This allows running make check without GTK+ installed.

 tests/test_generictreemodel.py | 16 +++++++++++++---
 1 file changed, 13 insertions(+), 3 deletions(-)

commit 038563ed620e0d966e385a1779455d9b0e148c41
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 3 04:39:35 2014 -0800

    tests: Conditionalize usage of regress typelib in test_properties

    Unconditional usage of regress breaks tests when PyGObject is
    built without
    cairo.

 tests/test_properties.py | 27 +++++++++++++++++----------
 1 file changed, 17 insertions(+), 10 deletions(-)

commit 1fa93ddc51b2d223d772aee7930fc96c0ced0e00
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 3 02:44:12 2014 -0800

    configure.ac: Use -std=c90 and error on declaration-after-statement

    Replace gcc option of -std=c9x with c90 and add
    -Werror=declaration-after-statement
    This ensures we keep compatibility with msvc builds.

 configure.ac | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit cee414ab5725c51d79a2c6aa1e8760e9fd754545
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Mar 3 02:38:30 2014 -0800

    Use g_snprintf instead of snprintf

    Use g_snprintf for consistency with the rest of gobjectmodule.c

 gi/gobjectmodule.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b016ae6793839b2a6a00a69d00de30937bc611be
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Feb 27 04:27:41 2014 -0800

    Use C style comments

    Update various locations which use C99 single line comments to
    conform to
    C90 style comments. Found with: make CFLAGS="-std=C90"

 gi/gimodule.c      | 2 +-
 gi/pygi-array.c    | 3 ++-
 gi/pygi-property.c | 2 +-
 gi/pygtype.c       | 2 +-
 4 files changed, 5 insertions(+), 4 deletions(-)

commit df7cba1495c167f1019dec7f4398dc5de62a5937
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:   Tue Feb 25 14:38:41 2014 +0800

    Fix Build on Visual Studio

    Some items from pygi-enum-marshal.c were moved to pygi-basictype.c,
    which
    included the use of the NAN and INFINITY macros/constants, so the
    definitions for those need to be moved to pygi-basictype.c as well.
    Also
    avoid defining a variable in the middle of the block.

    https://bugzilla.gnome.org/show_bug.cgi?id=725122

 gi/pygi-basictype.c    | 16 ++++++++++++++++
 gi/pygi-cache.c        |  3 ++-
 gi/pygi-enum-marshal.c | 16 ----------------
 3 files changed, 18 insertions(+), 17 deletions(-)

commit bb5550bc85ac0ff60ea39912416e347f27853fb4
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Feb 17 17:22:40 2014 -0800

    Update release steps to be more explicit in regards to NEWS

    Add an explicit step to commit the NEWS changes and push prior
    tagging.

 HACKING | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit c6ac95286bce858f1925a9d6173a91866d7e9f88
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Feb 17 17:18:10 2014 -0800

    configure.ac: post release version bump to 3.11.91

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f87e341c5528d066371d4ec493956db28dd0bafa
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Feb 17 17:08:13 2014 -0800

    release 3.11.90

 NEWS | 4 ++++
 1 file changed, 4 insertions(+)

commit 9b345b153e86ca6c9b7290cf2ad3b38f6ad9d0e5
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Feb 12 10:28:35 2014 -0800

    Use GObject type checking for instance arguments

    Add a g_type_is_a check to interface/object instance arguments
    in addition
    to the Python IsInstance check. This loosens restrictions on
    overrides which
    don't use gi.overrides.override() and is needed to keep API
    compatibility
    which broke with commit:
    https://git.gnome.org/browse/pygobject/commit/?id=d5925b76

    https://bugzilla.gnome.org/show_bug.cgi?id=724009

 gi/pygi-object.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 419e13e1717b725d5c6815bae9672649b0afddd4
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Feb 3 15:58:30 2014 -0800

    configure.ac: post release version bump to 3.11.90

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 57bceaac1d84ffd03f49d8e83a4c8507c9127a41
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Feb 3 15:51:27 2014 -0800

    release 3.11.5

 NEWS | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 058d944e3b9ef9157e912e6374b54a2eb5f7f5d1
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Feb 3 06:45:09 2014 -0800

    Restore pygobject_version API needed for pygobject.h

    Add gi._gobject.pygobject_version which was removed with commit:
    https://git.gnome.org/browse/pygobject/commit/?id=2624bd2b
    This is needed for pygobject.h to function properly.

 gi/_gobject/__init__.py | 1 +
 1 file changed, 1 insertion(+)

commit f3be4cedcb1d395a3fabee95d7460bce86268153
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Feb 3 06:29:07 2014 -0800

    cache refactoring: Add comments to arg cache setup functions

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/pygi-cache.c | 36 ++++++++++++++++++++++++++++++++++++
 1 file changed, 36 insertions(+)

commit 56ac6bd9ed99d6bb2cb8641581a594105036be68
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Feb 3 06:24:18 2014 -0800

    cache refactoring: Use consistent prefix for arg cache functions

    Use "pygi_arg_cache" as the prefix for arg cache memory related
    functions.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/pygi-array.c          |  6 ++--
 gi/pygi-basictype.c      |  4 +--
 gi/pygi-cache.c          | 74
 ++++++++++++++++++++++++------------------------
 gi/pygi-cache.h          | 58 ++++++++++++++++++++-----------------
 gi/pygi-ccallback.c      |  2 +-
 gi/pygi-closure.c        |  6 ++--
 gi/pygi-enum-marshal.c   |  4 +--
 gi/pygi-error.c          |  4 +--
 gi/pygi-hashtable.c      | 30 ++++++++++----------
 gi/pygi-info.c           |  2 +-
 gi/pygi-invoke.c         |  2 +-
 gi/pygi-list.c           |  2 +-
 gi/pygi-object.c         |  2 +-
 gi/pygi-struct-marshal.c |  2 +-
 14 files changed, 102 insertions(+), 96 deletions(-)

commit 204f5a187782c5325ed6bed96c9a940f3aa67d04
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Jan 12 12:26:30 2014 -0800

    marshal refactoring: Move GValue marshaling from pytype into
    pygi-value

    Move marshaling of GValues to and from PyObjects into
    pygi-value.c. Make
    PyGTypeMarshal struct and related functions accessible via pygtype.h.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/gobjectmodule.c       |   2 +
 gi/pygi-struct-marshal.c |   1 +
 gi/pygi-value.c          | 720
 +++++++++++++++++++++++++++++++++++++++++++++-
 gi/pygi-value.h          |  12 +
 gi/pygobject-private.h   |  16 --
 gi/pygobject.c           |   2 +-
 gi/pygtype.c             | 728
 +----------------------------------------------
 gi/pygtype.h             |  17 ++
 8 files changed, 757 insertions(+), 741 deletions(-)

commit b8120d848dc5d36832123b1a913015f6e1fd8cdc
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Jan 12 11:41:20 2014 -0800

    marshal refactoring: Move GIArgument from GValue code to new file

    Add gi/pygi-value.h and .c files with initial contents of
    _pygi_argument_from_g_value. Eventually this file will contain
    all code
    related to GValue marshaling from various code locations in the
    project.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/Makefile.am           |   2 +
 gi/pygi-argument.c       | 126 +----------------------------------------
 gi/pygi-argument.h       |   3 -
 gi/pygi-signal-closure.c |   1 +
 gi/pygi-value.c          | 144
 +++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-value.h          |  32 +++++++++++
 6 files changed, 180 insertions(+), 128 deletions(-)

commit c2d5857e9b964427190e1230be32ae7919e86bc0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 12 21:26:55 2013 -0700

    cache refactoring: Move enum and flags arg setup and marshaling to
    new file

    Move enum and flags argument cache setup and marshaling fragments into
    isolated file: pygi-enum-marshal.c. Remove pygi-marshal-from/to files.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/Makefile.am            |   6 +-
 gi/pygi-argument.c        |   2 -
 gi/pygi-cache.c           |  74 ++-------
 gi/pygi-enum-marshal.c    | 408
 ++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-enum-marshal.h    |  42 +++++
 gi/pygi-marshal-from-py.c | 206 -----------------------
 gi/pygi-marshal-from-py.h |  57 -------
 gi/pygi-marshal-to-py.c   | 152 -----------------
 gi/pygi-marshal-to-py.h   |  34 ----
 9 files changed, 464 insertions(+), 517 deletions(-)

commit 1d0f120d77582509b4e75d83f500a1ace7ed6421
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 12 20:00:12 2013 -0700

    cache refactoring: Move various struct arg setup and marshaling to
    new file

    Move struct (boxed, union, gvalue, gclosure, variant, and pointer)
    argument
    cache setup and marshaling fragments into isolated file:
    pygi-struct-marshal.c.
    Remove redundant and dead code related to boxed and union marshaling.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/Makefile.am            |   2 +
 gi/pygi-argument.c        |   1 +
 gi/pygi-array.c           |   3 +
 gi/pygi-cache.c           |  72 +------
 gi/pygi-cache.h           |   1 +
 gi/pygi-marshal-cleanup.c |  48 -----
 gi/pygi-marshal-cleanup.h |  16 --
 gi/pygi-marshal-from-py.c | 288 --------------------------
 gi/pygi-marshal-from-py.h |  33 ---
 gi/pygi-marshal-to-py.c   | 120 -----------
 gi/pygi-marshal-to-py.h   |  27 ---
 gi/pygi-object.c          |   2 +-
 gi/pygi-struct-marshal.c  | 516
 ++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-struct-marshal.h  |  73 +++++++
 14 files changed, 607 insertions(+), 595 deletions(-)

commit 4dcaa2b988239e01224994098c3e7cbe8b455fe0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 12 16:40:58 2013 -0700

    cache refactoring: Move GObject arg setup and marshaling into new file

    Move GObject argument cache setup and marshaling fragments into
    isolated file: pygi-object.c.
    Break GIInterfaceCache creation and setup into API for interface based
    argument cache usage.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/Makefile.am            |   2 +
 gi/pygi-argument.c        |   7 +-
 gi/pygi-cache.c           | 183 ++++++++++++++-----------------
 gi/pygi-cache.h           |   7 ++
 gi/pygi-marshal-cleanup.c |  27 -----
 gi/pygi-marshal-cleanup.h |  10 --
 gi/pygi-marshal-from-py.c | 123 ---------------------
 gi/pygi-marshal-from-py.h |  12 --
 gi/pygi-marshal-to-py.c   |  31 ------
 gi/pygi-marshal-to-py.h   |   8 --
 gi/pygi-object.c          | 273
 ++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-object.h          |  46 ++++++++
 12 files changed, 416 insertions(+), 313 deletions(-)

commit 2cddba811592fbb990322fbf2dce516ffd7e94cd
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 12 12:39:20 2013 -0700

    cache refactoring: Move closure setup and marshaling into pygi-closure

    Move closure argument caching and marshaling fragments into
    pygi-closure.c.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/pygi-cache.c           | 111 ++--------------
 gi/pygi-cache.h           |   9 --
 gi/pygi-closure.c         | 314
 +++++++++++++++++++++++++++++++++++++++++++++-
 gi/pygi-closure.h         |  13 +-
 gi/pygi-marshal-cleanup.c |  14 ---
 gi/pygi-marshal-cleanup.h |   5 -
 gi/pygi-marshal-from-py.c | 160 -----------------------
 gi/pygi-marshal-from-py.h |   6 -
 gi/pygi-marshal-to-py.c   |  13 --
 gi/pygi-marshal-to-py.h   |   4 -
 10 files changed, 333 insertions(+), 316 deletions(-)

commit 18d8274724484a27e05d2e60baac1f20c72b6d2b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 12 11:30:36 2013 -0700

    cache refactoring: Move GError arg setup and marshaling to new file

    Move GError argument caching and marshaling fragments into
    isolated file: pygi-error.c.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/Makefile.am            |   2 +
 gi/pygi-cache.c           |  93 ++++++++++++---------------------------
 gi/pygi-error.c           | 109
 ++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-error.h           |  35 +++++++++++++++
 gi/pygi-marshal-from-py.c |  13 ------
 gi/pygi-marshal-from-py.h |   6 ---
 gi/pygi-marshal-to-py.c   |  22 ----------
 gi/pygi-marshal-to-py.h   |   4 --
 8 files changed, 174 insertions(+), 110 deletions(-)

commit c45cafd07fc62ad545f3e58f2b7350ee4b2bb9b7
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 12 03:07:53 2013 -0700

    cache refactoring: Move GArray arg setup and marshaling into new file

    Move GArray argument caching and marshaling fragments into an
    isolated file: pygi-array.c.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/Makefile.am            |   2 +
 gi/pygi-array.c           | 906
 ++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-array.h           |  42 +++
 gi/pygi-cache.c           | 236 +-----------
 gi/pygi-marshal-cleanup.c | 150 --------
 gi/pygi-marshal-cleanup.h |  10 -
 gi/pygi-marshal-from-py.c | 354 ------------------
 gi/pygi-marshal-from-py.h |   6 -
 gi/pygi-marshal-to-py.c   | 210 -----------
 gi/pygi-marshal-to-py.h   |   4 -
 10 files changed, 963 insertions(+), 957 deletions(-)

commit 4697a3793b46a803c6dbef749ba75c0fee80020d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 11 23:26:08 2013 -0700

    cache refactoring: Move GList/GSList arg setup and marshaling into
    new file

    Move GList and GSList argument caching and marshaling fragments
    into an
    isolated file: pygi-list.c.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/Makefile.am            |   2 +
 gi/pygi-cache.c           |  71 ++-----
 gi/pygi-list.c            | 466
 ++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-list.h            |  38 ++++
 gi/pygi-marshal-cleanup.c |  80 --------
 gi/pygi-marshal-cleanup.h |  10 -
 gi/pygi-marshal-from-py.c | 156 ----------------
 gi/pygi-marshal-from-py.h |  12 --
 gi/pygi-marshal-to-py.c   |  98 ----------
 gi/pygi-marshal-to-py.h   |   8 -
 10 files changed, 517 insertions(+), 424 deletions(-)

commit c48ddacf4479d2cf80beb9c614cdce2a61599b3b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 11 21:30:45 2013 -0700

    cache refactoring: Break sequence cache up for array vs list

    Add new arg cache type specialized for arrays. This cleans up
    the basic
    sequence cache type which does not need length and size related
    info. Remove
    fixed length checks from GList and GSList from_py marshaling
    because these
    will always be -1.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/pygi-cache.c           | 160
 +++++++++++++++++++++++++++++++++++-----------
 gi/pygi-cache.h           |  16 ++++-
 gi/pygi-invoke.c          |   4 +-
 gi/pygi-marshal-cleanup.c |  28 ++++----
 gi/pygi-marshal-from-py.c |  37 ++++-------
 gi/pygi-marshal-to-py.c   |  23 +++----
 6 files changed, 177 insertions(+), 91 deletions(-)

commit c1a2a86a7b51f4dc5a5da9f8808552c38acadf9d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 11 20:12:01 2013 -0700

    cache refactoring: Move basic type arg setup and marshaling into
    new file

    Move all basic type arg caching and marshaling fragments into
    an isolated
    file where most functions are made static. pygi-basictype.h exposes:
    pygi_arg_basic_type_new_from_info, _pygi_marshal_from_py_basic_type,
    and
    _pygi_marshal_to_py_basic_type which allows continued use for all
    marshaling
    code paths.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/Makefile.am            |   2 +
 gi/pygi-argument.c        |   1 +
 gi/pygi-basictype.c       | 824
 ++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-basictype.h       |  42 +++
 gi/pygi-cache.c           |  82 +----
 gi/pygi-cache.h           |   1 +
 gi/pygi-marshal-cleanup.c |  26 --
 gi/pygi-marshal-cleanup.h |  10 -
 gi/pygi-marshal-from-py.c | 478 ---------------------------
 gi/pygi-marshal-from-py.h |  18 -
 gi/pygi-marshal-to-py.c   | 155 ---------
 gi/pygi-marshal-to-py.h   |  11 -
 12 files changed, 880 insertions(+), 770 deletions(-)

commit 4a6bf3be49cc5aec7287c41ec02c78d60df1d44c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 11 17:39:31 2013 -0700

    cache refactoring: Move PyGIHashCache and related marshaling into
    new file

    Re-organize hash table arg cache and its marshaling by moving all
    related code fragments into an isolated file where most of it is made
    static. pygi-hashtable.h exposes a single function:
    pygi_arg_hash_table_new_from_info. This is all the caching system
    needs to
    produce the proper bits for handling hash table marshaling.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/Makefile.am            |   4 +-
 gi/pygi-cache.c           | 103 +-----------
 gi/pygi-cache.h           |  21 ++-
 gi/pygi-hashtable.c       | 413
 ++++++++++++++++++++++++++++++++++++++++++++++
 gi/pygi-hashtable.h       |  35 ++++
 gi/pygi-marshal-cleanup.c |  63 -------
 gi/pygi-marshal-cleanup.h |  10 --
 gi/pygi-marshal-from-py.c | 125 --------------
 gi/pygi-marshal-from-py.h |   6 -
 gi/pygi-marshal-to-py.c   |  85 ----------
 gi/pygi-marshal-to-py.h   |   4 -
 11 files changed, 471 insertions(+), 398 deletions(-)

commit 983d0c2252f91e63d5fa0222ef2b67722cb97434
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 11 15:49:32 2013 -0700

    cache refactoring: Separate ArgCache creation and setup

    Move PyGIArgCache and PyGIInterfaceCache generic setup into standalone
    functions: pygi_arg_base_setup and pygi_arg_interface_setup
    respectively.
    Shift argument order and move arguments which will eventually
    be removed
    from the signature into the tail with comment. Isolate special
    casing for
    GI_INFO_TYPE_CALLBACK ArgCache creation to a single location in
    _arg_cache_new_for_interface.

    https://bugzilla.gnome.org/show_bug.cgi?id=709700

 gi/pygi-cache.c | 263
 ++++++++++++++++++++++++++++++++------------------------
 gi/pygi-cache.h |  15 ++++
 2 files changed, 167 insertions(+), 111 deletions(-)

commit 0af98aca40fe266d1fd93caaa7256bb92ba1d3e4
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Feb 2 15:52:24 2014 -0800

    tests: Add skip and expectedFailure to test_gi.test_callback_owned_box

    https://bugzilla.gnome.org/show_bug.cgi?id=722899

 tests/test_gi.py | 3 +++
 1 file changed, 3 insertions(+)

commit e79d2acc54c1e3b052835de5de20feb0b7069476
Author: Mike Gorse <mgorse@suse.com>
Date:   Fri Jan 24 05:17:06 2014 -0600

    tests: Add test for an owned boxed struct passed in a callback

    https://bugzilla.gnome.org/show_bug.cgi?id=722899

 tests/test_gi.py | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit b12ceed8cc5fa398cea2061813aac6a5ba100b6f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Jan 23 17:19:12 2014 -0800

    Rename gi.types.GIObjectMeta to gi.types.GObjectMeta

    Rename GIObjectMeta to GObjectMeta reverting it to its original
    name prior
    to commit https://git.gnome.org/browse/pygobject/commit/?id=2624bd2b
    That change could have been considered an API break for anyone
    deriving from
    gi.types.GObjectMeta since it is essentially public API. Rename
    base meta
    class to _GObjectMetaBase which was previously gi._gobject before
    commit 2624bd2b (private API).

 gi/module.py |  8 ++++----
 gi/types.py  | 10 +++++-----
 2 files changed, 9 insertions(+), 9 deletions(-)

commit 15fdd827ce4bff847fb35c817c6ea2d3650eec00
Author: Patrick Welche <prlw1@cam.ac.uk>
Date:   Thu Jan 23 23:49:51 2014 +0000

    build: Add --without-common configure option for package maintainers

    https://bugzilla.gnome.org/show_bug.cgi?id=721646

 Makefile.am    | 2 ++
 configure.ac   | 7 +++++++
 gi/Makefile.am | 2 ++
 3 files changed, 11 insertions(+)

commit df21dbbc84fa319af2a0f0664de436ca30df616e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Jan 16 16:33:41 2014 -0800

    tests: Add skipped test for GLib.Source inheritance problems

    Add test showing memory problems with sub-classes of GLib.Source.

    https://bugzilla.gnome.org/show_bug.cgi?id=722387

 tests/test_source.py | 45 +++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 45 insertions(+)

commit 7222a37a4b4955fe6c1dcc86e0eb798d653711e8
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jan 15 12:51:57 2014 -0800

    Fix reference sharing of gi sub-modules in Python 2

    Ensure we add a new reference to sub-modules added to gi._gi. This may
    have caused GC errors upon exiting the Python process since a
    reference was
    shared by sys.modules and gi._gi.

    https://bugzilla.gnome.org/show_bug.cgi?id=722274

 gi/gimodule.c | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit 8c838b683220bcbf2091bba97b91ddb56b275aed
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jan 14 23:46:44 2014 -0800

    demo: Add TreeModel interface implementation demonstration

    Add demo which shows how to implement the Gtk.TreeModel interfaces
    virtual
    methods.

 demos/gtk-demo/demos/TreeView/treemodel_large.py | 143
 +++++++++++++++++++++++
 1 file changed, 143 insertions(+)

commit 911898bac5d0ad5a42ed9990588bd98871f4a8a4
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jan 14 23:33:16 2014 -0800

    demo: Remove "Icon View" and "Tree View" directories

 demos/gtk-demo/demos/Icon View/__init__.py         |   0
 demos/gtk-demo/demos/Icon View/iconviewbasics.py   | 220 ----------------
 demos/gtk-demo/demos/Icon View/iconviewedit.py     |  98 --------
 demos/gtk-demo/demos/Tree View/__init__.py         |   0
 demos/gtk-demo/demos/Tree View/liststore.py        | 210 ----------------
 .../gtk-demo/demos/Tree View/treemodel_filelist.py | 234
 -----------------
 .../gtk-demo/demos/Tree View/treemodel_filetree.py | 279
 ---------------------
 7 files changed, 1041 deletions(-)

commit f89fa08ba756a1c529ff48beb39025f834a249bf
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jan 14 23:08:33 2014 -0800

    demo: Remove spaces from demo sub-directories

    Move "Icon View" to IconView and "Tree View" to TreeView. This
    will help
    ability to package the demos in tarball releases in future versions.

 demos/gtk-demo/demos/IconView/__init__.py          |   0
 demos/gtk-demo/demos/IconView/iconviewbasics.py    | 220 ++++++++++++++++
 demos/gtk-demo/demos/IconView/iconviewedit.py      |  98 ++++++++
 demos/gtk-demo/demos/TreeView/__init__.py          |   0
 demos/gtk-demo/demos/TreeView/liststore.py         | 210 ++++++++++++++++
 .../gtk-demo/demos/TreeView/treemodel_filelist.py  | 234
 +++++++++++++++++
 .../gtk-demo/demos/TreeView/treemodel_filetree.py  | 279
 +++++++++++++++++++++
 7 files changed, 1041 insertions(+)

commit 0b7d85f3379adfb3cf1122588e333707ee089e46
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jan 14 14:28:52 2014 -0800

    build: Remove _glib directory include from testhelper CFLAGS

 tests/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 35b5a85aad91f48935dd49fee60d69e6184eff2c
Author: Colin Walters <walters@verbum.org>
Date:   Tue Jan 14 16:33:38 2014 -0500

    build: Set PLATFORM_VERSION again to 3.0

    We are installing headers to:
    /usr/include/pygobject-$(PLATFORM_VERSION)/pygobject.h

    If the variable isn't set, then things attempting to use pygobject
    obviously fail.

    This was a regression from a build system refactoring.

 gi/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit f2a79904ff4d60bff657bfbfd6a2ce8ab9307848
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jan 14 12:54:42 2014 -0800

    Fix Python 2 build warning for module definitions

    Define PYGLIB_MODULE_ERROR_RETURN as NULL for both Python 2 and
    3. This is
    needed now that the function signature created with
    PYGLIB_MODULE_START is
    consistent between the two versions.

 gi/pyglib-python-compat.h | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit 61b4af05646a8f014cfb00a5507fec2deb9aafa6
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jan 14 12:26:16 2014 -0800

    tests: Run PyFlakes and PEP8 only on SUBDIRS

    Move PyFlakes and PEP8 checks into check-local of the root
    Makefile.am. Only
    run these tools on selective subdirs of top_srcdir. This fixes
    a problem
    where vpath build directories within the srcdir would contain links
    to the
    source files, causing these tools to run multiple times slowing
    down the
    check process.

 Makefile.am       | 21 ++++++++++++++++++++-
 tests/Makefile.am |  6 ------
 2 files changed, 20 insertions(+), 7 deletions(-)

commit 9a7f6f08c1dc0eb0dd91437da8ac429fbafc8a4a
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jan 14 12:25:09 2014 -0800

    Remove _glib include path from gi module target

 gi/Makefile.am | 7 ++-----
 1 file changed, 2 insertions(+), 5 deletions(-)

commit 8afd7e880a72a44e6ea46c763bab82146fd75c96
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jan 8 19:22:08 2014 -0800

    Move Python glib options module into gi package

    Move gi/_glib/option.py into gi/_option.py. Remove gi/_glib since
    it is no
    longer needed.

    https://bugzilla.gnome.org/show_bug.cgi?id=712197

 Makefile.am                        |  3 ++-
 configure.ac                       |  1 -
 gi/Makefile.am                     |  1 -
 gi/_glib/Makefile.am               | 21 ---------------------
 gi/_glib/__init__.py               | 20 --------------------
 gi/{_glib/option.py => _option.py} |  2 +-
 gi/overrides/GLib.py               |  2 +-
 gi/overrides/GObject.py            |  2 +-
 8 files changed, 5 insertions(+), 47 deletions(-)

commit ad565e5bbc9d12607c39be9479bc671a8f2de6e3
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jan 8 18:57:58 2014 -0800

    Merge static PyGLib module into PyGI

    Remove gi._glib._glib as a separately compiled module. Move all C
    files into
    pygobject/gi. Remove compilation and use of libpyglib-gi-2.0-python.so
    as a
    shared dependency since we do not distribute header files for it.
    Remove unused threading macros.

    https://bugzilla.gnome.org/show_bug.cgi?id=712197

 gi/Makefile.am                        | 16 +++++--
 gi/_glib/Makefile.am                  | 74
 +-------------------------------
 gi/_glib/__init__.py                  |  5 ---
 gi/_glib/option.py                    |  2 +-
 gi/gimodule.c                         |  9 ++++
 gi/{_glib => }/glibmodule.c           | 34 ++-------------
 gi/gobjectmodule.c                    |  5 +--
 gi/overrides/GLib.py                  |  2 +-
 gi/{_glib => }/pyglib-private.h       | 14 ++----
 gi/{_glib => }/pyglib-python-compat.h |  0
 gi/{_glib => }/pyglib.c               | 81
 ++---------------------------------
 gi/{_glib => }/pyglib.h               | 10 -----
 gi/{_glib => }/pygoptioncontext.c     |  0
 gi/{_glib => }/pygoptioncontext.h     |  0
 gi/{_glib => }/pygoptiongroup.c       |  0
 gi/{_glib => }/pygoptiongroup.h       |  0
 gi/{_glib => }/pygspawn.c             |  0
 gi/{_glib => }/pygspawn.h             |  0
 18 files changed, 40 insertions(+), 212 deletions(-)

commit 2624bd2b4a465a2d234951dd5b855fe8a0d46e1c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Oct 31 03:13:53 2013 -0700

    Move gobject sub-module Python files into the main gi package

    This moves the signalhelper, propertyhelper, and constants Python
    modules
    from gi/_gobject into gi. Keep gi/_gobject/__init__.py around because
    it is
    still needed to maintain the "_PyGObject_API" exposed by
    pygobject.h. This
    allows external modules compiled with prior versions of PyGObject to
    continue working with newer versions.

    https://bugzilla.gnome.org/show_bug.cgi?id=712197

 Makefile.am                                        |  5 ++-
 gi/__init__.py                                     | 19 +++++-----
 gi/{_gobject/constants.py => _constants.py}        |  5 ++-
 gi/_gobject/Makefile.am                            |  5 +--
 gi/_gobject/__init__.py                            | 42
 ++--------------------
 .../propertyhelper.py => _propertyhelper.py}       |  4 +--
 gi/{_gobject/signalhelper.py => _signalhelper.py}  |  5 ++-
 gi/module.py                                       | 16 ++++-----
 gi/overrides/GObject.py                            |  7 ++--
 gi/overrides/__init__.py                           |  2 +-
 gi/types.py                                        | 41
 ++++++++++++++++-----
 pygtkcompat/pygtkcompat.py                         |  4 +--
 tests/test_gi.py                                   |  2 +-
 tests/test_gobject.py                              |  4 ++-
 tests/test_properties.py                           |  2 +-
 tests/test_signal.py                               |  2 +-
 16 files changed, 78 insertions(+), 87 deletions(-)

commit d3e8946dbb23197a2e9d7de351a7b9cd04d360b9
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Oct 31 02:22:03 2013 -0700

    Merge gobject static code into the gi module

    Remove gi._gobject._gobject as a separately compiled static module and
    move all the files into gi._gi.
    Remove dead module initialization macros from "pyglib-python-compat.h"

    https://bugzilla.gnome.org/show_bug.cgi?id=712197

 gi/Makefile.am                        | 31 ++++++++++++++--
 gi/_glib/pyglib-python-compat.h       | 62
 +++++++++----------------------
 gi/_gobject/Makefile.am               | 69
 +----------------------------------
 gi/_gobject/__init__.py               |  4 +-
 gi/_gobject/constants.py              |  3 +-
 gi/_gobject/propertyhelper.py         | 16 +++++---
 gi/_gobject/signalhelper.py           |  3 +-
 gi/gimodule.c                         | 13 ++++---
 gi/{_gobject => }/gobjectmodule.c     |  0
 gi/module.py                          |  4 +-
 gi/{_gobject => }/pygboxed.c          |  0
 gi/{_gobject => }/pygboxed.h          |  0
 gi/{_gobject => }/pygenum.c           |  0
 gi/{_gobject => }/pygenum.h           |  0
 gi/{_gobject => }/pygflags.c          |  0
 gi/{_gobject => }/pygflags.h          |  0
 gi/pygi-argument.c                    |  3 +-
 gi/pygi-boxed.c                       |  2 +-
 gi/pygi-ccallback.c                   |  2 +-
 gi/pygi-foreign.c                     |  2 +-
 gi/pygi-info.c                        |  2 +-
 gi/pygi-marshal-to-py.c               |  3 +-
 gi/pygi-private.h                     |  2 +-
 gi/pygi-source.c                      |  3 +-
 gi/pygi-struct.c                      |  2 +-
 gi/pygi.h                             |  3 +-
 gi/{_gobject => }/pyginterface.c      |  0
 gi/{_gobject => }/pyginterface.h      |  0
 gi/{_gobject => }/pygobject-private.h |  5 ++-
 gi/{_gobject => }/pygobject.c         |  0
 gi/{_gobject => }/pygobject.h         |  0
 gi/{_gobject => }/pygparamspec.c      |  0
 gi/{_gobject => }/pygparamspec.h      |  2 +
 gi/{_gobject => }/pygpointer.c        |  0
 gi/{_gobject => }/pygpointer.h        |  0
 gi/{_gobject => }/pygtype.c           |  0
 gi/{_gobject => }/pygtype.h           |  0
 gi/types.py                           |  3 +-
 tests/Makefile.am                     |  2 +-
 39 files changed, 93 insertions(+), 148 deletions(-)

commit a329f559002f2be0898309c9d81cdf2c34aef158
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jan 14 10:15:53 2014 -0800

    tests: Fix test_torture_profile to return a number from its callback

    Return a number from rather than None from the callback passed to
    regress_test_torture_signature_2. This fixes a TypeError being
    raised in
    callback return argument marshaling which was ignored by the test
    suite.

 tests/test_everything.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a50a8386aae54dace7e46569415fdef85758fb9c
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Tue Jan 14 08:53:25 2014 +0100

    Add test for callback user data arguments with following arguments

    In this case we can't use the varargs userdata handling. Provides
    test case for
    https://bugzilla.gnome.org/show_bug.cgi?id=722104.

 tests/test_everything.py | 48
 ++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 48 insertions(+)

commit 3563a2d21a9e08a802d1cf30e04ba340e0bcfb49
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jan 13 08:19:02 2014 -0800

    valgrind: Add suppression files for python3.3 and python3.3dm

    Add new suppression files for Python 3. Use PYTHON_BASENAME for the
    suppression filename in the various make check.valgrind
    targets. Rename
    python.supp to python2.7.supp

 tests/Makefile.am                     |   6 +-
 tests/{python.supp => python2.7.supp} |   0
 tests/python3.3.supp                  | 471
 ++++++++++++++++++++++++++++++++++
 tests/python3.3dm.supp                | 471
 ++++++++++++++++++++++++++++++++++
 4 files changed, 945 insertions(+), 3 deletions(-)

commit 5c6f8afed5f6aa05d65d64509a2c9b8041a66b05
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jan 13 18:53:55 2014 -0800

    Makefile.am: Fix NEWS and ChangeLog generation under vpath builds

    Make sure NEWS generation uses top_srcdir to allow "make release-news"
    to
    work under a vpath build (directory outside the source tree).
    Update ChangeLog target to use $(top_srcdir)/missing. This fixes
    a problem
    where running "make dist" under a vpath build directory would
    include an
    empty ChangeLog.

 Makefile.am | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 056325cba3c86aefcf45ba10f2b7cf86e9fc1800
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jan 13 18:53:02 2014 -0800

    Update HACKING to include better release tagging instructions

 HACKING | 15 ++++++++-------
 1 file changed, 8 insertions(+), 7 deletions(-)

commit c0a43d259c003c5d06db23debd0675b87e805b74
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jan 13 17:20:17 2014 -0800

    configure.ac: post release version bump to 3.11.5

 NEWS         | 16 ++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 17 insertions(+), 1 deletion(-)

commit 44d003798d9d14dde16fb44c69b94a411bdee26b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jan 13 16:51:41 2014 -0800

    Fix mid-argument list callback user data expecting a tuple

    Ensure user data arguments are always packed into a tuple during
    callback
    marshaling. This fixes cases where there is mid-argument user data
    which is
    not in the form of a variable length tuple.

    https://bugzilla.gnome.org/show_bug.cgi?id=722104

 gi/pygi-marshal-from-py.c | 16 +++++++++++++++-
 1 file changed, 15 insertions(+), 1 deletion(-)

commit 415b240e3baab522f3bf9752995610f950ba609e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Oct 15 03:57:52 2013 -0700

    Remove special case GObject base class check when creating GI classes

    Replace explicit GObject.Object string name check when calculating the
    introspection class hierarchy with a more generalized technique. This
    allows
    any C based wrapper of a GType to "underride" an introspection class
    automatically. This currently only handles the case of GObject.Object,
    but
    will be used for fundamentals and GParamSpec.

    https://bugzilla.gnome.org/show_bug.cgi?id=631901

 gi/module.py | 17 +++++++++++------
 1 file changed, 11 insertions(+), 6 deletions(-)

commit 9b02b29016958791dfa9d7ebfc6c2ec44ab5690d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jan 7 09:16:54 2014 -0800

    overrides: Fix __repr__ for various Gdk structs

    Change __repr__ overrides for Gdk.Color, Gdk.RGBA, and Gdk.Atom to
    return a
    string reprentation that is valid Python given an expected
    environment.
    See: http://docs.python.org/2/reference/datamodel.html#object.__repr__

 gi/overrides/Gdk.py         | 10 +++++-----
 tests/test_atoms.py         |  7 +++++--
 tests/test_overrides_gdk.py |  9 +++++++++
 3 files changed, 19 insertions(+), 7 deletions(-)

commit f6a87935596a3b59c238a5572b288f34691b53d1
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Jan 7 07:31:22 2014 -0800

    docs: Fix array length argument skipping with preceding out arguments

    Remove split_function_info_args and use a list of all arguments for
    generating skipped index lists. Determine argument skipping based
    on the
    full argument list in each in/inout and out/inout argument list
    buildouts.
    This fixes a problem where out arguments preceding array length
    arguments
    would still show array length arguments in the docstring. This was
    due to an
    index mismatch when using split lists instead of list of all
    arguments.

 gi/docstring.py         | 38 ++++++++++++--------------------------
 tests/test_docstring.py | 37 +++++++++++++++----------------------
 2 files changed, 27 insertions(+), 48 deletions(-)

commit f114edc0a0afa64077a13459034afc4255b7a3f1
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jan 6 22:10:47 2014 -0800

    overrides: Remove GLib.Source.attach

    Remove GLib.Source.attach override now that tail end allow-none
    arguments
    default to None when not specified.

 gi/overrides/GLib.py | 5 -----
 tests/test_glib.py   | 7 +++++++
 2 files changed, 7 insertions(+), 5 deletions(-)

commit 50ab6a8b70cbe7b67fc8d804b7773bb2c9b47251
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jan 6 21:42:09 2014 -0800

    overrides: Remove Gtk overrides with tail end allow-none keywords

    Remove overrides for Widget.render_icon, TextIter.begins_tag,
    ends_tag,
    toggles_tag, and TreeModel.filter_new. These overrides added an
    optional keyword=None for allow-none arguments. This is now implicitly
    accepted by the PyGObject machinery so the overrides can go away.

 gi/overrides/Gtk.py         | 16 ----------------
 tests/test_overrides_gtk.py | 11 +++++++++++
 2 files changed, 11 insertions(+), 16 deletions(-)

commit 2d388fcfca4bf1258d01b4491b4168589f3dd2b0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jan 6 21:22:41 2014 -0800

    overrides: Remove Pango.Context.get_metrics

    Remove the override for Pango.Context and the get_metrics method. This
    can
    be done now that tail end method arguments with "allow-none"
    are implicitly
    defaulted to use None/NULL.

 gi/overrides/Pango.py         |  9 ---------
 tests/test_overrides_pango.py | 12 ++++++++++++
 2 files changed, 12 insertions(+), 9 deletions(-)

commit 43b35b1df3b6c0d8679f3cc0b08ef6ddcb276331
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Jan 6 17:35:04 2014 -0800

    Add enum and flags member methods

    Add all methods from GIEnumInfo to both enums and flags classes.

    https://bugzilla.gnome.org/show_bug.cgi?id=693099

 gi/module.py     | 2 ++
 tests/test_gi.py | 9 +++++++++
 2 files changed, 11 insertions(+)

commit 731a2cb4372084eac6cfe5bf190f6efa730e97e4
Author: Patrick Welche <prlw1@cam.ac.uk>
Date:   Mon Jan 6 22:31:48 2014 +0000

    python.m4: g/c JD_PYTHON_CHECK_VERSION

    We currently require automake 1.11.1, and its AM_PYTHON_CHECK_VERSION
    is identical (made here).

    https://bugzilla.gnome.org/show_bug.cgi?id=721662

 configure.ac |  4 ++--
 m4/python.m4 | 23 ++---------------------
 2 files changed, 4 insertions(+), 23 deletions(-)

commit aaaead18e2167c2becb309f1d9ae199222c0256b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Jan 4 16:31:56 2014 -0800

    Support union creation with PyGIStruct

    Add additional case for allowing the creation bare unions wrapped with
    PyGIStruct. This is needed because PyGIStruct wraps both GIStruct and
    GIUnion types.

 gi/pygi-struct.c         | 39 ++++++++++++++++++++++++++++++++++-----
 tests/test_repository.py | 13 +++++++++++++
 2 files changed, 47 insertions(+), 5 deletions(-)

commit 64f15961b637a7e1388bd8d2cd08f04fa20e4de4
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Jan 4 16:07:44 2014 -0800

    Fix crash in error handling when creating struct with mismatched
    info type

    Error handling code was attempting to get the PyType of a pointer to a
    pointer. Use the correct amount of indirection so an exception is
    raised as
    intended rather than a segfault.

 gi/pygi-info.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 07abf8343bbeac6f36d370ced654fa6506b22175
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jan 1 20:23:17 2014 -0800

    docs: Skip display of default constructor for disguised structs

    Structs which have zero length should now show a default constructor.
    Structs with a length should not show keyword arguments in the default
    constructor.

    https://bugzilla.gnome.org/show_bug.cgi?id=708060

 gi/docstring.py         |  9 ++++++++-
 tests/test_docstring.py | 18 ++++++++++++++++--
 2 files changed, 24 insertions(+), 3 deletions(-)

commit e8359847136e9ad76a670a382c0abc61cb4e81d3
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jan 1 19:57:06 2014 -0800

    Cleanup disguised struct constructor error and add it to boxed

    Give a cleaner error message when an attempt is made to create
    a disguised
    struct which also gives a hint to look at the pydoc. Add similar
    error to
    disguised boxed/unions.

    https://bugzilla.gnome.org/show_bug.cgi?id=647249

 gi/pygi-boxed.c          | 17 ++++++++++++++---
 gi/pygi-struct.c         |  2 +-
 tests/test_everything.py |  1 -
 tests/test_glib.py       |  4 ++++
 4 files changed, 19 insertions(+), 5 deletions(-)

commit 9ce527b09ed032f2cc83c2d83de8bb6d7b19be02
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jan 1 19:54:59 2014 -0800

    docs: List default constructor in doc strings

    Add default constructor to class docs strings as:
    Object(**properties)

    https://bugzilla.gnome.org/show_bug.cgi?id=708060

 gi/docstring.py | 10 ++++------
 1 file changed, 4 insertions(+), 6 deletions(-)

commit 9bfd73e7c3f2ec4975b3e530ba7c2cc55ee793d5
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jan 1 17:34:32 2014 -0800

    docs: List constructors in object and struct doc strings

    Add type dispatching to gi.docstring documentation generator for
    info types
    of StructInfo and ObjectInfo. Add lazy doc string generation to
    Object and Struct meta classes by using a property for __doc__. This
    lists
    available constructors immediately in all GObject.Object and Struct
    docs.
    ipython example:

    >>> Gtk.Button?
    :Constructors:
        Button(**properties)
        new()
        new_from_icon_name(icon_name:str, size:int)
        new_from_stock(stock_id:str)
        new_with_label(label:str)
        new_with_mnemonic(label:str)

    https://bugzilla.gnome.org/show_bug.cgi?id=708060

 gi/docstring.py         | 36 +++++++++++++++++++++++++++++-------
 gi/types.py             |  9 +++++++++
 tests/test_docstring.py |  8 ++++++++
 3 files changed, 46 insertions(+), 7 deletions(-)

commit 44612636575dd93c97210a7255c4490e2c84db67
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jan 1 17:10:15 2014 -0800

    docs: Cleanup PyGIBaseInfo repr

    Remove angle brackets and pointer address from
    PyGIBaseInfo.__repr__. This
    cleans up documentation and makes it easier to read.

 gi/pygi-info.c | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit 826c0e63eabac68fd665335950d311988a1405e3
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Dec 31 21:45:21 2013 -0800

    docs: Add return values and skip implicit out arguments in functions

    Add gi.CallableInfo.skip_return static binding for testing if
    the return
    value should show up in docs. Skip implicit list index arguments
    for out
    values.

    https://bugzilla.gnome.org/show_bug.cgi?id=697356

 gi/docstring.py         | 26 +++++++++++++++++++++-----
 gi/pygi-info.c          |  7 +++++++
 tests/test_docstring.py |  6 ++++++
 3 files changed, 34 insertions(+), 5 deletions(-)

commit aeccdaddf32dc7b48a79a1cd95a421a26895c9b2
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Dec 31 21:15:27 2013 -0800

    docs: Replace usage of functools.wraps with a custom version

    Using functools.wraps in overrides would cause docstring evaluation
    which
    can hurt performance during overrides loading. Add custom wraps
    decorator
    which only copies __name__ and __module__ attributes. Remove function
    wrapping used within gi.overrides.overridefunc because the wrapping
    was not
    doing anything, this preserves __doc__ ability without causing an
    eval at
    load time.

    https://bugzilla.gnome.org/show_bug.cgi?id=697356

 gi/overrides/GObject.py  |  3 +--
 gi/overrides/__init__.py | 21 ++++++++++++---------
 2 files changed, 13 insertions(+), 11 deletions(-)

commit cebf5314f195bf4bd6ee19a1da3bbb50c2c9bbd6
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Dec 31 19:42:02 2013 -0800

    docs: Move GIArgInfo.get_pytype_hint into gi.docstring

    Move the C implementation of pytype hinting into pure Python. Now that
    doc strings are lazily evaluated we can simplify this tedious bit of C
    code with Python. This is precursory work for getting return
    types into
    function doc strings.

    https://bugzilla.gnome.org/show_bug.cgi?id=697356

 gi/docstring.py          | 50 ++++++++++++++++++++++++++++++++++++++---
 gi/pygi-info.c           | 49 ----------------------------------------
 gi/pygi-type.c           | 58
 ------------------------------------------------
 gi/pygi-type.h           |  2 --
 tests/test_docstring.py  |  8 ++++---
 tests/test_repository.py |  1 -
 6 files changed, 52 insertions(+), 116 deletions(-)

commit 28a178e385e32c56910f1c430b370a8872218081
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Dec 31 17:50:36 2013 -0800

    docs: Skip implicit array length args when building function doc
    strings

    https://bugzilla.gnome.org/show_bug.cgi?id=697356

 gi/docstring.py         | 8 ++++++--
 tests/test_docstring.py | 4 ++++
 2 files changed, 10 insertions(+), 2 deletions(-)

commit 2ef59b89311529e34366d4d7aa8f8ae9a8ea6371
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Dec 31 13:41:20 2013 -0800

    gtk-demo: Avoid crash in CSS demos

    Avoid a potential crash in the CSS demos where the text editing
    buffer is
    out of sync with the last good CSS parsing buffer. In the case of CSS
    warnings, we get a parsing-error callback but no exception is raised.
    This would cause the buffers to become out of sync and accessing
    position
    information from the parsing-error section would crash the text
    editor due
    to an out of range iterator being created.

 demos/gtk-demo/demos/Css/css_basics.py      | 31
 +++++++++++++++++++++--------
 demos/gtk-demo/demos/Css/css_multiplebgs.py | 31
 +++++++++++++++++++++--------
 2 files changed, 46 insertions(+), 16 deletions(-)

commit b81f9c9b4e62d8cf589576aba8d9abbac4c80953
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Dec 31 02:05:46 2013 -0800

    gtk-demo: Add info bar and better error handling to CSS demos

    Use an info bar for displaying CSS parsing errors. Store the last good
    stylesheet text for use as a backup when a parsing error occures. This
    gives
    a seamless look while typing changes into the text editor.

    https://bugzilla.gnome.org/show_bug.cgi?id=719722

 demos/gtk-demo/demos/Css/css_basics.py      | 28
 +++++++++++++++++++++-------
 demos/gtk-demo/demos/Css/css_multiplebgs.py | 29
 ++++++++++++++++++++++-------
 2 files changed, 43 insertions(+), 14 deletions(-)

commit becb56734e13df182fd31cfe46c465477dfc4d2c
Author: Gian Mario Tagliaretti <gianmt@gnome.org>
Date:   Mon Dec 30 16:36:28 2013 +0100

    gtk-demo: Add CSS demos

    Add a couple of demos demostrating the use of CSS, the css files are
    stored into a GResource binary file compiled with
    glib-compile-resources,
    the comments in gtk-demo.py explain the usage of GResource.

    Signed-off-by: Simon Feltman <sfeltman@src.gnome.org>

    https://bugzilla.gnome.org/show_bug.cgi?id=719722

 .gitignore                                    |   1 +
 demos/gtk-demo/demos/Css/__init__.py          |   0
 demos/gtk-demo/demos/Css/css_accordion.py     |  94 +++++++++++++++
 demos/gtk-demo/demos/Css/css_basics.py        | 119 +++++++++++++++++++
 demos/gtk-demo/demos/Css/css_multiplebgs.py   | 157
 ++++++++++++++++++++++++++
 demos/gtk-demo/demos/data/brick.png           | Bin 0 -> 5043 bytes
 demos/gtk-demo/demos/data/brick2.png          | Bin 0 -> 10713 bytes
 demos/gtk-demo/demos/data/css_accordion.css   |  52 +++++++++
 demos/gtk-demo/demos/data/css_basics.css      |  22 ++++
 demos/gtk-demo/demos/data/css_multiplebgs.css | 136
 ++++++++++++++++++++++
 demos/gtk-demo/demos/data/cssview.css         |  41 +++++++
 demos/gtk-demo/demos/data/demo.gresource      | Bin 0 -> 31110 bytes
 demos/gtk-demo/demos/data/demo.gresource.xml  |  18 +++
 demos/gtk-demo/demos/data/reset.css           |  68 +++++++++++
 demos/gtk-demo/gtk-demo.py                    |  16 ++-
 15 files changed, 723 insertions(+), 1 deletion(-)

commit 2ff095ea0b0c05fbf6cc332eeadf26cfeb9e69f7
Author: Colin Watson <cjwatson@ubuntu.com>
Date:   Tue Dec 24 22:19:02 2013 +0000

    build: Avoid clash between gi/types.py and stdlib

    Use non-recursive make for the Python modules in gi/ to work around a
    clash between gi/types.py and the standard library's types module when
    running py-compile.

    https://bugzilla.gnome.org/show_bug.cgi?id=721025

    Signed-off-by: Martin Pitt <martinpitt@gnome.org>

 Makefile.am    | 24 ++++++++++++++++++++++++
 gi/Makefile.am | 20 ++------------------
 2 files changed, 26 insertions(+), 18 deletions(-)

commit b9716853fb7727fcf2b5ea59a3368d5a5b2e6be2
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Dec 16 04:17:28 2013 -0800

    configure.ac: post-release bump to 3.11.4

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2ec00c2563bebff1e55faf97c67e44fda862ad5b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Dec 16 04:10:54 2013 -0800

    release 3.11.3

 NEWS | 4 ++++
 1 file changed, 4 insertions(+)

commit 7fb55f93e207378992cd9f3e0663604a4de2213f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Dec 12 01:35:11 2013 -0800

    Replace usage of PyGIBoxed_Type with PyGIStruct_Type

    Remove empty definition of PyGIBoxed_Type and use PyGIStruct_Type
    in its
    place for GI_INFO_TYPE_BOXED based infos in repositories. As noted in
    the docs: "GI_INFO_TYPE_BOXED boxed, see GIStructInfo or GIUnionInfo"
    we can use the GIStructInfo API for boxed types because we also
    dispatch
    base classes on GType checks as seen in:
    https://git.gnome.org/browse/pygobject/tree/gi/module.py?id=3.11.2#n186
    This fixes some of the issues noted in bug 581525.

    https://bugzilla.gnome.org/show_bug.cgi?id=581525

 gi/pygi-info.c | 13 +------------
 1 file changed, 1 insertion(+), 12 deletions(-)

commit b3c85eec75c62c138c136531ebe49a33351941f0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Nov 17 20:12:50 2013 -0800

    configure.ac: post release version bump to 3.11.3

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d1314af8f237a634dbfefb0a1c319f910d3d8765
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Nov 17 20:04:49 2013 -0800

    release 3.11.2

 NEWS | 6 ++++++
 1 file changed, 6 insertions(+)

commit 6fc3d977f17397e514aed492055e93d03c410f60
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Nov 12 23:04:50 2013 -0800

    gtk-demo: Fix pyflakes error after recent commit

 demos/gtk-demo/demos/pixbuf.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a309b3baf5ee99139cc2d1817339233e24391bc2
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Nov 12 18:41:35 2013 -0800

    gkt-demo: Change main info/source notebook into a GtkStack

    Use the new in 3.10 GtkStack and GtkStackSwitcher for switching
    between Info
    and Source tabs. Beyond giving a newer look and feel to the demo,
    this also
    provides an example for how to use a GtkStack.

 demos/gtk-demo/gtk-demo.py | 23 +++++++++++++++++------
 1 file changed, 17 insertions(+), 6 deletions(-)

commit 69ff43bf6292fb3ddaea027cfc595139c4f1655d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Nov 12 19:32:18 2013 -0800

    gtk-demo: Cleanup deprecated calls throughout demo code

    Specify constructor arguments as keyword args for various object
    creation calls. Update combobox demo to use bind_property instead
    of manual
    signal connections with update callbacks.

 demos/gtk-demo/demos/Entry/entry_buffer.py         |  6 ++---
 demos/gtk-demo/demos/Entry/entry_completion.py     |  6 ++---
 demos/gtk-demo/demos/Entry/search_entry.py         |  8 +++---
 demos/gtk-demo/demos/Tree View/liststore.py        |  8 +++---
 .../gtk-demo/demos/Tree View/treemodel_filelist.py |  2 +-
 .../gtk-demo/demos/Tree View/treemodel_filetree.py |  2 +-
 demos/gtk-demo/demos/appwindow.py                  |  4 +--
 demos/gtk-demo/demos/combobox.py                   | 30
 +++-------------------
 demos/gtk-demo/demos/dialogs.py                    | 26
 +++++++++----------
 demos/gtk-demo/demos/expander.py                   |  9 +++----
 demos/gtk-demo/demos/images.py                     |  2 +-
 demos/gtk-demo/demos/infobars.py                   | 23 +++++++++--------
 demos/gtk-demo/demos/links.py                      | 10 ++++----
 demos/gtk-demo/demos/menus.py                      |  4 +--
 demos/gtk-demo/demos/pickers.py                    |  8 +++---
 demos/gtk-demo/demos/pixbuf.py                     |  4 +--
 demos/gtk-demo/demos/rotatedtext.py                |  2 +-
 17 files changed, 64 insertions(+), 90 deletions(-)

commit 890fb7b97823985d5c800284ead43a49174db244
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Nov 12 18:19:34 2013 -0800

    Revert TreeStore and ListStore initializer replacements

    Revert changes to Tree/ListStore where the __init__ overrides were
    replaced
    with __new__ overrides which accept column types directly. The
    issue with
    the change is sub-classes of these types can override __init__
    themself
    passing in their own column types to the super class. These
    sub-classes
    expect the super class to handle column type setup via __init__
    and hence
    the change described is an API break. This reverts parts of commit:
    2f2069c9efcd8f312ce9ffa572df371fbc08822d

 gi/overrides/Gtk.py | 10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit 795201873a3aae530598f5e16470b6a8d2d55c23
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 15 20:01:48 2013 -0700

    Deprecate Gdk.Cursor constructor dispatching

    Give deprecation warning for the overridden __new__ method on
    Gdk.Cursor when more than one argument is used. Recommend using
    Gdk.Cursor.new_for_display, new_from_pixbuf, and new_from_pixmap
    instead.

    https://bugzilla.gnome.org/show_bug.cgi?id=705810

 gi/overrides/Gdk.py         | 48
 ++++++++++++++++++++++++++-------------------
 tests/test_overrides_gdk.py | 17 ++++++++++++----
 2 files changed, 41 insertions(+), 24 deletions(-)

commit 2f2069c9efcd8f312ce9ffa572df371fbc08822d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 15 19:23:18 2013 -0700

    Cleanup overzealous new and init implementations

    Remove PyGObject initializer code attempting to set properties on
    GObjects that have already been created. There were a number of
    overridden __new__ and __init__ methods that stripped away
    arguments before calling the base class to work around attempted
    property sets and argument count errors (fixing the symptom not
    the problem).
    Use Gtk.ListStore/TreeStore.new with __new__ override instead
    of __init__ with set_column_types.

    https://bugzilla.gnome.org/show_bug.cgi?id=705810

 gi/_gobject/gobjectmodule.c | 35 ++++++++++++++---------------------
 gi/_gobject/pygobject.c     | 16 ++++++++++++++--
 gi/overrides/GObject.py     |  3 ---
 gi/overrides/Gdk.py         | 15 ---------------
 gi/overrides/Gtk.py         | 11 ++++-------
 gi/overrides/Pango.py       |  5 -----
 gi/pygi-boxed.c             |  6 ------
 7 files changed, 32 insertions(+), 59 deletions(-)

commit 86a37d67455dc5d435ade35f17b27c5de2b288f5
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Aug 13 18:02:54 2013 -0700

    Add deprecation warnings and cleanup class initializer overrides

    Print deprecation warnings for calls to class initializers which
    don't explicitly specify keywords. Print deprecation warning
    for overrides that have renamed keywords (Gtk.Table.rows should
    be n_rows). Additionally deprecate non-standard defaults with
    initializers (Gtk.SizeGroup.mode defaults to HORIZONTAL in GTK+
    and VERTICAL in PyGI).
    Remove AboutDialog override because it doesn't do anything.

    https://bugzilla.gnome.org/show_bug.cgi?id=705810

 gi/overrides/Gio.py         |   6 +-
 gi/overrides/Gtk.py         | 367
 ++++++++++++++++++++++----------------------
 gi/overrides/__init__.py    |  88 +++++++++++
 tests/test_gi.py            |  75 +++++++++
 tests/test_overrides_gtk.py |  95 ++++++++----
 5 files changed, 411 insertions(+), 220 deletions(-)

commit d2e9be8e2b3d21b55e1aad3d0b22dcff3421b702
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Aug 13 17:42:11 2013 -0700

    tests: Use explicit keywords args when calling initializers

    Replace all usage of GObject creation that relies on positional
    arguments from overrides. Positional initializer args will be
    deprecated, updating the tests as a first pass proves backwards
    and forwards compatibility of the deprecation.

    https://bugzilla.gnome.org/show_bug.cgi?id=705810

 tests/test_overrides_gtk.py | 107
 +++++++++++++++++++++++---------------------
 1 file changed, 55 insertions(+), 52 deletions(-)

commit 8342302dac9bf3fcb49ec3ac334dbf014b4db025
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Nov 12 03:46:08 2013 -0800

    Revert "Add type checking to positional Gtk.Box and Gtk.Window
    ctor arguments"

    This reverts commit 7193f0509a0ed7da7c810daa6733e34a22db3180.

 gi/overrides/Gtk.py         |  7 -------
 tests/test_overrides_gtk.py | 18 ------------------
 tests/test_properties.py    |  9 ---------
 3 files changed, 34 deletions(-)

commit 1f37340c4623262a2146ec8cd25b487cdf4234bd
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Nov 10 03:26:10 2013 -0800

    Fix dir method for static GParamSpec in Python 3

    Add a __dir__ method which lists GParamSpec attributes and remove
    code from
    getattr which made use of the deprecated __members__ technique for dir
    (removed in Python 3). This makes dir(pspec) work again in Python 3.

 gi/_gobject/pygparamspec.c | 218
 ++++++++++++++++++++++++---------------------
 tests/test_gi.py           |  10 +++
 2 files changed, 126 insertions(+), 102 deletions(-)

commit 7193f0509a0ed7da7c810daa6733e34a22db3180
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Tue Nov 5 15:28:12 2013 +0100

    Add type checking to positional Gtk.Box and Gtk.Window ctor arguments

    Gtk.Box and Gtk.Window are base classes of a lot of widgets. Avoid
    confusion
    when trying to create a subclass of them through the GObject
    constructor with
    positional arguments by at least verifying that their type is
    right. Otherwise
    you can do things like

      chooser = Gtk.FileChooserWidget(Gtk.FileChooserAction.SELECT_FOLDER)

    which succeeds, but does not have the desired effect (it sets the
    "homogenous"
    property of the Gtk.Box superclass instead).

    https://bugzilla.gnome.org/show_bug.cgi?id=711487

 gi/overrides/Gtk.py         |  7 +++++++
 tests/test_overrides_gtk.py | 18 ++++++++++++++++++
 tests/test_properties.py    |  9 +++++++++
 3 files changed, 34 insertions(+)

commit 79aea2655db11bc9d2c0ad75c87862b2b66da594
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Nov 4 03:29:57 2013 -0800

    Remove overzealous argument checking for callback userdata

    Remove check which ensures userdata is None if the callback is None.
    This check would need to become more complicated with recent
    versions of
    PyGObject where userdata can be variable (would also need to check
    against
    a tuple containing None). Instead of adding more complex checking,
    simply
    remove the checking as it is unnecessary to begin with.

    https://bugzilla.gnome.org/show_bug.cgi?id=711173

 gi/pygi-marshal-from-py.c   |  7 -------
 tests/test_overrides_gtk.py | 11 +++++++----
 2 files changed, 7 insertions(+), 11 deletions(-)

commit f32d649b72f865e32cc2b62a54d927b8345da0c8
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Mon Oct 28 16:00:57 2013 +0100

    configure.ac: post-release bump to 3.11.2

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5bcdb56433d0ba2976f05946c6c5b6ffe3e84901
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Mon Oct 28 15:59:51 2013 +0100

    release 3.11.1

 NEWS | 27 +++++++++++++++++++++++++++
 1 file changed, 27 insertions(+)

commit 65b8f7bd77474e361c80905ec23de6dbde27970c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Oct 27 22:09:27 2013 -0700

    Fix toggleref safety problems by always enabling the GIL

    Call PyEval_InitThreads for the base gi module import. This forces the
    Python internals create the GIL and always support threading with the
    various thread state enter/exit funcs. This is needed since we cannot
    predict which GI repositories might accept Python callbacks and run
    them in
    non-Python threads or trigger toggle ref notifications in a thread
    other
    than main.

    https://bugzilla.gnome.org/show_bug.cgi?id=709223

 gi/__init__.py       |  2 --
 gi/gimodule.c        | 18 +++++++-----------
 gi/overrides/GLib.py |  8 ++------
 3 files changed, 9 insertions(+), 19 deletions(-)

commit 57195c9c864bc25521bb3cb98286e6d6f0645652
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Oct 27 16:02:13 2013 -0700

    Add consistent GLib.MainLoop SIGINT cleanup

    Remove auto cleanup of SIGINT source handling by returning True
    from the
    signal callback. This gives the __del__ method consistent cleanup
    semantics
    regardless of whether or not a SIGINT occurred.

    https://bugzilla.gnome.org/show_bug.cgi?id=710978

 gi/overrides/GLib.py | 4 ++++
 1 file changed, 4 insertions(+)

commit 1c03ebba9598e7b6d5293889f46b015bfac3611c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Oct 27 15:16:09 2013 -0700

    tests: Fix source testing to handle critical with non-existing sources

    Silence new critical coming from g_source_remove on non-existing
    sources.
    This function still returns False, but we need to silence the new
    critical
    so the test suite doesn't fail. See bug 710724.

    https://bugzilla.gnome.org/show_bug.cgi?id=710978

 tests/test_source.py | 18 ++++++++++++------
 1 file changed, 12 insertions(+), 6 deletions(-)

commit ac776da7e56b78a2fa422487f0ef0d8771bcb78f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Jul 28 00:01:35 2013 -0700

    docs: Add a keyword value of None for allow-none annotations

    Update documentation generator for allow-none arguments and
    user_data arguments to show a keyword value of None.
    Add skip for GDestroyNotify closure arguments.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/docstring.py         | 20 +++++++++++++++++---
 tests/test_docstring.py | 10 ++++++++++
 2 files changed, 27 insertions(+), 3 deletions(-)

commit e1bf9c069644ea0bff0c6a7efa72a285e122a414
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 19 19:03:12 2013 -0700

    Remove overrides for supporting pre-3.10 GObject signal functions

    Remove GObject override code for supporting pre-3.10 signal functions
    which
    annotate the object argument as "gpointer". With PyGObject 3.11
    having a
    dependency on GObject 3.10, clear the special case overrides out.

 gi/overrides/GObject.py | 76
 ++++++-------------------------------------------
 1 file changed, 9 insertions(+), 67 deletions(-)

commit 0c308de528c402f67808b13760ca30d55d4c99d7
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 18 17:15:06 2013 -0700

    Add threads_init back as a requirement for non-Python threaded repos

    Re-add a "threads_init" function to gi for explicit intialization
    of Python
    threading support. This was marked as deprecated in the previous cycle
    because using Python threads already initializes everything.
    However, we still need an explicit initalization when using
    repositories
    with non-Python threads which may interact with Python callbacks
    (GStreamer).

    https://bugzilla.gnome.org/show_bug.cgi?id=710447

 gi/__init__.py       |  2 ++
 gi/gimodule.c        | 10 ++++++++++
 gi/overrides/GLib.py | 11 +++++++----
 3 files changed, 19 insertions(+), 4 deletions(-)

commit a2fa531b4dee73c193cac92fa3e870808688b5d7
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Oct 14 20:38:13 2013 -0700

    Add dir method to GObject props accessor

    Remove special case __members__ attribute from the props accessor
    objects getattr method. This has been deprecated since Python 2.3 and
    removed in Python 3. Replace this with a __dir__ method making use
    of the
    old members list building code. Additionally fix error where the
    GObjectClass was being unref'd too many times when using
    dir(Object.props),
    causing a GLib critical.

    https://bugzilla.gnome.org/show_bug.cgi?id=705754

 gi/_gobject/pygobject.c | 29 +++++++++++++++++++++--------
 tests/test_gi.py        | 14 ++++++++++++++
 2 files changed, 35 insertions(+), 8 deletions(-)

commit 799989ada2f6b1d729f078f204445651c808a2c7
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri May 3 04:37:13 2013 -0700

    Remove PyGObjectWeakRef now that g_binding_unbind exists

    Remove the static code for managing GBinding weak references now
    that GLib
    has a method (unbind) for clearing out bindings.

    https://bugzilla.gnome.org/show_bug.cgi?id=699571

 gi/_gobject/pygobject.c | 59
 +------------------------------------------------
 gi/overrides/GObject.py | 19 ++++++++++++++++
 tests/test_gobject.py   | 41 ++++++++++++++++++++--------------
 3 files changed, 44 insertions(+), 75 deletions(-)

commit fe217e0afbd63f05285e59628533f351896377d9
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Oct 9 00:34:37 2013 -0700

    Fix GArray, GList, GSList, and GHashTable marshaling leaks

    Remove calling of cleanup code for transfer-everything modes by
    ensuring
    cleanup_data is set to NULL in from_py marshalers. Use array and hash
    table ref/unref functions for container transfer mode to ensure we
    have a
    valid container ref after invoke and during from_py cleanup of
    contents.
    Rework restrictions with to_py marshaling cleanup so we always
    unref the
    container for transfer-everything and transfer-container modes.

    https://bugzilla.gnome.org/show_bug.cgi?id=693402

 gi/pygi-marshal-cleanup.c | 54 +++++++++++----------------------
 gi/pygi-marshal-from-py.c | 77
 ++++++++++++++++++++++++++++++++++++++++-------
 2 files changed, 84 insertions(+), 47 deletions(-)

commit 7407367f424595c2780a2d6a47d936ad0bd91735
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Oct 7 14:11:39 2013 -0700

    Add cleanup_data argument used for Python to C marshaler cleanup

    Add a new output argument to all from_py marshalers which is used for
    keeping track of marshaling data that later needs cleanup. Previously
    most
    marshalers would rely on the GIArgument->v_pointer as the means
    for data
    cleanup. However, this pointer would get clobbered in the case of
    bi-directional arguments (inout) and the memory lost.
    Use the new cleanup_data for storing temporarily wrapped C arrays
    so we
    don't need to re-calculate the length argument during cleanup.

    Additionally delay the from_py marshaling cleanup function until after
    _invoke_marshal_out_args is called. This gives inout arguments
    which don't
    modify the pointer sufficient time to exist until they marshaled
    back to
    Python (gi_marshalling_tests_gvalue_inout).

    https://bugzilla.gnome.org/show_bug.cgi?id=693402

 gi/pygi-argument.c            |   4 +-
 gi/pygi-cache.h               |   3 +-
 gi/pygi-invoke-state-struct.h |   7 +-
 gi/pygi-invoke.c              |  20 +++---
 gi/pygi-marshal-cleanup.c     |  43 +++++-------
 gi/pygi-marshal-from-py.c     | 160
 ++++++++++++++++++++++++++++--------------
 gi/pygi-marshal-from-py.h     |  45 ++++++++----
 7 files changed, 177 insertions(+), 105 deletions(-)

commit 9456e83233a927f1f01c6ffcb1f07c62b491a1df
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Aug 7 12:08:15 2013 -0700

    Add support for variable user data arguments

    Support a variable number of user data arguments for all callback
    connection function where the user data is the last explicit argument.
    This adds convience as well as consistency with the rest of PyGObject.
    Cleanup overrides for GLib.idle_add, timeout_add, timeout_add_seconds,
    io_add_watch, and child_watch_add which manually implemented this
    feature.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/overrides/GLib.py      | 75
 +++++++++++++++--------------------------------
 gi/pygi-cache.c           | 14 +++++++++
 gi/pygi-cache.h           |  3 ++
 gi/pygi-closure.c         | 37 +++++++++++++++--------
 gi/pygi-invoke.c          | 71
 +++++++++++++++++++++++++++++++-------------
 gi/pygi-marshal-from-py.c |  5 ++++
 tests/test_everything.py  | 32 ++++++++++++++++++++
 tests/test_glib.py        | 21 +++++++++++++
 tests/test_subprocess.py  |  8 ++---
 9 files changed, 177 insertions(+), 89 deletions(-)

commit ba4a0a65bf9ec44c3b9449f63d63035bff75d8df
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Mon Oct 14 12:57:04 2013 +0200

    Bump glib and g-i dependencies to latest stable.

    glib 2.38 and g-i 1.38 are from stable GNOME 3.10 which we now
    assume as
    minimal version.

    Drop @unittest.skipUnless tags from tests which didn't work with
    g-i 1.36.

 README           | 3 ++-
 configure.ac     | 6 +++---
 tests/test_gi.py | 2 --
 3 files changed, 5 insertions(+), 6 deletions(-)

commit 2a5ad2af6bc91b187a2f07fc8d001ec7ad618adf
Author: Nuno Araujo <nuno.araujo@russo79.com>
Date:   Fri Oct 11 18:41:48 2013 +0200

    Fix TypeError when setting drag target_list to None

    When calling Widget.drag_dest_set_target_list(None) or
    Widget.drag_source_set_target_list(None)
    a "TypeError: 'NoneType' object is not iterable" is thrown.

    According to Gtk documentation [1] [2], this shouldn't be the case
    since client code should be
    able to pass NULL in calls made to gtk_drag_dest_set_target_list and
    gtk_drag_source_set_target_list.

    We now check if the target_list is None and do not try to create a
    TargetList if it is the case.

    [1]
    https://developer.gnome.org/gtk3/3.10/gtk3-Drag-and-Drop.html#gtk-drag-dest-set-target-list
    [2]
    https://developer.gnome.org/gtk3/3.10/gtk3-Drag-and-Drop.html#gtk-drag-source-set-target-list

    https://bugzilla.gnome.org/show_bug.cgi?id=709926

 gi/overrides/Gtk.py         | 4 ++--
 tests/test_overrides_gtk.py | 2 ++
 2 files changed, 4 insertions(+), 2 deletions(-)

commit 27e9f6ede021fc58e952491b67d69c2a5cdd6acb
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Oct 1 17:09:39 2013 -0700

    Use qdata for wrapper retrieval in toggle reference notifications

    Replace usage of user data holding PyGObject wrappers in toggle ref
    notifications with GObject qdata retrieval. This fixes thread
    safety issues
    where a toggle notify may be called from another thread during
    the PyGObject
    wrappers dealloc. In this case the toggle notify is blocked because
    the GIL
    is held in dealloc, and when it continues, the user data would be
    holding an
    invalid PyGObject wrapper. Using qdata solves this by ensuring
    the wrapper
    retrieval is done within the safety of the GIL and may turn up
    as NULL.

    https://bugzilla.gnome.org/show_bug.cgi?id=709223

 gi/_gobject/pygobject.c | 21 ++++++++++++++-------
 1 file changed, 14 insertions(+), 7 deletions(-)

commit 55d925d5f0fb87464b1f391c325c1e70da10d33d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Oct 10 16:10:16 2013 -0700

    Add expected failure to deal with fixes in gimarshallingtests.c

    Fix test_object_full_inout based on newer gimarshallingtests.c >
    1.38.0.
    Add expectedFailure to deal with previous versions of
    gimarshallingtests.c.

    https://bugzilla.gnome.org/show_bug.cgi?id=709796

 tests/test_gi.py | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit d866d422cc39b229f443dd08a3ea50cb3f7df8e6
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Oct 7 01:17:08 2013 -0700

    Fix memory leaks for inout array arguments

    Add tracking for array allocations to from_py marashalers in the
    argument states extra data (arg_data). This is then used later
    for inout
    marshaling cleanup to call the array cleanup function.

    https://bugzilla.gnome.org/show_bug.cgi?id=693402

 gi/pygi-invoke.c          |  1 +
 gi/pygi-marshal-cleanup.c |  1 +
 gi/pygi-marshal-from-py.c | 13 +++++++++----
 3 files changed, 11 insertions(+), 4 deletions(-)

commit 31263ac117027446c8e2fd1b56d7e348384aabef
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Oct 6 21:54:15 2013 -0700

    Fix to Python marshaling leaks for arrays holding GVariants

    Add early check for array items holding pointers and simply assign the
    pointer to GIArgument.v_pointer prior giving it to the per-item
    marshaler.
    This simplifies marshaling and fixes leaks regarding arrays of
    GVariants by
    removing the unneeded g_variant_ref_sink (variants are always
    pointers).
    Conditionalize the use of g_variant_ref_sink based on transfer mode
    in the
    per-item marshaler. This fixes a reference leak where we are given
    ownership
    of the variant (transfer full) but added a new ref anyway.

    https://bugzilla.gnome.org/show_bug.cgi?id=693402

 gi/pygi-marshal-to-py.c | 34 ++++++++++++++++++----------------
 1 file changed, 18 insertions(+), 16 deletions(-)

commit c9580ce1156789221aa19b00c7aab404db5431b5
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Oct 6 04:26:18 2013 -0700

    Cleanup per-item array marshaling code for flat arrays

    Add an early per-item check which tests if the item being marshaled
    is a
    pointer and simply copies the pointer into the array. This takes
    care of the
    GdkAtom and GVariant special cases because these items are always
    reported
    as pointers.
    Fix error condition cleanup code when an item fails marshaling in
    the middle
    of an array.

    https://bugzilla.gnome.org/show_bug.cgi?id=693402

 gi/pygi-marshal-from-py.c | 87
 +++++++++++++++++++++--------------------------
 tests/test_gi.py          | 32 +++++++++++++++++
 2 files changed, 71 insertions(+), 48 deletions(-)

commit 4623caa71c54958ab821db27a9eff2790acb3975
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Oct 5 17:00:54 2013 -0700

    Fix GValue array marshaling leaks and crash fallout

    * Decrement references for results of PySequence_GetItem. There were
    a few
    places we were not decrementing the Python reference, leaking
    the value.
    * Add tracking of Python arguments with recursive marshaling
    cleanup. This
    allows arrays of GValues which have been coerced from Python types
    to be
    properly free'd (also fixes bug 703662).
    * Use g_variant_ref for variant arguments marked as transfer
    everything.
    This fixes double free's caused by the decrementing of
    PySequence_GetItem
    results.

    https://bugzilla.gnome.org/show_bug.cgi?id=693402

 gi/pygi-cache.h           |  1 +
 gi/pygi-invoke.c          |  1 +
 gi/pygi-marshal-cleanup.c | 50
 +++++++++++++++++++++++++++++++++++++++++------
 gi/pygi-marshal-cleanup.h | 14 +++++++++++++
 gi/pygi-marshal-from-py.c | 20 ++++++++++++++++---
 gi/pygi-marshal-to-py.c   |  1 +
 6 files changed, 78 insertions(+), 9 deletions(-)

commit 549f849ef8854352483657df3d7558688a4b0007
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Sep 28 00:26:28 2013 -0700

    Refactor GLib.io_add_watch to make it more testable

    Break the argument munging code into a separate function which
    can be tested in isolation of adding an io watch.
    Add additional failing test which specifies all args as keywords
    which we eventually need to support for consistency with the
    rest of PyGObject.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/overrides/GLib.py | 23 ++++++++++++++++++-----
 1 file changed, 18 insertions(+), 5 deletions(-)

commit bc780ed17bc4cc62959c63c3f0142161a924679f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Sep 27 20:59:45 2013 -0700

    Refactor GLib.child_watch_add to make it more testable

    Break the argument munging code into a separate function which
    can be tested in isolation of adding a child watch. Update tests
    to reflect this. Add additional failing test which specify
    all args as keywords which we eventually need to support for
    consistency with the rest of PyGObject.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/overrides/GLib.py     | 25 +++++++++-----
 tests/test_subprocess.py | 88
 +++++++++++++++++++++---------------------------
 2 files changed, 56 insertions(+), 57 deletions(-)

commit 73c6213e8b47fa7c4c2c7a517fe7b56126145888
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Sep 26 19:05:20 2013 -0700

    Don't pass None to callbacks when user data is not specified

    For APIs which support a callback and optional user data,
    don't pass the user data to the callback if it was not explicitly
    specified when the callback was connected.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/pygi-closure.c         | 17 ++++++++++++++---
 gi/pygi-marshal-from-py.c |  5 -----
 tests/test_everything.py  |  7 ++-----
 3 files changed, 16 insertions(+), 13 deletions(-)

commit a76b06179cdca43f1c7d1feb8e2563e3d884a8ff
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 4 17:27:47 2013 -0700

    Add missing methods on PyGIBaseInfo and sub-classes

    Expose all methods of GIBaseBase info and its sub-classes.

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 gi/_glib/pyglib-python-compat.h |   1 +
 gi/pygi-info.c                  | 550
 +++++++++++++++++++++++++++++++++++++++-
 tests/test_repository.py        | 134 ++++++++++
 3 files changed, 677 insertions(+), 8 deletions(-)

commit e190eb75093e8bf36190dc1beb18d1c1b95b9582
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 4 13:46:36 2013 -0700

    Expose all GI enum and flags types

    Add new types for GIDirection, GITransfer, GIArrayType, GIScopeType,
    GIVFuncInfoFlags, GIFieldInfoFlags, GIFuncitonInfoFlags, GITypeTag,
    and
    GInfoType. These types are found in the gi._gi module exposed
    without the
    "GI" prefix and contain all of their values as class attributes. e.g.
    gi._gi.Transfer.EVERYTHING.

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 gi/docstring.py          |  10 ++--
 gi/pygi-info.c           | 150
 ++++++++++++++++++++++++++++++++++++++++++++---
 tests/test_repository.py |  13 +++-
 3 files changed, 158 insertions(+), 15 deletions(-)

commit 0120af6c418d0f67f39c02a4e8327813645b97f4
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 4 13:42:34 2013 -0700

    Avoid calling g_base_info_get_name on GI_INFO_TYPE_TYPE

    Calling g_base_info_get_name on infos tagged with GI_INFO_TYPE_TYPE
    will
    cause a crash. Avoid this by adding _safe_base_info_get_name and
    using that
    throughout the bindings.
    Logged GI bug as: https://bugzilla.gnome.org/show_bug.cgi?id=709456

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 gi/pygi-info.c | 35 +++++++++++++++++++++++++----------
 1 file changed, 25 insertions(+), 10 deletions(-)

commit c86b2fe8d01070f06c45fffd910d890afba1313a
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 4 13:41:08 2013 -0700

    Add GIBaseInfo.equal method

    Break PyGIBaseInfo rich compare into two methods: equal and
    richcompare.
    Equal is a direct exposure of the GI method and richcompare makes
    use of
    this with additional support for Pyton "==" and "!=" operators.

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 gi/pygi-info.c           | 32 ++++++++++++++++++++++++--------
 tests/test_repository.py |  1 +
 2 files changed, 25 insertions(+), 8 deletions(-)

commit e7b758badd0ab0b147117859f7871c39fb5399c1
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 4 13:36:11 2013 -0700

    Move info string retrieval into generic function

    Add get_info_string for sharing binding of simple string retrieval on
    GIBaseInfo objects.

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 gi/pygi-info.c | 15 +++++++++++++--
 1 file changed, 13 insertions(+), 2 deletions(-)

commit d2aef364de778da966bc1cfffe184d649f9ebb21
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Sep 24 06:26:17 2013 -0700

    Move child info retrieval into generic function

    Add a generic function for bindings which return a single child info.
    This trivializes binding methods like PyGIObjectInfo.get_parent and
    fixes leaks in PyGIObjectInfo.get_class_struct and
    PyGIVFuncInfo.get_invoker.

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 gi/pygi-info.c | 56
 +++++++++++++++++++++++---------------------------------
 1 file changed, 23 insertions(+), 33 deletions(-)

commit cdd03a2b0baef19797a5b55c2880e5b7acf1dd93
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Sep 24 02:52:22 2013 -0700

    Move info tuple retrieval into generic function

    Create new generic function for retrieving a tuple of child infos.
    This greatly simplifies all the bindings which return tuples from
    a common pattern of functions on GIBaseInfo based instances.

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 gi/pygi-info.c | 469
 ++++++++-------------------------------------------------
 1 file changed, 59 insertions(+), 410 deletions(-)

commit 62f185bef20b42f18290a3cf1d3b19dddc957f8a
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Oct 6 16:41:37 2013 -0700

    tests: Update check.valgrind with always-malloc and add logging
    options

    Based on notes in https://wiki.gnome.org/Valgrind we need to use
    always-malloc for valgrind runs.
    Add check.valgrindlog and check.valgrindxml which output valgrind
    logs into
    an ignored local tmp. Output logs are named <head-sha>-$TEST_NAMES.log
    so we
    can track commits and use diff tools on the logs.

 .gitignore        |  1 +
 Makefile.am       |  6 ++++++
 tests/Makefile.am | 10 +++++++++-
 3 files changed, 16 insertions(+), 1 deletion(-)

commit 314c933626c4dc5fc585d0e5b6c45ddb17c2e52f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 4 20:43:02 2013 -0700

    Move existing repository tests into test_repository

    Move flags and enum double registration tests into test_repository.py.
    Remove duplicate ObjectInfo tests from test_gi.py.

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 tests/test_gi.py         | 38 --------------------------------------
 tests/test_repository.py | 28 ++++++++++++++++++++++++++++
 2 files changed, 28 insertions(+), 38 deletions(-)

commit 31840888c8948aab78041da93c329572f3aabb64
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 4 17:31:21 2013 -0700

    Add unittests for GIRepository

    Add basic unittests for the existing classes and methods exposed for
    the GIRepository module (gi._gi).

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 tests/Makefile.am        |   1 +
 tests/test_repository.py | 170
 +++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 171 insertions(+)

commit 4408f83be70e92c5e3943f5ce85c551e7f2c87d0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 4 15:50:05 2013 -0700

    Derive SignalInfo info from CallableInfo

    Change Python class derivation of PyGISignalInfo to use
    PyGICallableInfo as
    the base class. This accurately reflects the GI class layout and
    provides
    the callable information for signals.

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 gi/pygi-info.c | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit b01daba04ff001b9e63d343938e879d339d9a98c
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Oct 4 15:48:05 2013 -0700

    Use PYGLIB_PyLong_FromLong for GIDirection return

    https://bugzilla.gnome.org/show_bug.cgi?id=709008

 gi/pygi-info.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d644cbd0c0ad85142286754838db848c4eb1707f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Oct 3 19:25:34 2013 -0700

    Fix memory leak for caller allocated GValue out arguments

    Swizzle the order of type checks in _cleanup_caller_allocates so
    G_TYPE_VALUE arguments are checked before G_TYPE_BOXED. The
    ordering is
    important because G_TYPE_VALUE is a sub-type of boxed and so its
    specialized
    cleanup code was never being called (g_value_unset).
    Additionally update check to use g_type_is_a instead of a compare
    to handle
    the potential case of a G_TYPE_VALUE sub-type.

    https://bugzilla.gnome.org/show_bug.cgi?id=709397

 gi/pygi-marshal-cleanup.c | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit 510789d52e9e2fd863d26613f3282364eb175601
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Jul 28 14:44:51 2013 -0700

    Add support for default arguments annotated with allow-none

    Support default value of NULL for tail end arguments which are
    marked with allow-none.
    The implementation uses a place holder object for un-supplied
    arguments
    which are annotated with allow-none. This is then used later during
    marshaling to supply NULL as the default.
    Additionally support an implicit default for callback user_data
    using the same technique.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/gimodule.c             |   6 +++
 gi/pygi-cache.c           | 103
 ++++++++++++++++++++++++++++++----------------
 gi/pygi-cache.h           |   8 ++++
 gi/pygi-invoke.c          |  42 +++++++++++++------
 gi/pygi-marshal-from-py.c |   5 +++
 gi/pygi.h                 |   1 +
 tests/test_everything.py  |  16 +++++++
 tests/test_gi.py          |  30 ++++++++++++++
 8 files changed, 162 insertions(+), 49 deletions(-)

commit 03f531ffb1adde0c48e98f92bd92f79416654fbe
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 2 22:27:10 2013 -0700

    cache refactoring: Move arg cache field assignments into
    _arg_cache_new

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/pygi-cache.c | 23 +++++++++++------------
 1 file changed, 11 insertions(+), 12 deletions(-)

commit cb7e7311bff57eb4c79c7772b6db4d00084656bb
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 2 20:27:02 2013 -0700

    cache refactoring: Cleanup array length argument marshaling

    Add shared function: _arg_cache_array_len_arg_setup for use
    with both to and from array marshaling setup. This function
    consolidates all of the edge cases regarding array length setup
    and removes the need for flagging arguments with
    PYGI_META_ARG_TYPE_CHILD_NEEDS_UPDATE.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/pygi-cache.c | 145
 +++++++++++++++++++++++++++-----------------------------
 gi/pygi-cache.h |   5 --
 2 files changed, 71 insertions(+), 79 deletions(-)

commit c9d8639401ae82977e960de44d80b94a501a2184
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sat Aug 3 00:26:11 2013 -0700

    cache refactoring: Move variable declarations to blocks where they
    are used

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/pygi-cache.c | 25 ++++++++++++++-----------
 1 file changed, 14 insertions(+), 11 deletions(-)

commit dbc2cf5f1fa0f9cc046170efa6afb086b90253cb
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Thu Aug 1 19:33:27 2013 -0700

    cache refactoring: Remove continue statements from
    _args_cache_generate

    Remove continue and goto statements from the large loop within
    _args_cache_generate. This simplifies the sharing of parts of
    the loop for future refactoring.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/pygi-cache.c | 126
 +++++++++++++++++++++++++++-----------------------------
 1 file changed, 61 insertions(+), 65 deletions(-)

commit 87ae14b8b4a0ed9beb22f48314247e988a2e017f
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jul 31 18:10:05 2013 -0700

    cache refactoring: Use bit field for PyGIDirection instead of enum

    This supports cleaner logic when testing the direction of
    arguments due to the majority of these tests being along the
    lines of: (direction == FROM_PYTHON || direction == BIDIRECTIONAL)
    Which is replaced with: (direction & FROM_PYTHON)

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/pygi-cache.c | 64
 ++++++++++++++++++++++++++++-----------------------------
 gi/pygi-cache.h |  6 +++---
 2 files changed, 35 insertions(+), 35 deletions(-)

commit d5925b76afa3a429092cbafd82aed40bb0cf0b18
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Jul 28 20:45:05 2013 -0700

    cache refactoring: Remove special case marshaling for instance
    arguments

    Remove duplicate code for marshaling struct and objects for
    instance arguments. Re-use individual cache marshalers for
    structs and objects with the instance argument. This required
    removal of passing GITypeInfo to the marshaler because it is
    not available for instance arguments. Instead always assume
    "is_pointer" for the instance argument by using the cache.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/pygi-argument.c        |  4 +--
 gi/pygi-cache.c           | 16 ++++-----
 gi/pygi-marshal-from-py.c | 87
 +++--------------------------------------------
 gi/pygi-marshal-from-py.h | 16 ++-------
 4 files changed, 16 insertions(+), 107 deletions(-)

commit c19bed69c669160737e12d92cc29f3e6d1b008cc
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Jul 28 16:44:01 2013 -0700

    cache refactoring: Use GPtrArray for callable arg cache

    Replace manual management of the C array holding individual
    argument caches with usage of GPtrArray. This provides storage
    of the array length along with item memory management.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/pygi-cache.c           | 62
 +++++++++++++++++++++++------------------------
 gi/pygi-cache.h           | 16 +++++++++---
 gi/pygi-invoke.c          | 16 ++++++------
 gi/pygi-marshal-cleanup.c |  8 +++---
 gi/pygi-marshal-from-py.c |  6 ++---
 gi/pygi-marshal-to-py.c   |  6 ++---
 6 files changed, 62 insertions(+), 52 deletions(-)

commit 52ea3afb0a6494423eca36a54af928d4ae5d9954
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Jul 28 15:02:51 2013 -0700

    cache refactoring: Move PyGI direction code into new function

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/pygi-cache.c | 42 +++++++++++++++++++++---------------------
 1 file changed, 21 insertions(+), 21 deletions(-)

commit 83208bf495b152e93a28a231d445f43ea827d2eb
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Fri Aug 2 15:59:25 2013 -0700

    cache refactoring: Add comments to callable cache structure

    Add comments to count fields on _PyGICallableCache.

    https://bugzilla.gnome.org/show_bug.cgi?id=640812

 gi/pygi-cache.h | 13 ++++++++++++-
 1 file changed, 12 insertions(+), 1 deletion(-)

commit 0a8d5695972601eaa9f7f463bac173d02b0380a0
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Jul 24 01:14:29 2013 -0700

    Remove support for allowing PyObjects as void pointers

    Final removal of marshaling Python object addresses as
    void pointers. This ensures we can successfully pass
    integer values as the pointer without the Python object
    leaking or crashing due to invalid memory.

    https://bugzilla.gnome.org/show_bug.cgi?id=688081

 gi/pygi-marshal-from-py.c | 20 ++++++--------------
 gi/pygi-marshal-to-py.c   | 14 ++------------
 tests/test_signal.py      |  5 +----
 3 files changed, 9 insertions(+), 30 deletions(-)

commit 1469403ee2faa699430055384b338f0cd8e672d7
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Sep 25 18:21:22 2013 -0700

    configure.ac: bump trunk to 3.11.1

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8e774e61d62c82efa3d907c1201359121878b4b5
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 23 03:57:03 2013 -0700

    configure.ac: post-release bump to 3.10.1

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 95af6279a9affff5c816db2db53207ff0f19872d
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 23 03:17:19 2013 -0700

    release 3.10.0

 NEWS         | 3 +++
 configure.ac | 4 ++--
 2 files changed, 5 insertions(+), 2 deletions(-)

commit c626be6317b610277c95461108573d1ae6f42b6d
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Mon Sep 23 12:06:11 2013 +0200

    Fix test_gi.TestProjectVersion.test_version_str()

    In this test case we only do a string comparison, not a proper
    "by version
    component" numerical one. So relax the test to also work with 3.10.

 tests/test_gi.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0a30f8d02099e582ea3ded800303e14d2e7ab212
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Mon Sep 16 10:12:33 2013 -0500

    release 3.9.92

 NEWS | 7 +++++++
 1 file changed, 7 insertions(+)

commit 506f1e35a9375be80a6a79421bf8272165fdd90a
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 16 01:23:49 2013 -0700

    Update current maintainers list in README

 README | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit ef120498e060e88a1efcb82de385a23c1fa9c7da
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Tue Sep 10 17:11:21 2013 -0700

    Fix union argument regression when marshaling from python

    Check for union members when marshaling boxed types from Python.
    This is a regression caused by stricter type checking added when
    merging code from pygi-argument.c.
    Re-add pyg_boxed_check to the same bit of code in addition to
    __gtype__ checking to avoid a double regression.

    https://bugzilla.gnome.org/show_bug.cgi?id=703873

 gi/pygi-marshal-from-py.c | 53
 ++++++++++++++++++++++++++---------------------
 1 file changed, 29 insertions(+), 24 deletions(-)

commit 59a2964141e963d2961e55d4b84a777927b4f21b
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Wed Sep 11 05:05:33 2013 -0700

    Fix GLib.Source sub-classing with initializer args

    Add variable args and keyword args to the GLib.Source.__new__
    method to support sub-classes which want to implement __init__.

    https://bugzilla.gnome.org/show_bug.cgi?id=707904

 gi/overrides/GLib.py |  2 +-
 tests/test_source.py | 11 +++++++++++
 2 files changed, 12 insertions(+), 1 deletion(-)

commit afa42ab95327da1de0cf86005974cd8ab0d46872
Author: Vratislav Podzimek <vpodzime@redhat.com>
Date:   Wed Sep 4 14:17:31 2013 +0200

    Copy __doc__ when wrapping function

    Signed-off-by: Vratislav Podzimek <vpodzime@redhat.com>
    Signed-off-by: Martin Pitt <martinpitt@gnome.org>

 gi/overrides/__init__.py | 1 +
 1 file changed, 1 insertion(+)

commit 7914a6828a533d8c579a5b422351e18b9f9afc8c
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Mon Sep 2 14:56:24 2013 +0200

    configure.ac: post-release bump to 3.9.92

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ad8b7d1a89eb2d030a504d521f7589a4c1d835fb
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Mon Sep 2 14:38:41 2013 +0200

    release 3.9.91

 NEWS | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 9df8eb79929025f12d51bc7f79b1d160156c2755
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Mon Sep 2 04:19:35 2013 -0700

    Fix GObject signal methods to work with new annotations

    Add conditional support for signal methods annotated as gpointer
    or GObject.Object. This is needed to work with newer versions of
    glib which changed annotations to GObject.Object (bug #685387).

    https://bugzilla.gnome.org/show_bug.cgi?id=707280

 gi/overrides/GObject.py | 106
 ++++++++++++++++++++++++++++++------------------
 1 file changed, 66 insertions(+), 40 deletions(-)

commit 9b6b6c7ee6a621cba99f51857eadd622a1535118
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:   Thu Aug 15 14:41:40 2013 +0800

    Fix build on C89 Compilers

    Avoid a variable declaration at the middle of the block

    https://bugzilla.gnome.org/show_bug.cgi?id=707264

 gi/pygi-closure.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 19c1a2dfb91a83a6fb0ca76b9c95c42a49a3736e
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Sep 1 20:44:26 2013 -0700

    Change boxed type checking in marshaling to use __gtype__ attribute

    Replace usage of pyg_boxed_check(pyboxed) with g_type_is_a and
    pyg_type_from_object. This has the effect of using the __gtype__
    attribute stashed on object class instead of the PyGBoxed
    internally held gtype. This fixes type descrepencies for objects
    marshaled into overridden signal class closures and passed back
    to functions taking an alias their type.

    https://bugzilla.gnome.org/show_bug.cgi?id=707140

 gi/pygi-marshal-from-py.c   |  8 +++++++-
 tests/test_overrides_gtk.py | 34 ++++++++++++++++++++++++++++++++++
 2 files changed, 41 insertions(+), 1 deletion(-)

commit dab0c09f1996e124ca98334e5aea0852904b44b5
Author: Simon Feltman <sfeltman@src.gnome.org>
Date:   Sun Sep 1 17:49:09 2013 -0700

    Use G_IS_VALUE for checking return values in closure marshaling

    Replace return_value argument NULL checks in GClosureMarshal
    implementations with G_IS_VALUE. This checks both NULL and
    validity of the value (!= G_TYPE_INVALID). This is needed
    because GLib can pass either NULL or an invalid value based
    on whether or not G_ENABLE_DEBUG is set.
    See: https://bugzilla.gnome.org/show_bug.cgi?id=707249

    https://bugzilla.gnome.org/show_bug.cgi?id=707170

 gi/_gobject/pygtype.c    | 4 ++--
 gi/pygi-signal-closure.c | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit c7b75a8c250078ac8ea28752f087ed687bd20edd
Author: Yanko Kaneti <yaneti@declera.com>
Date:   Wed Aug 21 08:53:07 2013 +0200

    Fix PEP-8 errors in propertyhelper.py

    https://bugzilla.gnome.org/show_bug.cgi?id=706319

    Signed-off-by: Martin Pitt <martinpitt@gnome.org>

 gi/_gobject/propertyhelper.py | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 6fdd58404103596accb6ab04d4de33846d853c58
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Mon Aug 19 17:13:30 2013 +0200

    configure.ac: post-release bump to 3.9.91

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6fbe2580deda215896e9583b418b8bc1aceb2f96
Author: Martin Pitt <martinpitt@gnome.org>
Date:   Mon Aug 19 17:10:52 2013 +0200

    release 3.9.90

